// ContrastDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImgProcBk.h"
#include "ContrastDlg.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "ImgProcBkDoc.h"
#include "ImgProcBkView.h"
#include <math.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CContrastDlg dialog


CContrastDlg::CContrastDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CContrastDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CContrastDlg)
	m_Slope = 0.0f;
	m_Intercept = 0.0f;
	//}}AFX_DATA_INIT

	m_pView   = NULL;
	m_pImgSrc = NULL;
	m_pImgDst = NULL;
}

CContrastDlg::CContrastDlg(CImageObj* imgOrg,CImageObj* imgRst,CWnd* pParent /*=NULL*/)
	: CDialog(CContrastDlg::IDD, pParent)
{
	m_Slope = 0.0f;
	m_Intercept = 0.0f;

	m_pImgSrc = imgOrg; 
	m_pImgDst = imgRst;

	//  view ͸ ´.
	CMainFrame *pFrame = (CMainFrame*)AfxGetMainWnd() ;
	CChildFrame *pChild = (CChildFrame*)pFrame->GetActiveFrame();
	m_pView = (CView*)pChild->GetActiveView();
}

void CContrastDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContrastDlg)
	DDX_Control(pDX, IDC_FRAME, m_Frame);
	DDX_Control(pDX, IDC_SLIDER2, m_Contrast);
	DDX_Control(pDX, IDC_SLIDER1, m_Brightness);
	DDX_Text(pDX, IDC_LUT_SLOPE, m_Slope);
	DDX_Text(pDX, IDC_LUT_INTERCEPT, m_Intercept);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CContrastDlg, CDialog)
	//{{AFX_MSG_MAP(CContrastDlg)
	ON_WM_HSCROLL()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_LUT_INVERSE, OnLutInverse)
	ON_BN_CLICKED(IDC_LUT_EQUALIZATION, OnLutEqualization)
	ON_BN_CLICKED(IDC_LUT_NORMALIZATION, OnLutNormalization)
	ON_BN_CLICKED(IDC_LUT_USER, OnLutUser)
	ON_BN_CLICKED(IDC_LUT_LINEAR, OnLutLinear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContrastDlg message handlers

BOOL CContrastDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Brightness=0;
	Contrast=-45;
	m_Slope = 1.f;
	m_Intercept = 0.0f;

	memset(&Lut, 0, sizeof(Lut));
	
	m_Brightness.SetRange(-255,255,TRUE);
	m_Contrast.SetRange(-89,0,TRUE);

	m_Brightness.SetPos(Brightness);
	m_Contrast.SetPos(Contrast);

	UpdateData(FALSE);
	
	OnLutUser();

	SetEnableManual(TRUE);

	((CButton*)GetDlgItem(IDC_LUT_USER))->SetCheck(TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CContrastDlg::SetEnableManual(BOOL mode)
{
	((CEdit*)GetDlgItem(IDC_LUT_SLOPE))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_LUT_INTERCEPT))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_SLIDER1))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_SLIDER2))->EnableWindow(mode);
}

void CContrastDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	Brightness=m_Brightness.GetPos();
	Contrast=m_Contrast.GetPos();

	double theta,y;
	theta = Contrast*3.141592/180.;
	for(int i=0;i<256;i++)
	{
		y=tan(3.141592/2.+theta)*(i-Brightness*cos(theta))+Brightness*sin(theta);
		Lut[0][i]=Lut[1][i]=Lut[2][i] = (int) min(max(y,0),255);
	}

	m_Slope = (double)((int)(tan(3.141592/2.+theta)*100))/100.0;
	
	m_Intercept = (double)((int)(tan(3.141592/2.+theta)*(-Brightness*cos(theta))+Brightness*sin(theta))*100)/100.0;
	
	UpdateData(FALSE);

	Invalidate(FALSE);

	DrawResultImage();

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CContrastDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CDC * pDC;
	CRect rcRange;
	CBrush cBrush, *pOldBrush;

	pDC=m_Frame.GetDC();
	cBrush.CreateSolidBrush(RGB(255,255,255));
	pOldBrush=pDC->SelectObject(&cBrush);

	m_Frame.GetClientRect(&rcRange);
	rcRange.DeflateRect(3,3);
	pDC->FillRect(&rcRange,&cBrush);

	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetWindowExt(257,257);
	pDC->SetViewportExt(rcRange.right-rcRange.left,	-(rcRange.bottom-rcRange.top));
	pDC->SetViewportOrg(rcRange.left,rcRange.bottom-1);
	
	for(int c=0;c<m_pImgSrc->m_ColorMode/IDM_GRAY;c++)
	{
		pDC->MoveTo(0,Lut[c][0]); 
		for(int i=0;i<256;i++) pDC->LineTo(i,Lut[c][i]);
	}

	pDC->SelectObject(pOldBrush);
	
	cBrush.DeleteObject();

	m_Frame.ReleaseDC(pDC);
	
	// Do not call CDialog::OnPaint() for painting messages
}

void CContrastDlg::OnLutLinear() 
{
	// 
	for(int j=0;j<3;j++) for(int i=0;i<256;i++) Lut[j][i]=i;
	m_Slope = 1;
	m_Intercept = 0;
	UpdateData(FALSE);

	SetEnableManual(FALSE);
	Invalidate(FALSE);

	DrawResultImage();
}

void CContrastDlg::OnLutInverse() 
{
	/// ȯ 
	for(int j=0;j<3;j++) for(int i=0;i<256;i++) Lut[j][i] = 255-i;
	m_Slope=-1;
	m_Intercept=255;
	UpdateData(FALSE);

	SetEnableManual(FALSE);
	Invalidate(FALSE);

	DrawResultImage();
}

void CContrastDlg::OnLutEqualization() 
{
	//  
	GetHidtogram();
	Equalization();

	m_Slope=0;
	m_Intercept=0;
	UpdateData(FALSE);

	SetEnableManual(FALSE);
	Invalidate(FALSE);

	DrawResultImage();
}

void CContrastDlg::OnLutNormalization() 
{
	// ȭ 
	Normalization();

	m_Slope=0;
	m_Intercept=0;
	UpdateData(FALSE);

	SetEnableManual(FALSE);
	Invalidate(FALSE);

	DrawResultImage();
}

void CContrastDlg::OnLutUser() 
{
	//  
	UpdateData(TRUE);

	for(int i=0;i<256;i++)
		Lut[0][i]=Lut[1][i]=Lut[2][i] = (long) min(max( m_Slope*i+m_Intercept,0 ),255);
	UpdateData(FALSE);

	SetEnableManual(TRUE);
	Invalidate(FALSE);

	DrawResultImage();
}

void CContrastDlg::DrawResultImage() 
{
	if(m_pImgSrc==NULL || m_pImgDst==NULL) return;

	if(m_pImgSrc->m_ColorMode==IDM_GRAY)
	{
		for(long y=0;y<m_pImgSrc->m_Height;y++) 
		{
			for(long x=0;x<m_pImgSrc->m_Width;x++) 
			{
				(*m_pImgDst)[y][x] = Lut[0][ (*m_pImgSrc)[y][x] ];
			}
		}
	}
	else if(m_pImgSrc->m_ColorMode==IDM_RGB)
	{
		for(long y=0;y<m_pImgSrc->m_Height;y++) 
		for(long x=0;x<m_pImgSrc->m_Width;x++) 
		{
			(*m_pImgDst)[y][x*3+0] = Lut[0][ (*m_pImgSrc)[y][x*3+0] ];
			(*m_pImgDst)[y][x*3+1] = Lut[1][ (*m_pImgSrc)[y][x*3+1] ];
			(*m_pImgDst)[y][x*3+2] = Lut[2][ (*m_pImgSrc)[y][x*3+2] ];
		}
	}

	m_pView->Invalidate(FALSE);
}

void CContrastDlg::GetHidtogram()
{
	//Get CHistogramDlg
	for(int j=0;j<3;j++) for(int i=0;i<256;i++) Hist[j][i]=0;

	//long Xs,Xe,Ys,Ye,Area;
	//long X,Y;
	//Xs=0;
	//Xe=m_pImgSrc->m_Width;
	//Ys=0;
	//Ye=m_pImgSrc->m_Height;

	//Area=(Xe-Xs)*(Ye-Ys);

	if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
	{
		//BYTE ** I;
		//I=m_pImgSrc->m_pGrayBuff;
		for(long y=0;y<m_pImgSrc->m_Height;y++)
			for(long x=0;x<m_pImgSrc->m_Width;x++)
				Hist[0][(*m_pImgSrc)[y][x]]++;
	}
	else 
	{
		//RGB ** I;
		//I=m_pImgSrc->m_pRgbBuff;

		for(long y=0;y<m_pImgSrc->m_Height;y++)	for(long x=0;x<m_pImgSrc->m_Width;x++)
		{
			Hist[0][(*m_pImgSrc)[y][x*3+0]]++;
			Hist[1][(*m_pImgSrc)[y][x*3+1]]++;
			Hist[2][(*m_pImgSrc)[y][x*3+2]]++;
		}
	}
}


void CContrastDlg::Equalization()
{
	int i,c;
	float lHist[3][256],cdf[3][256],sum;

	if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
	{
		for(sum=0,i=0;i<256;i++) sum=sum+Hist[0][i];
		for(long i=0;i<256;i++) lHist[0][i]=Hist[0][i]/sum;
		cdf[0][0]=lHist[0][0];
		for(i=1;i<256;i++) cdf[0][i] = cdf[0][i-1]+lHist[0][i];
		for(i=0;i<256;i++) Lut[0][i] = (long) (cdf[0][i]*255.);
	} else
	{
		for(c=0;c<3;c++)
		{
			for(sum=0,i=0;i<256;i++) sum=sum+Hist[c][i];
			for(long i=0;i<256;i++) lHist[c][i]=Hist[c][i]/sum;
			cdf[c][0]=lHist[c][0];
			for(i=1;i<256;i++) cdf[c][i] = cdf[c][i-1]+lHist[c][i];
			for(i=0;i<256;i++) Lut[c][i] = (long) (cdf[c][i]*255.);
		}
	}
}



void CContrastDlg::Normalization()
{
	//desired average, vriance
	int M0=100;
	int VAR0=100;

	float mean[3],var[3];

	//long Xs,Xe,Ys,Ye,Area;
	//long X,Y,i,Int,c;
	//Xs = 0;
	//Xe = m_pImgSrc->m_Width;
	//Ys = 0;
	//Ye = m_pImgSrc->m_Height;

	long Area=(m_pImgSrc->m_Width)*(m_pImgSrc->m_Height);
	long val;

	if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
	{
		mean[0]=0;
		for(long y=0;y<m_pImgSrc->m_Height;y++) 
			for(long x=0;x<m_pImgSrc->m_Width;x++)
				mean[0]+=(*m_pImgSrc)[y][x];
		mean[0]=mean[0] / Area;
	}
	else 
	{
		//RGB ** I;
		//I=m_pImgSrc->m_pRgbBuff;

		mean[0]=mean[1]=mean[2]=0;
		for(long y=0;y<m_pImgSrc->m_Height;y++)	for(long x=0;x<m_pImgSrc->m_Width;x++)
		{
			mean[0] += (*m_pImgSrc)[y][x*3+0];
			mean[1] += (*m_pImgSrc)[y][x*3+1];
			mean[2] += (*m_pImgSrc)[y][x*3+2];
		}
		mean[0] = mean[0]/Area;
		mean[1] = mean[1]/Area;
		mean[2] = mean[2]/Area;
	}

	if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
	{
		//BYTE ** I;
		//I=m_pImgSrc->m_pGrayBuff;
		var[0]=0;
		for(long y=0;y<m_pImgSrc->m_Height;y++)
			for(long x=0;x<m_pImgSrc->m_Width;x++)
				var[0]+= ((*m_pImgSrc)[y][x]-mean[0])*((*m_pImgSrc)[y][x]-mean[0]);
		var[0]=var[0]/Area;
	}
	else 
	{
		//RGB ** I;
		//I=m_pImgSrc->m_pRgbBuff;
		var[0]=var[1]=var[2]=0;
		for(long y=0;y<m_pImgSrc->m_Height;y++)	for(long x=0;x<m_pImgSrc->m_Width;x++)
		{
			var[0]+= ((*m_pImgSrc)[y][x*3+0]-mean[0])*((*m_pImgSrc)[y][x*3+0]-mean[0]);
			var[1]+= ((*m_pImgSrc)[y][x*3+1]-mean[1])*((*m_pImgSrc)[y][x*3+1]-mean[1]);
			var[2]+= ((*m_pImgSrc)[y][x*3+2]-mean[2])*((*m_pImgSrc)[y][x*3+2]-mean[2]);
		}
		var[0]=var[0]/Area;
		var[1]=var[1]/Area;
		var[2]=var[2]/Area;
	}
	 	
	if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
	{
		for(long i=0;i<256;i++)  
		{
			if(i> mean[0])
			{
				val = (long) (i-mean[0]);
				val = (long) (M0+sqrt( VAR0 *val*val / var[0]));
			} else 
			{
				val = (long) (i-mean[0]);
				val = (long) (M0-sqrt( VAR0 *val*val / var[0]));
			}
			Lut[0][i]=max(min(val,255),0);
		}
	}
	else
	{
		for(long c=0;c<3;c++)
		for(long i=0;i<256;i++)  
		{
			if(i> mean[c])
			{
				val = (long) (i-mean[c]);
				val = (long) (M0+sqrt( VAR0 *val*val / var[c]));
			} else 
			{
				val = (long) (i-mean[c]);
				val = (long) (M0-sqrt( VAR0 *val*val / var[c]));
			}
			Lut[c][i]=max(min(val,255),0);
		}
	}
}
