// HistogramDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImgProcBk.h"
#include "HistogramDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHistogramDlg dialog


CHistogramDlg::CHistogramDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHistogramDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHistogramDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CHistogramDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHistogramDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHistogramDlg, CDialog)
	//{{AFX_MSG_MAP(CHistogramDlg)
	ON_BN_CLICKED(IDC_GRAY, OnGray)
	ON_BN_CLICKED(IDC_GREEN, OnGreen)
	ON_BN_CLICKED(IDC_RED, OnRed)
	ON_BN_CLICKED(IDC_BLUE, OnBlue)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHistogramDlg message handlers

void CHistogramDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages
	DrawHistogram();
	DrawColorBar();
}

BOOL CHistogramDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	if(m_pImgSrc!=NULL) 
	{
		if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
		{
			((CButton*)GetDlgItem(IDC_RED))->EnableWindow(FALSE);
			((CButton*)GetDlgItem(IDC_GREEN))->EnableWindow(FALSE);
			((CButton*)GetDlgItem(IDC_BLUE))->EnableWindow(FALSE);
			m_Color = 0;
			((CButton*)GetDlgItem(IDC_GRAY))->SetCheck(BST_CHECKED);
		}
		else 
		{
			((CButton*)GetDlgItem(IDC_GRAY))->EnableWindow(FALSE);
			m_Color = 1;
			((CButton*)GetDlgItem(IDC_RED))->SetCheck(BST_CHECKED);
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

// ׷  ٸ ׸
void CHistogramDlg::DrawColorBar()
{
	// ȭ  ϱ
	CRect rc;
	((CWnd*)GetDlgItem(IDC_COLORBAR))->GetWindowRect(&rc);
	ScreenToClient(&rc);
	rc.DeflateRect(1,1);

	CDC* pDC = GetDC();
	CBrush brush(RGB(255,255,255));
	pDC->FillRect(&rc,&brush);

	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetWindowExt(256,100);
	pDC->SetViewportExt(rc.right-rc.left, rc.bottom-rc.top);
	pDC->SetViewportOrg(rc.left,rc.top);

	for(int i=0;i<256;i++) 
	{
		CPen pen(PS_SOLID,2,RGB( (m_Color==0||m_Color==1)?i:0, (m_Color==0||m_Color==2)?i:0, (m_Color==0||m_Color==3)?i:0 ) );
		CPen *pOldPen = pDC->SelectObject(&pen);
		pDC->MoveTo( i, 2 );
		pDC->LineTo( i, 98 );
		pDC->SelectObject(pOldPen);
	}

	ReleaseDC(pDC);
}


// ׷ ׷ ׸
void CHistogramDlg::DrawHistogram()
{
	if(m_pImgSrc==NULL) return;

	int Hist[256];
	int maxH = 0;

	// ׷ ϱ
	for(int i=0;i<256;i++) Hist[i] = 0;

	for(long y=0;y<m_pImgSrc->m_Height;y++) 
	{
		for(long x=0;x<m_pImgSrc->m_Width;x++)
		{
			Hist[ (*m_pImgSrc)[y][ (m_Color==0)?x:x*3+m_Color-1 ] ]++;
		}
	}
	for(i=0;i<256;i++) 
	{
		if(Hist[i] > maxH) maxH = Hist[i];
	}

	// ȭ  ϱ
	CRect rc;
	((CWnd*)GetDlgItem(IDC_FRAME))->GetClientRect(rc);
//	rc.DeflateRect(2,2);

	CDC* pDC = ((CWnd*)GetDlgItem(IDC_FRAME))->GetDC();
	CBrush brush(RGB(255,255,255));
	pDC->FillRect(&rc,&brush);

	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetWindowExt(256+1,maxH+1);
	pDC->SetViewportExt(rc.right-rc.left, -rc.bottom+rc.top+2);
	pDC->SetViewportOrg(rc.left+1,rc.bottom-1);

	// ׷ ׸
	COLORREF color[4] = { RGB(0,0,0), RGB(255,0,0), RGB(0,180,0), RGB(0,0,255) };
	CPen pen(PS_SOLID,1,color[m_Color]);
	CPen *pOldPen = pDC->SelectObject(&pen);

	for(i=0;i<256;i++) 
	{
		pDC->MoveTo(i,0);
		pDC->LineTo(i,(int)Hist[i]);
	}
	pDC->SelectObject(pOldPen);

	((CWnd*)GetDlgItem(IDC_FRAME))->ReleaseDC(pDC);
}

void CHistogramDlg::OnGray()
{
	m_Color = 0;
	DrawHistogram();
	DrawColorBar();
}

void CHistogramDlg::OnRed()
{
	m_Color = 1;
	DrawHistogram();
	DrawColorBar();
}

void CHistogramDlg::OnGreen()
{
	m_Color = 2;
	DrawHistogram();
	DrawColorBar();
}

void CHistogramDlg::OnBlue()
{
	m_Color = 3;
	DrawHistogram();
	DrawColorBar();
}

