// ---------------------------------------------------
//  ̹  а  Ŭ̴.
//  Modified by H.C.H
// ---------------------------------------------------

#include "StdAfx.h"
#include "ImageObj.h"


CImageObj::CImageObj(void)
{
	m_pBuff = NULL;
	m_WidthByte = 0;
	m_ColorMode = 0;
	m_Height = 0;
	m_Width = 0;
	m_pCPLX2D = NULL;

	m_Flag = TRUE;	// ũ⿡ °  ũ  ʿϴ.
}

CImageObj::~CImageObj(void)
{
	FreeBuff();
}

CImageObj::CImageObj(CImageObj& imgObj) 
{ 
	m_pBuff = NULL;
	m_WidthByte = 0;
	m_ColorMode = 0;
	m_Height = 0;
	m_Width = 0;
	m_pCPLX2D = NULL;

	m_Flag = TRUE;	// ũ⿡ °  ũ  ʿϴ.

	AllocBuff(imgObj);
}


BOOL CImageObj::Load(LPCTSTR lpszPathName)
{
	// ̸ 
	m_Name = CString(lpszPathName);
	m_Name = m_Name.Right(m_Name.GetLength() - m_Name.ReverseFind('\\') - 1);

	CFile file;
	CFileException fe;
	BITMAPFILEHEADER bmfHeader;
	BITMAPINFOHEADER bmiHeader;

	// б   
	if(!file.Open(lpszPathName, CFile::modeRead | CFile::typeBinary, &fe)) return FALSE;

	//   б  
	if(file.Read((LPSTR)&bmfHeader, sizeof(bmfHeader))!=sizeof(bmfHeader))	return FALSE;

	// BMP  Ÿ "BM" Ŀ ִ Ȯ
	if (bmfHeader.bfType != 0x4d42)	return FALSE;

	// BMP ̹  ´.
	if(file.Read((LPSTR)&bmiHeader, sizeof(bmiHeader))!=sizeof(bmiHeader))	return FALSE;

	//  ׷, Į ˻Ѵ.
	// Ʈʿ 2Į, 16Į, 256Į, 65536Į(16Ʈ), 1600Į(24Ʈ)
	
	
	if(bmiHeader.biBitCount!=8 && bmiHeader.biBitCount!=24) 
	{
		AfxMessageBox("2Į(1bit), 16Į(4bit)    ϴ.");
		return FALSE;
	}
	
	
	if(bmiHeader.biBitCount<=8) bmiHeader.biClrUsed = 1<<bmiHeader.biBitCount;

	m_Width = bmiHeader.biWidth;
	m_Height = abs(bmiHeader.biHeight);
	m_WidthByte = WIDTHBYTES(bmiHeader.biWidth*bmiHeader.biBitCount);
	m_ColorMode = bmiHeader.biBitCount;

	// ȷƮ о
	if(bmiHeader.biClrUsed!=0) {
		UINT pal_size=bmiHeader.biClrUsed*sizeof(RGBQUAD);
		BYTE * pPalBuf=new BYTE[pal_size];
		if(file.Read(pPalBuf,pal_size) != pal_size )	return FALSE;
		delete pPalBuf;
	}

	// ޸ Ҵ
	AllocBuff();

	BYTE *pBuf = new BYTE[m_WidthByte];
	for(long y=0;y<m_Height;y++)
	{
		if (file.Read(pBuf,m_WidthByte) != m_WidthByte) 
		{
			FreeBuff();
			delete [] pBuf;
			return NULL;
		}
		//  ٷ о ´.
		for(unsigned long x=0;x<m_WidthByte;x++) m_pBuff[m_Height-1-y][x] = pBuf[x];
	}
	delete [] pBuf;

	return TRUE;
}



void CImageObj::Empty()
{
	if(m_pBuff==NULL) return;

	for(long y=0;y<m_Height;y++)
	{
		memset(m_pBuff[y], 0, m_WidthByte);
	}

}

void CImageObj::ReallocBuff(int mode)
{
	FreeBuff();

	// Ʈ 尡 ٸΰ ˻Ѵ.
	if(mode != m_ColorMode) 
	{
		m_ColorMode = mode;
		m_WidthByte = WIDTHBYTES(m_Width*m_ColorMode);
	}

	AllocBuff();
}


void CImageObj::AllocBuff(const CImageObj &imgSrc)
{
	AllocBuff(imgSrc.m_Width,imgSrc.m_Height,imgSrc.m_ColorMode);
}

void CImageObj::AllocBuff(int xsize,int ysize,int color)
{
	FreeBuff();

	m_Width = xsize;
	m_Height = ysize;
	m_ColorMode = color;
	m_WidthByte = WIDTHBYTES(m_Width*m_ColorMode);
	
	m_Flag=TRUE;	// ũ⺯ȯ

	m_pBuff = new BYTE *[m_Height];
	if(m_pBuff==NULL) return;
	
	for(long y=0;y<m_Height;y++)
	{
		m_pBuff[y]= new BYTE [m_WidthByte];
		if(m_pBuff[y]==NULL) { FreeBuff(); return; }
		memset(m_pBuff[y], 0, m_WidthByte);
	}
}

void CImageObj::AllocBuff()
{
	AllocBuff(m_Width,m_Height,m_ColorMode);
}

void CImageObj::AllocComplex2D()
{
	if(m_pCPLX2D==NULL)
	{
		m_pCPLX2D = new CComplex *[m_Height];
 		for(int y=0; y<m_Height; y++) m_pCPLX2D[y] = new CComplex [m_Width];
	}
}

void CImageObj::FreeBuff()
{
	if(m_pBuff!=NULL) 
	{
		for(long y=0;y<m_Height;y++) delete m_pBuff[y];
		delete [] m_pBuff;
		m_pBuff = NULL;
	}
	if(m_pCPLX2D!=NULL)
	{
	 	for(int y=0; y<m_Height; y++) delete m_pCPLX2D[y];
		delete m_pCPLX2D;
		m_pCPLX2D = NULL;
	}
}


BOOL CImageObj::Save(LPCTSTR filename)
{
	CFile file;
	CFileException fe;
	BITMAPFILEHEADER bmfHdr;
	LPBITMAPINFOHEADER pSrc;
	SIZE_T ulDIBSize;

	//    
	if (!file.Open(filename, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite, &fe)) return FALSE;

	HGLOBAL hSrc = MakeDIBData();

	// ޸ 
	pSrc = (LPBITMAPINFOHEADER)::GlobalLock(hSrc);
	if (pSrc == NULL) return FALSE;
	ulDIBSize=GlobalSize(hSrc);

	// Ʈ    
	bmfHdr.bfType = 0x4d42;  // "BM"
	ulDIBSize=sizeof(BITMAPINFOHEADER)+pSrc->biClrUsed*sizeof(RGBQUAD)+m_WidthByte*m_Height;
	bmfHdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER)+ulDIBSize);
	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;
	bmfHdr.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+pSrc->biClrUsed*sizeof(RGBQUAD);

	TRY
	{
		// Ʈ   Ͽ 
		file.Write((LPSTR)&bmfHdr, sizeof(BITMAPFILEHEADER));
		//  ͸ Ͽ 
		file.Write((LPSTR)pSrc,(UINT)ulDIBSize);
	}
	CATCH (CFileException, e)
	{
		::GlobalUnlock((HGLOBAL) hSrc);
		THROW_LAST();
	}
	END_CATCH

	file.Close();

	// ޸ Ǯ
	::GlobalUnlock((HGLOBAL) hSrc);
	::GlobalFree(hSrc);

	return TRUE;
}

HGLOBAL CImageObj::MakeDIBData()
{
	int nPalette = (m_ColorMode==IDM_GRAY)? 256:0;
	long MemSize = sizeof(BITMAPINFOHEADER)+nPalette*sizeof(RGBQUAD)+m_WidthByte*m_Height;
	
	HGLOBAL hSrc = GlobalAlloc(GMEM_MOVEABLE,MemSize);
	LPBITMAPINFOHEADER pSrc = (LPBITMAPINFOHEADER)GlobalLock(hSrc);
	pSrc->biSize			= sizeof(BITMAPINFOHEADER); 
	pSrc->biWidth			= m_Width;; 
	pSrc->biHeight			= m_Height;
	pSrc->biPlanes			= 1; 
	pSrc->biBitCount		= m_ColorMode;
	pSrc->biCompression		= BI_RGB;
	pSrc->biSizeImage		= m_WidthByte*m_Height;
	pSrc->biXPelsPerMeter	= 0;
	pSrc->biYPelsPerMeter	= 0; 
	pSrc->biClrUsed			= nPalette;
	pSrc->biClrImportant	= 0; 

	
	if(m_ColorMode==IDM_GRAY) 
	{
		RGBQUAD * pRgb = (RGBQUAD *)((LPSTR)pSrc+pSrc->biSize);

		for(unsigned int i=0;i<pSrc->biClrUsed;i++) 
		{
			pRgb[i].rgbRed	 = (BYTE)i;
			pRgb[i].rgbGreen = (BYTE)i;
			pRgb[i].rgbBlue  = (BYTE)i;
			pRgb[i].rgbReserved = 0;
		}
	}
	

	BYTE *q = (BYTE *) pSrc+pSrc->biSize+pSrc->biClrUsed*sizeof(RGBQUAD);

	for(long y=0;y<m_Height;y++)
	{
		for(unsigned long x=0;x<m_WidthByte;x++) 
		{
			//  ٷ Ѵ.
			*(q+y*m_WidthByte+x)=m_pBuff[m_Height-1-y][x];
		}
	}

	GlobalUnlock(hSrc);
	return hSrc;
}


void CImageObj::SaveAsText()
{
	CFile fp;
	CString str;
	str = m_Name.Left(m_Name.Find('.')) + ".txt";

	fp.Open(str, CFile::modeWrite | CFile::shareExclusive | CFile::modeCreate);

	if(m_ColorMode == IDM_GRAY) {	
		for(long y=0;y<m_Height;y++)
		{
			for(unsigned long x=0;x<m_WidthByte;x++) 
			{
				str.Format(_T("%d, %d, %d\r\n"),x,y,(int)m_pBuff[y][x]);
				fp.Write(str,str.GetLength());
			}
		}
		fp.Close();
	}
}

void CImageObj::Copy(const CImageObj &imgSrc)
{
	int width;
	int height;

	width=min(m_WidthByte,imgSrc.m_WidthByte);
	height=min(m_Height,imgSrc.m_Height);

	if(m_pBuff!=NULL && imgSrc.m_pBuff!=NULL) 
	{
		for(long y=0;y<height;y++)
		{
			memcpy(m_pBuff[y], imgSrc.m_pBuff[y], width);
		}
	}
}

CImageObj& CImageObj::operator=(const CImageObj &imgObj)
{
	AllocBuff(imgObj);
	Copy(imgObj);

	return *this;
}

CImageObj& CImageObj::operator+(const CImageObj &imgObj)
{
	if(m_Width==imgObj.m_Width && m_Height==imgObj.m_Height)
	{
		if(m_pBuff!=NULL && imgObj.m_pBuff!=NULL) 
		{
			for(long y=0;y<m_Height;y++)
			{
				for(unsigned long x=0;x<m_WidthByte;x++)
				{
					m_pBuff[y][x] = min(m_pBuff[y][x]+imgObj.m_pBuff[y][x],255);
				}
			}
		}
	}

	return *this;
}

CImageObj& CImageObj::operator-(const CImageObj &imgObj)
{
	if(m_Width==imgObj.m_Width && m_Height==imgObj.m_Height)
	{
		if(m_pBuff!=NULL && imgObj.m_pBuff!=NULL) 
		{
			for(long y=0;y<m_Height;y++)
			{
				for(unsigned long x=0;x<m_WidthByte;x++)
				{
					m_pBuff[y][x] = max(m_pBuff[y][x]-imgObj.m_pBuff[y][x],0);
				}
			}
		}
	}

	return *this;
}

