// -----------------------------------------------------
//  ȭó  Ŭ̴.
//
//  Last Modification date: 2008/11/15
//  Programed by H.C.H
// -----------------------------------------------------


#pragma once

#include "ImageObj.h"
#include "UserBinDlg.h"


#define RIGHT 0
#define LEFT  1
#define UP    2
#define DOWN  3


//#define MAXPL 12



struct _pixlist {
	int N, n;
	int **list;
};
typedef struct _pixlist * PIXLIST;


struct _houghline {
	float rho;
	float ang;
	int color;
};
typedef struct _houghline HOUGHLINE, *PHOUGHLINE;

#define MAX_HOUGH 100


class CImageProc
{
public:
	CImageProc(void);
	~CImageProc(void);

public:

public:
	// Į/׷ ȯ
	BOOL CvtRgbToGray(CImageObj &imgSrc, CImageObj &imgGray, DWORD cvtMode = 0);
	
	// Ȱȭ
	BOOL CvHistoEqual(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtEdgeEg(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtEndinEq(CImageObj &imgSrc,CImageObj &imgDst);
	
	// Ϻȯ
	BOOL CvtInverse(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtGamma(CImageObj &imgSrc,CImageObj &imgDst,float gamma=2.2f);
	BOOL CvtStretching(CImageObj &imgSrc,CImageObj &imgDst,int stretch_val=40);
	BOOL CvtCompress(CImageObj &imgSrc,CImageObj &imgDst,int compress_val=40);
	BOOL CvtPosterizing(CImageObj &imgSrc,CImageObj &imgDst,int poster_val=32);
	BOOL CvtThreshold(CImageObj &imgSrc,CImageObj &imgDst,int thres_val=128);
	BOOL CvtRangeThreshold(CImageObj &imgSrc,CImageObj &imgDst,int start=50,int end=205,int thresh=128);
	BOOL CvtBitClipping(CImageObj &imgSrc,CImageObj &imgDst,int bitclip_val=64);
	BOOL CvEqualBright(CImageObj &imgSrc,CImageObj &imgDst,int start=50,int end=55);
	BOOL CvtRangeEmphasis(CImageObj &imgSrc,CImageObj &imgDst,int start=120,int end=192);
	BOOL CvtSolarising(CImageObj &imgSrc,CImageObj &imgDst,int solar_val);
	BOOL CvtParabola(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtParabola2(CImageObj &imgSrc,CImageObj &imgDst);
	
	// ȭ
	int  CvtPtileBin(CImageObj &imgSrc,CImageObj &imgDst);
	int  CvtModeBin(CImageObj &imgSrc,CImageObj &imgDst);
	int  CvtAvrBin(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtIterativeBin(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtAdaptiveBin(CImageObj &imgSrc,CImageObj &imgDst,int nBlock=5);
	BOOL CvtBlockBin(CImageObj &imgSrc,CImageObj &imgDst);
	int  CvtOtsuBin(CImageObj &imgSrc,CImageObj &imgDst);
	int  OptimalThreshold(long method, CImageObj &imgSrc);
	int  CvtEntropyBin(CImageObj &imgSrc,CImageObj &imgDst);
	
	// ȯ
	BOOL CvtRszScale(CImageObj &imgSrc,CImageObj &imgDst,int width,int height);
	BOOL CvtRszNearest(CImageObj &imgSrc,CImageObj &imgDst,int width,int height);
	BOOL CvtRszBilinear(CImageObj &imgSrc,CImageObj &imgDst,int width,int height);
	BOOL CvtRszBspline(CImageObj &imgSrc,CImageObj &imgDst,int width,int height);

	BOOL CvtAffine(CImageObj &imgSrc,CImageObj &imgDst,
		double u0,double v0,double u1,double v1,double u2,double v2,
		double x0,double y0,double x1,double y1,double x2,double y2);
	BOOL CvtPerspective(CImageObj &imgSrc,CImageObj &imgDst,
		double x0,double y0,double x1,double y1,double x2,double y2,double x3,double y3);
	BOOL CvtBilinTransform1(CImageObj &imgSrc,CImageObj &imgDst,
		double u0,double v0,double u1,double v1,double u2,double v2,double u3,double v3);
	BOOL CvtBilinTransform2(CImageObj &imgSrc,CImageObj &imgDst,
		double x0,double y0,double x1,double y1,double x2,double y2,double x3,double y3);
	BOOL CvtMirror(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtFlip(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtRotate(CImageObj &imgSrc,CImageObj &imgDst,int deg);
	BOOL CvtShear(CImageObj &imgSrc,CImageObj &imgDst,int angle1,int angle2);
	BOOL CvtTranslate(CImageObj &imgSrc,CImageObj &imgDst,int tx,int ty);

	BOOL CvtFFT(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtIFFT(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL IsPowerOf2(CImageObj &imgSrc);
	BOOL CvtZeroPadding(CImageObj &imgSrc,CImageObj &imgDst);
	int  Log2N(int N);
	void FFT1D(CComplex *f, int N, int log2N);
	void IFFT1D(CComplex *f, int N, int log2N);
	void Shuffle(CComplex *f,int N, int log2N);
	void Butterfly(CComplex *f, int N, int log2N, int dir=0);
	void FFT2D(CImageObj &imgSrc,CImageObj &imgDst);
	void IFFT2D(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtLpf(CImageObj &imgSrc,CImageObj &imgDst,double D0=32.0,double N=4.0,int mode=0);
	BOOL CvtHpf(CImageObj &imgSrc,CImageObj &imgDst,double D0=32.0,double N=4.0,int mode=0);
	BOOL CvtBpf(CImageObj &imgSrc,CImageObj &imgDst,double D1=32.0,double D2=20.0,double N=4.0,int mode=0);
	BOOL CvtBsf(CImageObj &imgSrc,CImageObj &imgDst,double D1=32.0,double D2=20.0,double N=4.0,int mode=0);

	void DCT1D(double *f, int N);		// 1 DCT ȯ 
	void IDCT1D(double *f, int N);		// 1 DCT ȯ 
	BOOL CvtDCT(CImageObj &imgSrc,CImageObj &imgDst);	// 2 DCT ȯ 
	BOOL CvtIDCT(CImageObj &imgSrc,CImageObj &imgDst);	// 2 DCT ȯ 


	
	// ()
	BOOL CvtEdgeSobel(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtEdgePrewitte(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtEdgeRobert(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtEdgeLaplacian(CImageObj &imgSrc,CImageObj &imgDst,int mode);
	BOOL CvtEdgeLoG(CImageObj &imgSrc,CImageObj &imgDst,int mode=3);
	BOOL CvtGaussianSmoothing3(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtGaussianSmoothing5(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtEdgeZeroCross(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtEdgeCanny(CImageObj &imgSrc,CImageObj &imgDst,int threshold=100,int mode=0);
	// ȭ
	BOOL CvtThinningZhangSuen(CImageObj &imgSrc,CImageObj &imgDst);
	int  t1a(CImageObj &imgSrc,int i,int j,int *a,int *b,int nn,int mm);
	BOOL CvtThinningStentiford(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtThinningStentiford_LOM(CImageObj &imgSrc,CImageObj &imgDst);
	int  Yokoi(CImageObj &imgSrc, int r, int c);
	int  nays8(CImageObj &imgSrc, int r, int c);
	void pre_smooth (CImageObj &imgSrc,CImageObj &imgDst);
	void aae (CImageObj &imgSrc,CImageObj &imgDst);
	void match_du (CImageObj &imgSrc,CImageObj &imgDst, int r, int c, int k);

	BOOL CvtHoughTransform(CImageObj &imgSrc,CImageObj &imgHough,CImageObj &imgDst);
	BOOL CvtHoughImage(CImageObj &imgSrc,CImageObj &imgDst,PHOUGHLINE pline,int &nline);
	BOOL CvtInvHoughImage(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL DrawHoughLine(CImageObj &imgSrc,float &rho,float &ang,int color);
	BOOL CvtHoughTransform2(CImageObj &imgSrc,CImageObj &imgHough,CImageObj &imgDst);
	void CosSin(double *COS, double *SIN, int Len);
	BOOL CvtHoughImage_LOM(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtInvHoughImage_LOM(CImageObj &imgSrc,CImageObj &imgHough,CImageObj &imgDst);
	BOOL CvtThinningGray(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtThinningSlowGray(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtThinning(CImageObj &imgSrc,CImageObj &imgDst);

	// 輱
	BOOL CvtContourTracing(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL GetContourTracing(CImageObj &imgSrc,CImageObj &imgDst,int I, int J, PIXLIST c, int pmax, int *nn,int label);
	BOOL BlobColor(CImageObj &imgSrc,CImageObj &imgDst,POINT *Bd,long Max,BYTE color);
	BOOL CvtBlobColoring(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtChainCode_BlobColoring(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC=NULL);
	BOOL CvtBorderFollowing(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC=NULL);
	BOOL CvtRasterScan(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC=NULL);
	BOOL CvtGrassFire(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC=NULL);
	BOOL CvtAmeba(CImageObj &imgSrc,CImageObj &imgDst,WORD x,WORD y,CDC *pDC=NULL);
	
	// 
	BOOL CvtAddSaltPepperNoise(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtAddGaussianNoise(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtMeanFilter(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtMedianFilter(CImageObj &imgSrc,CImageObj &imgDst);
	
	// 
	BOOL CvtOpening(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtClosing(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtErosion(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtDilation(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtHitMissTransform(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtGDilation(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtGErosion(CImageObj &imgSrc,CImageObj &imgDst);
	BOOL CvtBoundary(CImageObj &imgSrc,CImageObj &imgDst);

	// Ÿ
	void ApplyLUT(CImageObj &imgSrc,CImageObj &imgDst,int (&LUT)[256]);
	void CalcHistogram(CImageObj &imgSrc,int (&Histo)[256]);
	void ApplyBIN(CImageObj &imgSrc,CImageObj &imgDst,int Threshold,int Limit=-1);
	void ApplyByte(CImageObj &imgDst, BYTE bTemp[][300]);
	void ApplyMask(CImageObj &imgDst, BYTE mask);
	BYTE** BitMask(CImageObj &imgDst, BYTE mask);
	BYTE** MakeTempBuffer(CImageObj& imgSrc);
	void DeleteTempBuffer(BYTE **pTempBuf);
	void ClearData(CImageObj &imgSrc,BYTE** pTempBuf ,unsigned char num=NULL);
	int  Median(int *buf, int len);
	void ApplySglMask(CImageObj &imgSrc,CImageObj &imgDst,int *mask,int len=3,float scale=0.0,float offset=0.0);
	void ApplyDblMask(CImageObj &imgSrc,CImageObj &imgDst,int *mask1,int *mask2,int len=3,float scale=0.0,float offset=0.0);

	void DelayTime(DWORD t);

};
