// -----------------------------------------------------
//  ȭó  Ŭ̴.
//
//  Last Modification date: 2008/11/15
//  Programed by H.C.H
// -----------------------------------------------------

#include "StdAfx.h"
#include "ImageProc.h"
#include "MainFrm.h"
#include "ImageObj.h"
#include "resource.h"
#include "math.h"

//CComplex CComplex_m_pFFT2D[256*256];

#define PI	3.1415926535897932384626433832795f



CImageProc::CImageProc(void)
{
}

CImageProc::~CImageProc(void)
{
}


////////////////////////////////////////////////////////////////////////////////////////////////////

/**************************************************************
* Functions :	 Լ
*
* History : 2005. 06. 20
* Modified: 2008. 07. 2,  H.C.H
*****************************************************************/


// Į  ׷  ȯѴ.
BOOL CImageProc::CvtRgbToGray(CImageObj &imgRgb,CImageObj &imgGray, DWORD cvtMode)
{
	int x,y;
	if(imgRgb.m_ColorMode==IDM_GRAY) return FALSE;

	// Į󿵻 ۸ ׷̿ ۷ ٲ۴.
	if(imgGray.m_ColorMode == IDM_RGB) imgGray.ReallocBuff(IDM_GRAY);

	switch(cvtMode)
	{
	case ID_RGB2GRAY_BLUE:
		{
			for(y=0;y<imgGray.m_Height;y++) 
				for(x=0;x<imgGray.m_Width;x++) 
					imgGray[y][x] = imgRgb[y][x*3];
		}
		break;
	case ID_RGB2GRAY_GREEN:
		{
			for(y=0;y<imgGray.m_Height;y++) 
				for(x=0;x<imgGray.m_Width;x++) 
					imgGray[y][x] = imgRgb[y][x*3+1];
		}
		break;
	case ID_RGB2GRAY_RED:
		{
			for(y=0;y<imgGray.m_Height;y++) 
				for(x=0;x<imgGray.m_Width;x++) 
					imgGray[y][x] = imgRgb[y][x*3+2];
		}
		break;
	default:
		{
			for(y=0;y<imgGray.m_Height;y++) 
				for(x=0;x<imgGray.m_Width;x++) 
					imgGray[y][x]  = ( imgRgb[y][x*3+0] + imgRgb[y][x*3+1] + imgRgb[y][x*3+2] ) / 3;
		}
		break;
	}

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////////////////////////

/**************************************************************
* Procedure Name :	Ȱȭ
*
* Author : âȣ,ڼ,,,ȯ
*
* History : 2005. 06. 20
* Modified: 2008. 02. 26
*****************************************************************/


// ׷  Ȱȭ
BOOL CImageProc::CvHistoEqual(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,i;
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	//int k, Ax, Ay;
	int Hist[256], LUT[256];
	double cdf[256];

	//׷ ʱȭ.
	for(i=0;i<256;i++) Hist[i]=0;	

	// ׷  л .
	for(y=0; y < imgSrc.m_Height; y++)
		for(x=0; x < imgSrc.m_Width; x++)	
			Hist[imgSrc[y][x]]++;

	//׷  .
	cdf[0]=Hist[0];
	for(i=1;i<256;i++) cdf[i]=cdf[i-1]+Hist[i];		

	//Ȱȭ.	Ȯ е.f=N^2/(qk-q0)	
	for(i=0;i<256;i++) LUT[i] = (int)( (cdf[i]-cdf[0])*255.0 / (cdf[255]-cdf[0]) );

	for(y=0; y < imgSrc.m_Height; y++)
	{
		for(x=0; x < imgSrc.m_Width; x++)	
		{
			//Ax=x*15;	
			//Ay=y*15;
			//for(y=0;y<15;y++) for(x=0;x<15;x++)	
			//	imgDst[y*15+y][x*15+x] = (unsigned char)LUT[imgSrc[y*15+y][x*15+x]];
			imgDst[y][x] = (unsigned char)LUT[imgSrc[y][x]];
		}
	}

	return TRUE;
}



/**************************************************************
*  Procedure Name :	
* 	EdgePresvSmoothing()
*
*  Description
*	  Ȱȭ.
*  Author:  ڼ,  Modified by âȣ
***************************************************************/


static int Smo_Dir3[12][7][2] = 
{
	{{-2,2},{-1,1},{0,0},{1,-1},{2,-2},{-1,-1},{1,1}},
	{{-2,-2},{-1,-1},{0,0},{1,1},{2,2},{-1,1},{1,-1}},
	{{-2,0},{-1,0},{0,0},{1,0},{2,0},{0,1},{0,-1}},
	{{0,2},{0,1},{0,0},{0,-1},{0,-2},{-1,0},{1,0}},
	{{-1,1},{0,1},{1,1},{0,0},{-1,-1},{0,-1},{1,-1}},
	{{-1,1},{1,1},{-1,0},{0,0},{1,0},{-1,-1},{1,-1}},
	{{-1,1},{0,1},{-1,0},{0,0},{1,0},{0,-1},{1,-1}},
	{{0,1},{1,1},{-1,0},{0,0},{1,0},{-1,-1},{0,-1}},
	{{0,0},{-1,-1},{0,-1},{1,-1},{-1,-2},{0,-2},{1,-2}},
	{{-2,1},{-1,1},{-2,0},{-1,0},{0,0},{-2,-1},{-1,-1}},
	{{-1,2},{0,2},{1,2},{-1,1},{0,1},{1,1},{0,0}},
	{{1,1},{2,1},{0,0},{1,0},{2,0},{1,-1},{2,-1}}
};


//  Ȱȭ
BOOL CImageProc::CvtEdgeEg(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int min;
	int minIndex;
	int x,y,k,l;
	double sum[12] = {0,};
	double aver[12] = {0.0f, };
	double variance[12] = {0.0f, };

	for(y=2; y < imgSrc.m_Height-2; y++)
	{
		for(x=2; x < imgSrc.m_Width-2; x++)	
		{
			for(k=0; k<12; k++)
			{
				sum[k] = 0.0f;
				for(l=0; l<7; l++)
				{
					sum[k] += imgSrc[ y+Smo_Dir3[k][l][1] ][ x+Smo_Dir3[k][l][0] ];
				}
				aver[k] = (sum[k]/7.0f);
			}

			for(k=0; k<12; k++)
			{
				variance[k] = 0.0f;
				for(l=0; l<7; l++)
				{
					variance[k] += pow((double)(aver[k]-imgSrc[ y+Smo_Dir3[k][l][1] ][ x+Smo_Dir3[k][l][0] ]), (double)2.0f);
				}
				variance[k] = (variance[k]/7.0f);
			}

			min = (int)variance[0];
			minIndex = 0;
			for(k=1; k<12; k++)
			{
				if(min > variance[k])
				{
					min = (int)variance[k];
					minIndex = k;
				}
			}
			imgDst[y][x] = (unsigned char)aver[minIndex];
		}
	}

	return TRUE;
}


// /Į  ׷ ϱ
void CImageProc::CalcHistogram(CImageObj &imgSrc,int (&Histo)[256])
{
	int i,x,y;

	for(i=0; i<256; i++) Histo[i]=0;

	if(imgSrc.m_ColorMode==IDM_GRAY)
	{
		for(y=0; y < imgSrc.m_Height; y++)
		{
			for(x=0; x < imgSrc.m_Width; x++)	
			{
				Histo[(int)imgSrc[y][x]]++;
			}
		}
	}
	else 
	{
		for(y=0; y < imgSrc.m_Height; y++)
		{
			for(x=0; x < imgSrc.m_Width; x++)	
			{
				Histo[(int)imgSrc[y][x*3+0]]++;
				Histo[(int)imgSrc[y][x*3+1]]++;
				Histo[(int)imgSrc[y][x*3+2]]++;
			}
		}
	}
}


//  Ž Ȱȭ
BOOL CImageProc::CvtEndinEq(CImageObj &imgSrc,CImageObj &imgDst)
{
	int i;
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;


	int histogram[256];
	int LUT[256];
	int lowthresh,highthresh;
	float scale_factor;
	//scaling factor for contrast stretch
	//intialalize thresholds
	lowthresh=0;highthresh=255;//׷Ǻ󵵼

	// ׷ 
	CalcHistogram(imgSrc,histogram);

	//׷߰峷.
	for(i=0; i<256; i++) 
	{
		if (histogram[i]) 
		{
			lowthresh=i;
			break;
		}
	}

	//׷߰.
	for(i=255; i>=0; i--) 
	{
		if(histogram[i]) 
		{
			highthresh=i;
			break;
		}
	}

	//̺.
	for(i=0; i<lowthresh; i++) LUT[i]=0;
	for(i=255; i>highthresh; i--) LUT[i]=255;

	//ƮĪǰҼִfactor.
	scale_factor=(float)(255.0/(highthresh-lowthresh));
	for(i=lowthresh; i<=highthresh; i++) 
		LUT[i]=(unsigned char)((i-lowthresh)*scale_factor);
	
	//̺°Ҵ.
	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////////////////////////

/**************************************************************
* Functions :	Ϻȯ Լ
*
* History : 2005. 06. 20
* Modified: 2008. 07. 2,  H.C.H
*****************************************************************/

// ȯ
BOOL CImageProc::CvtInverse(CImageObj &imgSrc,CImageObj &imgDst)
{
	int LUT[256],i;
	for(i=0;i<256;i++) LUT[i] = 255-i;

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// ȯ
//#define transformation(x) pow( (double)(x) / 255.0f, (1.0f/gamma) ) * 255.0f

BOOL CImageProc::CvtGamma(CImageObj &imgSrc,CImageObj &imgDst,float gamma)
{
	int LUT[256],i;

	//迬
	for(i=0;i<256;i++)
	{
		LUT[i] = (int)(pow( (double)(i) / 255.0f, (1.0f/gamma) ) * 255.0f);
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// ƮĪ ȯ
BOOL CImageProc::CvtStretching(CImageObj &imgSrc,CImageObj &imgDst,int stretch_val)
{
	int LUT[256],i;

	for(i=0;i<256;i++)
	{
		LUT[i] = min( max( (int)((float)(i-stretch_val)*255.0f/(255.0f-stretch_val*2)), 0), 255);
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

//  ȯ
BOOL CImageProc::CvtCompress(CImageObj &imgSrc,CImageObj &imgDst,int compress_val)
{
	int LUT[256],i;

	for(i=0;i<256;i++)
	{
		LUT[i] = compress_val+(int)((float)i*(256.0f-compress_val*2)/(256.0f));
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// Ͷ¡
// poster_val 1~255  ܽ  ´
BOOL CImageProc::CvtPosterizing(CImageObj &imgSrc,CImageObj &imgDst,int poster_val)
{
	int LUT[256],i;
	int cur=-poster_val;

	//Posterizing
	for (i=0;i<256;i++)
	{
		if(i%poster_val==0) cur+=poster_val;
		LUT[i] = min( max(cur,0), 255 );
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// Ӱ谪 ȯ
BOOL CImageProc::CvtThreshold(CImageObj &imgSrc,CImageObj &imgDst,int thres_val)
{
	int LUT[256],i;	

	for (i=0;i<256;i++)
	{
		if(i<thres_val) LUT[i] = 0;
		else LUT[i] = 255;
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// Ӱ谪 ȯ
BOOL CImageProc::CvtRangeThreshold(CImageObj &imgSrc,CImageObj &imgDst, int start, int end,int thresh)
{
	int LUT[256],i;
	//  ˻
	if(start>thresh || thresh>end) return FALSE;

	// ̺ ۼ
	for (i=0;i<256;i++)
	{
		if(i<start) LUT[i] = i;
		else if(i<thresh) LUT[i]=start;
		else if(i<end) LUT[i]=end;
		else LUT[i] = i;
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// Ʈ۸ ȯ ( 1bit ~ 8bit)
BOOL CImageProc::CvtBitClipping(CImageObj &imgSrc,CImageObj &imgDst,int bitclip_val)
{
	int LUT[256],i;

	for (i=0;i<256;i++)
	{
		LUT[i]=i % (256/(1<<bitclip_val));
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

//  ȭ ȯ
BOOL CImageProc::CvEqualBright(CImageObj &imgSrc,CImageObj &imgDst,int start,int end)
{
	int LUT[256],i;

	for (i=0;i<256;i++)
	{
		LUT[i]=i;

		if(start<=i && i<end)
		{
			LUT[i]=0;
		}
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

//   ȯ
BOOL CImageProc::CvtRangeEmphasis(CImageObj &imgSrc,CImageObj &imgDst,int start,int end)
{
	int LUT[256],i;
	//int w0=120;
	//int w1=192;

	for (i=0;i<256;i++)
	{
		if(start<=i && i<end) LUT[i]=255;
		else LUT[i]=i;
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// ֶ¡ ȯ
BOOL CImageProc::CvtSolarising(CImageObj &imgSrc,CImageObj &imgDst,int solar_val)
{
	int LUT[256],i;
	//int solar_val=128;

	for (i=0;i<256;i++)
	{
		if(i>solar_val) LUT[i]=255-i;
		else LUT[i]=i;
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

// Ķ󺼶 ȯ ()
BOOL CImageProc::CvtParabola(CImageObj &imgSrc,CImageObj &imgDst)
{
	int LUT[256],i;

	for(i=0;i<256;i++)
	{
		LUT[i] = 255 -255 * pow((double)(i/128.0)-1.0, 2);
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}

//  Ķ󺼶 ȯ ()
BOOL CImageProc::CvtParabola2(CImageObj &imgSrc,CImageObj &imgDst)
{
	int LUT[256],i;

	for(i=0;i<256;i++)
	{
		LUT[i] = 255 * pow((double)(i/128.0)-1.0, 2);
	}

	ApplyLUT(imgSrc,imgDst,LUT);

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////////////////////////

/**************************************************************
* Functions :	ȭ Լ
*
* History : 2005. 06. 20
* Modified: 2008. 07. 3,  H.C.H
*****************************************************************/

// P Ÿ ȭ
int CImageProc::CvtPtileBin(CImageObj &imgSrc,CImageObj &imgDst)
{
	int i,P=50;
	long sum=0;
	int histogram[256];

	// ׷ 
	CalcHistogram(imgSrc,histogram);

	// P ۰ų  Ӱ谪 ã´ 
	// ( (SUM H(i)) / (M*N) ) <= P
	for(i=0;i<256;i++)
	{
		sum += histogram[i];
		if(sum*100/(imgSrc.m_Width*imgSrc.m_Height) > P) break;
	}

	//  ȭ
	ApplyBIN(imgSrc,imgDst,i);

	return i;
}

//  ȭ
/*
 * (Mode) : ׷    شϴ  ȭ Ӱ谪 ϴ 

   Ӱ谪   Peakness  ˰
  ׷   ̻  ִ 2  ִ ã´. (gi, gj) 
  ׷ gi gj    gk ã´. 
  min(H(gi), H(gj))/H(gk) ǵǴ Peakness Ѵ. 
   ȭϴ Ӱ谪δ   Peakness   gk Ѵ. 
 */

int CImageProc::CvtModeBin(CImageObj &imgSrc,CImageObj &imgDst)
{
	int histogram[256],i;
	int Max, MaxValue=0, MinValue=0, Min, Tvalue, T, temp;

	// ׷ 
	CalcHistogram(imgSrc,histogram);

	//׷ ִġ .
	for(i=0;i<256;i++) 
	{
		if(histogram[i]>MaxValue)
		{     
			MaxValue = histogram[i];
			Max = i;
		}
	}

	//ִġ  ָ  鼭    ȼ  ȼ .
	for(i=0; i<256 ;i++)
	{
		temp = (i-Max)*(i-Max)*histogram[i];
		if(temp > MinValue)
		{
			MinValue = temp; 
			Min = i;
		}
	}

	//Max Min Ͽ   ū  Max  Min.
	if(Max < Min)
	{
		temp = Min;
		Min = Max;
		Max = temp;
	}

	//Max Min ּ  Ͽ Threshold .
	Tvalue = MaxValue;
	for(i=Min+1; i<Max; i++)
	{
 		if(histogram[i]<Tvalue)
		{
			Tvalue = histogram[i];
			T = i;
		}
	}

	//  ȭ
	if(Min==Max) T=Min;
	ApplyBIN(imgSrc,imgDst,T);

	return T;
}


//  ȭ
int CImageProc::CvtAvrBin(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y;
	int m_sum=0, m_avg=0;

	// հ 
    for(y=0;y<imgSrc.m_Height;y++)
	{
		for(x=0;x<imgSrc.m_Width;x++)
		{
			m_sum += imgSrc[y][x];
		}
	}
	m_avg = m_sum / (imgSrc.m_Height*imgSrc.m_Width);

	// հ    ũ ,   thresholding
	ApplyBIN(imgSrc,imgDst,m_avg);

	return m_avg;
}

// ݺ ȭ
int CImageProc::CvtIterativeBin(CImageObj &imgSrc,CImageObj &imgDst)
{
	int a_old,a_new=0;
	int i,j;
	int hist[256];
	int t_bs=0,t_b=0,Nb=0,t_os=0,t_o,No=0;

	do { 
		a_old = a_new;

		// ׷ 
		CalcHistogram(imgSrc,hist);
		
		for(i=0;i<a_old+1;i++) 
		{ 
			t_bs+=i*hist[i];      // հ    
			Nb += hist[i]; 
		}
		
		if(Nb!=0) t_b = t_bs/Nb;        // հ   

		for( j=(int)a_old+1; j<256; j++) 
		{ 
		  t_os+=j*hist[j];     // հ ū   
		  No +=hist[j]; 
		} 
		
		if(No!=0) t_o = t_os/No;       // հ ū   

		a_new = (t_b+t_o)/2;   // ο   
	} while(a_new != a_old);  //     հ  

	//  հ  հ   .
	ApplyBIN(imgSrc,imgDst, a_new);

	return a_new;
}

//  ȭ
/*
BOOL CImageProc::CvtAdaptiveBin(CImageObj &imgSrc,CImageObj &imgDst,int nBlock)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) { AfxMessageBox(_T("GRAY  ƴմϴ.")); return FALSE; }

    int result=0,mask=0,x,y,bx,by; 
    int sum=0,count=0; 

	for(y=0; y<imgSrc.m_Height-9; y++) 
	{
		for(x=0; x<imgSrc.m_Width-9; x++) 
 		{
            for(bx=0; bx<9; bx++)
			{ 
                for(by=0; by<9; by++) 
				{ 
					mask += imgSrc[y+by][x+bx]; 
                } 
            }
            result = mask/81; 
            mask=0; 

            if(imgSrc[y][x]<result) 
			{ 
                imgDst[y+5][x+5]=255; 
            } 
            else 
			{
				imgDst[y+5][x+5]=0; 
			}
        } 
    } 
}*/


BOOL CImageProc::CvtAdaptiveBin(CImageObj &imgSrc,CImageObj &imgDst,int nBlock)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) { AfxMessageBox(_T("GRAY  ƴմϴ.")); return FALSE; }

	int x,y,i,j;
	int xstep,ystep;
	int threshold,t1,t2;
	int hist[256],sum;
	int max1,max2,min,mid;

	// ü   Ѵ.
	ystep=imgSrc.m_Height/nBlock;
 	for(y=0; y<imgSrc.m_Height; y+=ystep) 
	{
		xstep=imgSrc.m_Width/nBlock;
		for(x=0; x<imgSrc.m_Width; x+=xstep) 
 		{
			// xstep,ystep   ( ۱⶧)
			if(x+xstep>imgSrc.m_Width) xstep=imgSrc.m_Width-x;
			if(y+ystep>imgSrc.m_Height) ystep=imgSrc.m_Height-y;

			// ׷ Ѵ.
			for(i=0;i<256;i++) hist[i]=0;
			for(j=0;j<ystep;j++)
			{
				for(i=0;i<xstep;i++)
				{
					hist[ imgSrc[y+j][x+i] ]++;
				}
			}

			// ߽ ã´.
			sum=0;
			mid=128;
			for(i=0;i<256;i++)
			{
				sum += hist[i];
				if(sum*100/(xstep*ystep) > 50) 
				{
					mid=i;
					break;
				}
			}

			// ¿ κп ִġ ã´.
			max1=0,max2=0;
			for(j=0;j<mid;j++)
			{
				if(hist[j]>max1) {
					max1=hist[j];
					t1=j;
				}
			}
			for(j=mid;j<256;j++)
			{
				if(hist[j]>max2) {
					max2=hist[j];
					t2=j;
				}
			}

			// ִġ ̿ ּҰ ã´.
			min=imgSrc.m_Width*imgSrc.m_Height;
			for(i=t1;i<t2;i++)
			{
				if(hist[i]<min) {
					min=hist[i];
					threshold=i;
				}
			}

			// κ ȭ Ѵ.
			for(j=0;j<ystep;j++)
			{
				for(i=0;i<xstep;i++)
				{
					imgDst[y+j][x+i]=(imgSrc[y+j][x+i]>threshold)?255:0;
				}
			}
		}
	}

	return TRUE;
}


//  ȭ
BOOL CImageProc::CvtBlockBin(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,row,column;
	int result=0,mask=0;
	int sum=0,count=0;
	int color=0,col;
	int m=9;	//  

	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
		for(row=0; row<imgSrc.m_Height-m; row++)
		{
			for(column=0; column<imgSrc.m_Width-m; column++ )
			{
				mask=0;
				for(y=0; y<m; y++)
				{
					for(x=0; x<m; x++)
					{
						mask += imgSrc[row+y][(column+x)*color+col];	
					}
				}
				
				result = mask/(m*m);

				imgDst[row+m/2][(column+m/2)*color+col] = (imgSrc[row+m/2][(column+m/2)*color+col]<result)? 0:255;
			}
		}
	}

	return TRUE;
}

//  ȭ
int CImageProc::CvtOtsuBin(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int t,threshold,i;
	double q1,q2,u1,u2,Smax,Sb;
	int hist[256];
	float fhist[256];

	// ׷ 
	CalcHistogram(imgSrc,hist);
	//m_Scale HistogramBin data
	for(i=0;i<256;i++) fhist[i] = (float)hist[i]/(imgSrc.m_Height * imgSrc.m_Width);

	Smax = 0;
	for(t=1;t<256;t++)
	{
		q1=q2=u1=u2=0;
		for(i=0;i<=t;i++) q1+=fhist[i];
		
		for(i=0;i<=t;i++) u1+=i*fhist[i]; 
		u1=u1/q1;
		
		q2=1-q1;
		for(i=t+1;i<256;i++) u2+=i*fhist[i];
		u2=u2/q2; 

		Sb=q1*(1-q1)*(u1-u2)*(u1-u2);
		if(Sb>Smax)
		{
			Smax=Sb; 
			threshold=t;
		}
	}

	ApplyBIN(imgSrc,imgDst,threshold);

	return threshold;
}



////////////////////////////////////////////////////////////////////////////////
/**
 * Finds the optimal (global or local) treshold for image binarization
 * \param method: 0 = average all methods (default); 1 = Otsu; 2 = Kittler & Illingworth; 3 = max entropy; 4 = potential difference;
 * \param pBox: region from where the threshold is computed; 0 = full image (default).
 * \param pContrastMask: limit the computation only in regions with contrasted (!=0) pixels; default = 0.
 * the pContrastMask image must be grayscale with same with and height of the current image,
 * can be obtained from the current image with a filter:
 *   CxImage iContrastMask(*image,true,false,false);
 *   iContrastMask.GrayScale();
 *   long edge[]={-1,-1,-1,-1,8,-1,-1,-1,-1};
 *   iContrastMask.Filter(edge,3,1,0);
 *   long blur[]={1,1,1,1,1,1,1,1,1};
 *   iContrastMask.Filter(blur,3,9,0);
 * \return optimal threshold; -1 = error.
 * \sa AdaptiveThreshold
 */

int  CImageProc::OptimalThreshold(long method, CImageObj &imgSrc)
{
	long xmin,xmax,ymin,ymax;
	xmin = ymin = 0;
	xmax = imgSrc.m_Width; ymax=imgSrc.m_Height;
	
	int p[256];
	memset(p,  0, 256*sizeof(int));

	//build histogram
	CalcHistogram(imgSrc,p);

	//find histogram limits
	int gray_min = 0;
	while (gray_min<255 && p[gray_min]==0) gray_min++;
	int gray_max = 255;
	while (gray_max>0 && p[gray_max]==0) gray_max--;
	int tmp;
	if (gray_min > gray_max) 
	{
		tmp = gray_min;
		gray_min = gray_max;
		gray_max = tmp;
	}
	if (gray_min == gray_max)
	{
		if (gray_min == 0) return 0;
		else return gray_max-1;
	}

	//compute total moments 0th,1st,2nd order
	int i,k;
	double w_tot = 0;
	double m_tot = 0;
	double q_tot = 0;
	for (i = gray_min; i <= gray_max; i++){
		w_tot += p[i];
		m_tot += i*p[i];
		q_tot += i*i*p[i];
	}

	double L, L1max, L2max, L3max, L4max; //objective functions
	int th1,th2,th3,th4; //optimal thresholds
	L1max = L2max = L3max = L4max = 0;
	th1 = th2 = th3 = th4 = -1;

	double w1, w2, m1, m2, q1, q2, s1, s2;
	w1 = m1 = q1 = 0;
	for (i = gray_min; i < gray_max; i++)
	{
		w1 += p[i];
		w2 = w_tot - w1;
		m1 += i*p[i];
		m2 = m_tot - m1;
		q1 += i*i*p[i];
		q2 = q_tot - q1;
		s1 = q1/w1-m1*m1/w1/w1; //s1 = q1/w1-pow(m1/w1,2);
		s2 = q2/w2-m2*m2/w2/w2; //s2 = q2/w2-pow(m2/w2,2);

		//Otsu
		L = -(s1*w1 + s2*w2); //implemented as definition
		//L = w1 * w2 * (m2/w2 - m1/w1)*(m2/w2 - m1/w1); //implementation that doesn't need s1 & s2
		if (L1max < L || th1<0){
			L1max = L;
			th1 = i;
		}

		//Kittler and Illingworth
		if (s1>0 && s2>0){
			L = w1*log(w1/sqrt(s1))+w2*log(w2/sqrt(s2));
			//L = w1*log(w1*w1/s1)+w2*log(w2*w2/s2);
			if (L2max < L || th2<0){
				L2max = L;
				th2 = i;
			}
		}

		//max entropy
		L = 0;
		for (k=gray_min;k<=i;k++) if (p[k] > 0)	L -= p[k]*log(p[k]/w1)/w1;
		for (k;k<=gray_max;k++) if (p[k] > 0)	L -= p[k]*log(p[k]/w2)/w2;
		if (L3max < L || th3<0){
			L3max = L;
			th3 = i;
		}

		//potential difference (based on Electrostatic Binarization method by J. Acharya & G. Sreechakra)
		// L=-fabs(vdiff/vsum);  molto selettivo, sembra che L=-fabs(vdiff) o L=-(vsum)
		// abbiano lo stesso valore di soglia... il che semplificherebbe molto la routine
		double vdiff = 0;
		for (k=gray_min;k<=i;k++)
			vdiff += p[k]*(i-k)*(i-k);
		double vsum = vdiff;
		for (k;k<=gray_max;k++){
			double dv = p[k]*(k-i)*(k-i);
			vdiff -= dv;
			vsum += dv;
		}
		if (vsum>0) L = -fabs(vdiff/vsum); else L = 0;
		if (L4max < L || th4<0){
			L4max = L;
			th4 = i;
		}
	}

	int threshold;
	switch (method){
	case 1: //Otsu
		threshold = th1;
		break;
	case 2: //Kittler and Illingworth
		threshold = th2;
		break;
	case 3: //max entropy
		threshold = th3;
		break;
	case 4: //potential difference
		threshold = th4;
		break;
	default: //auto
		{
			int nt = 0;
			threshold = 0;
			if (th1>=0) { threshold += th1; nt++;}
			if (th2>=0) { threshold += th2; nt++;}
			if (th3>=0) { threshold += th3; nt++;}
			if (th4>=0) { threshold += th4; nt++;}
			if (nt)
				threshold /= nt;
			else
				threshold = (gray_min+gray_max)/2;

		}
	}

	if (threshold <= gray_min || threshold >= gray_max)
		threshold = (gray_min+gray_max)/2;
	
	return threshold;
}


// Ʈ ȭ
int CImageProc::CvtEntropyBin(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int ThresholdLevel, hist[256];
	double prob[256], Sum_prob_1k = 0, Sum_prob_kl = 0, 
		Sum_prob_ln_1k = 0, Sum_prob_ln_kl = 0, Entropy[256];
	int XMax = imgSrc.m_Width;
	int YMax = imgSrc.m_Height;

    //gets histogram of image
	CalcHistogram(imgSrc,hist);

	// probability distribution
	for( int i = 0; i< 256; i++)
		prob[i] =  (double) hist[i] / (XMax * YMax); 
	
           // k is trial threshold level
	for( int k = 0; k< 255; k++)		
	{
		Sum_prob_1k = 0; Sum_prob_kl = 0; 
		Sum_prob_ln_1k = 0; Sum_prob_ln_kl = 0;
		     
		//From 1 to k
		for(i = 1; i < k; i++)			
		{	
			//Sums probablities to k
			Sum_prob_1k += prob[i];		

            //Sums prob times Log of prob to k
			if(prob[i]!=0) Sum_prob_ln_1k += (prob[i] * log(prob[i]));
		}
		
		//From k to end
		for(i = k; i < 256; i++)
		{								 
			//Sums prob of k to end
			Sum_prob_kl += prob[i];		
			//Sums prob times log of prob
		    if(prob[i]!=0) Sum_prob_ln_kl += (prob[i] * log(prob[i]));
		}
		//Final equation of entropy for each k
		Entropy[k] = log(Sum_prob_1k) + log(Sum_prob_kl)
			- (Sum_prob_ln_1k / Sum_prob_1k)
			- (Sum_prob_ln_kl / Sum_prob_kl);
		//protects against divide by zero
		if(Entropy[k]<0) Entropy[k]=0;
	}		

	ThresholdLevel = 0;
	//Finds Maximum
	for(k = 0; k<256; k++)	
	{
		if(Entropy[k] > Entropy[ThresholdLevel]) ThresholdLevel = k;
	}

	ApplyBIN(imgSrc,imgDst,ThresholdLevel);
	
	return ThresholdLevel;
}


////////////////////////////////////////////////////////////////////////////////////////////////////

/**************************************************************
* Functions :	ȯ
*  Ȯ/, ȸ, ¿/ϴĪ, ̵, FFTȯ
*****************************************************************/

// Ȯ/: Ϲ   (Forward Mapping)
BOOL CImageProc::CvtRszScale(CImageObj &imgSrc,CImageObj &imgDst,int width,int height)
{
	int x,y,X,Y;
	int color=0,col;
	double wscale,hscale;

	//   ޸ Ҵ
	imgDst.AllocBuff(width,height,imgSrc.m_ColorMode);

	//   ϱ
	wscale = (double)width/imgSrc.m_Width;
	hscale = (double)height/imgSrc.m_Height;

	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
 		for(Y=0; Y<imgSrc.m_Height; Y++) 
		{
			for(X=0; X<imgSrc.m_Width; X++) 
 			{
				//  
				x = (int) ((double)X*wscale);
				y = (int) ((double)Y*hscale);
				imgDst[y][x*color+col] = imgSrc[Y][X*color+col];
			}
		}
	}

	return TRUE;
}

// Ȯ/: ֱ  (Backward Mapping)
BOOL CImageProc::CvtRszNearest(CImageObj &imgSrc,CImageObj &imgDst,int width,int height)
{
	int x,y,X,Y;
	int color=0,col;
	double wscale,hscale;

	//   ޸ Ҵ
	imgDst.AllocBuff(width,height,imgSrc.m_ColorMode);

	//   ϱ
	wscale = (double)width/imgSrc.m_Width;
	hscale = (double)height/imgSrc.m_Height;

	// Į󿵻ΰ
	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
 		for(Y=0; Y<imgDst.m_Height; Y++) 
		{
			for(X=0; X<imgDst.m_Width; X++) 
 			{
				//  
				x = (int) ((double)X/wscale);
				y = (int) ((double)Y/hscale);
				imgDst[Y][X*color+col] = imgSrc[y][x*color+col];
			}
		}
	}

	return TRUE;
}


// Ȯ/: 缱  (Backward Mapping)
BOOL CImageProc::CvtRszBilinear(CImageObj &imgSrc,CImageObj &imgDst,int width,int height)
{
	int color=0,col;
	double wscale,hscale;
	int x,y,xs,ys;
	int NW,NE,SW,SE;
	double EW1,EW2;
	double EWscale,NSscale;

	//   ޸ Ҵ
	imgDst.AllocBuff(width,height,imgSrc.m_ColorMode);

	//   ϱ
	wscale = (double)width/imgSrc.m_Width;
	hscale = (double)height/imgSrc.m_Height;

	// Į󿵻ΰ
	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
 		for(y=0; y<imgDst.m_Height; y++) 
		{
			for(x=0; x<imgDst.m_Width; x++) 
 			{
				//   ǥ
				xs = (int) ((double)x/wscale);
				ys = (int) ((double)y/hscale);
				if(xs>=imgSrc.m_Width-1)  xs--;
				if(ys>=imgSrc.m_Height-1) ys--;

				// ũ  
				EWscale = (double)x/wscale - xs;
				NSscale = (double)y/hscale - ys;

				//   4 
				NW = imgSrc[ys][xs*color+col];
				NE = imgSrc[ys+1][xs*color+col];
				SW = imgSrc[ys][xs*color+col+1];
				SE = imgSrc[ys+1][xs*color+col+1];

				// 1 
				EW1 = NW + EWscale*(NE-NW);
				EW2 = SW + EWscale*(SE-SW);

				// 2 
				imgDst[y][x*color+col] = EW1 + NSscale*(EW2-EW1);
			}
		}
	}


	return TRUE;
}

// Ȯ/: B-Spline 
double BSP_A0(double X) { return -(1.0f/6.0f)*X*X*X + X*X - 2.0f*X + 4.0f/3.0f; }
double BSP_A1(double X) { return 0.5f*X*X*X - X*X + 2.0f/3.0f; }
double BSP_A2(double X) { return 0.5f*X*X*X - X*X + 2.0f/3.0f; }
double BSP_A3(double a0,double a1,double a2)  { return 1.0f-a0-a1-a2; }

BOOL CImageProc::CvtRszBspline(CImageObj &imgSrc,CImageObj &imgDst,int width,int height)
{
	int color=0,col,i;
	int x,y,xs,ys;
	double wscale,hscale,xweight,yweight,column[4];
	double a[4],b[4];

	//   ޸ Ҵ
	imgDst.AllocBuff(width,height,imgSrc.m_ColorMode);

	//   ϱ
	wscale = (double)width/imgSrc.m_Width;
	hscale = (double)height/imgSrc.m_Height;

	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
 		for(y=0; y<imgDst.m_Height; y++) 
		{
			for(x=0; x<imgDst.m_Width; x++) 
 			{
				// Է  ǥ
				xs = (int)((double)x/wscale)-1;
				ys = (int)((double)y/wscale)-1;
				if(xs<0) xs = 0;
				if(ys<0) ys = 0;
				if(xs>imgSrc.m_Width-4)  xs=imgSrc.m_Width-4;
				if(ys>imgSrc.m_Height-4) ys=imgSrc.m_Height-4;

				// ũ  
				xweight = (double)x/wscale - (int)((double)x/wscale);
				yweight = (double)y/hscale - (int)((double)y/wscale);

				// x  
				a[0] = BSP_A0(xweight + 1.0f);
				a[1] = BSP_A1(xweight);
				a[2] = BSP_A2(1.0f - xweight);
				a[3] = BSP_A3(a[0],a[1],a[2]);

				// Y  
				b[0] = BSP_A0(yweight + 1.0f);
				b[1] = BSP_A1(yweight);
				b[2] = BSP_A2(1.0f - yweight);
				b[3] = BSP_A3(b[0],b[1],b[2]);

				for(i=0;i<4;i++) 
				{
					column[i] = a[0]*imgSrc[ys+i][xs*color+col+0] +
								a[1]*imgSrc[ys+i][xs*color+col+1] +
								a[2]*imgSrc[ys+i][xs*color+col+2] +
								a[3]*imgSrc[ys+i][xs*color+col+3];
					imgDst[y][x*color+col] += b[i]*column[i];
				}
			}
		}
	}


	return TRUE;
}


// Ȯ/: 3 ȸ 
/*
'C  ̿ ó' linear interpolation κ ҽ
'ó ̷а ' cubic interpolation Դϴ...
VC++ console application  ߽ϴ...
 ȭ  ȵǴ 伥 ̿Ͻñ...

ҽ  Դϴ.
*******************************************************************************
unsigned char cubic_interpolation(unsigned char image[4][4], float x, float y, double a)
// Է  4 by 4Դϴ. x, y ǥ, a cubic convolution Լ  
// .. -1 Ѵٳ׿..

   {
   double column[4];                // storage for row interpolation results
// row    ˴ϴ..

   double a0, a1, a2, a3;           // interpolation coefficients
   double x_plus_1, y_plus_1;       // x + 1, y + 1 
   double one_minus_x, one_minus_y; // 1 - x, 1 - y 
   double two_minus_x, two_minus_y; // 2 - x, 2 - y 
   int i;                           // loop index 
   double pixel;                    // newly interpolated value 

   // Do we really need to interpolate ? 
   if((x == 0.0) && (y == 0.0))
return image[1][1];
// ϴ  ʿ, ʿ  Ǻմϴ...x, y ǥ 0, 0   [1][1]
// ȭҰ returnմϴ....[0][0] ƴѰɷ  offset  [1][1] Ʈ  
// ׿...

   if(x == 0.0)                   // Do we need to interpolate the rows?
for(i=0; i<4; i++)         // NO 
   column[i] = (double) image[i][1];
// row   ʿ θ ...ʿ   column[]  ϰ
// column   Ѿ.

   else                           // YES, we do need to interpolate rows 
{
x_plus_1 = x + 1.0;
one_minus_x = 1.0 - x;
two_minus_x = 2.0 - x;
// å  x    ÷  ɼ(d)ϸ
// x  ׸ 4.7  ִ 3 Լ -2  2  ȿ ְ ˴ϴ..
// , f(-d), f(-1-d), f(1-d), f(2-d) ..., f(d), f(1+d) f(-d), f(-1-d)   ..
// Ŀ x  0  2  Ѱ Լ Ī̱  x 밪 
//   θ  Դϴ.....
//    a0, a1, a2, a3 Լ f(x)  شǴ    ϴµ ˴ϴ.
// x_plus_1 a0=f(1+d) 1+d  Ÿ ̱, one_minus_x a(2) 1-d, ׸
// two_minus_x a3 2-d Ÿϴ...

a0 = ((a * x_plus_1 - 5.0 * a) * x_plus_1 + 8.0 * a) * x_plus_1 - 4.0 * a;
a1 = ((a + 2.0) * x - (a + 3.0)) * x * x + 1;
a2 = ((a + 2.0) * one_minus_x - (a + 3.0)) * one_minus_x * one_minus_x + 1;
a3 = ((a * two_minus_x - 5.0 * a) * two_minus_x + 8.0 * a) * two_minus_x - 4.0 * a;
//   p.148  ° ó, p.145  Honor rule Ͽ Ǯ Դϴ...
//  ÷帰 matlab ҽ  ״ ߴ...

if(y == 0.0)   // can we just process one row
   {
   pixel = a0 * image[1][0] + a1 * image[1][1] +
   a2 * image[1][2] + a3 * image[1][3];
   CLIP(pixel, 0.0, 255.0);
   return (unsigned char) pixel;
   }
// y ˻Ͽ 0 ̸  ʿ䰡   ȼ Ͽ returnϰ ..
else
   for(i=0; i<4; i++)
column[i] = a0 * image[i][0] + a1 * image[i][1] +
   a2 * image[i][2] + a3 * image[i][3];
}
// y ƴϸ, column[]  row ȼ Ͽ .. 

   // interpolate the resulting column 
//  row ߴ    column մϴ....

   y_plus_1 = y + 1.0;
   one_minus_y = 1.0 - y;
   two_minus_y = 2.0 - y;

   a0 = ((a * y_plus_1 - 5.0 * a) * y_plus_1 + 8.0 * a) * y_plus_1 - 4.0 * a;
   a1 = ((a + 2.0) * y - (a + 3.0)) * y * y + 1;
   a2 = ((a + 2.0) * one_minus_y - (a + 3.0)) * one_minus_y * one_minus_y + 1;
   a3 = ((a * two_minus_y - 5.0 * a) * two_minus_y + 8.0 * a) * two_minus_y - 4.0 * a;

   pixel = column[0] * a0 + column[1] * a1 + column[2] * a2 + column[3] * a3;
   CLIP(pixel, 0.0, 255.0);
   return (unsigned char) pixel;
//   column   row  Ͽ ȼ returnմϴ..
// CLIP ȭ  0-255 ̿ ֵ ϱ  ˴ϴ..
   }
 
*/


// Affine ȯ
// (u0,v0), (u1,v1), (u2,v2) Է ﰢ ǥ
// (x0,y0), (x1,y1), (x2,y2)  ﰢ ǥ
BOOL CImageProc::CvtAffine(CImageObj &imgSrc,CImageObj &imgDst,
	double u0,double v0,double u1,double v1,double u2,double v2,
	double x0,double y0,double x1,double y1,double x2,double y2)
{
	int col,color;
	int u,v,x,y;
	double a11,a12,a21,a22,a31,a32;
	double xx,yy,fu,fv,detUV,detT;

	imgDst.Empty();

	u0=10.0/570;
	v0=10.0/570;
	u1=710.0/570;
	v1=10.0/570;
	u2=710.0/570;
	v2=470.0/570;

	/*
	x0=10.0/570;
	y0=10.0/570;
	x1=710.0/570;
	y1=10.0/570;
	x2=710.0/570;
	y2=470.0/570;
	*/

	
	x0=50.0/570;
	y0=50.0/570;
	x1=710.0/570;
	y1=10.0/570;
	x2=670.0/570;
	y2=430.0/570;
	
	/*
	x0=50.0/imgSrc.m_Width;
	y0=50.0/imgSrc.m_Height;
	x1=240.0/imgSrc.m_Width;
	y1=10.0/imgSrc.m_Height;
	x2=210.0/imgSrc.m_Width;
	y2=150.0/imgSrc.m_Height;
	*/

	// ÷  
	color=imgSrc.m_ColorMode/8;

	//  Ѵ.
	detUV = (u0*(v1-v2) - v0*(u1-u2) + (u1*v2-u2*v1) );
	
	a11 = detUV*( (v1-v2)*x0 + (v2-v0)*x1 + (v0-v1)*x2 );
	a21 = detUV*( (u2-u1)*x0 + (u0-u2)*x1 + (u1-u0)*x2 );
	a31 = detUV*( (u1*v2-u2*v1)*x0 + (u2*v0-u0*v2)*x1 + (u2*v1-u1*v0)*x2 );

	a12 = detUV*( (v1-v2)*y0 + (v2-v0)*y1 + (v0-v1)*y2 );
	a22 = detUV*( (u2-u1)*y0 + (u0-u2)*y1 + (u1-u0)*y2 );
	a32 = detUV*( (u1*v2-u2*v1)*y0 + (u2*v0-u0*v2)*y1 + (u2*v1-u1*v0)*y2 );
	
	detT = (a11*a22-a21*a12);

	for(col=0;col<color;col++)
	{
 		for(y=0; y<imgSrc.m_Height; y++) 
		{
			yy = (float)y/imgSrc.m_Height;

			for(x=0; x<imgSrc.m_Width; x++) 
 			{
				xx = (float)x/imgSrc.m_Width;

				fu = (1.0/detT) * ( xx*a22 - yy*a21 + a21*a32 - a31*a22 ) * imgSrc.m_Width;
				fv = (1.0/detT) * ( yy*a11 - xx*a12 + a31*a12 - a11*a32 ) * imgSrc.m_Height;
				u = (int)(fu+0.5);	// ֱ 
				v = (int)(fv+0.5);

				// ǥ ˻
				if(u>=imgSrc.m_Width) u = imgSrc.m_Width-1;
				if(u<0) u = 0;
				if(v>=imgSrc.m_Height) v = imgSrc.m_Height-1;
				if(v<0) v = 0;

				//  Է
				imgDst[y][x*color+col] = imgSrc[v][u*color+col];
			}
		}
	}

	return TRUE;
}

// ¿ Ī
BOOL CImageProc::CvtMirror(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y;
	int color=0,col;
	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
 		for(y=0; y<imgSrc.m_Height; y++) 
		{
			for(x=0; x<imgSrc.m_Width; x++) 
 			{
				imgDst[y][x*color+col] = imgSrc[y][(imgSrc.m_Width-1-x)*color+col];
			}
		}
	}
	
	return TRUE;
}

//  Ī
BOOL CImageProc::CvtFlip(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y;
	int color=0,col;
	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
 		for(y=0; y<imgSrc.m_Height; y++) 
		{
			for(x=0; x<imgSrc.m_Width; x++) 
 			{
				imgDst[y][x*color+col] = imgSrc[imgSrc.m_Height-1-y][x*color+col];
			}
		}
	}
	
	return TRUE;
}


// ȸ
//#define PI 3.141592f

// Visual C++ ̿ ǿ뿵ó -- 
BOOL RotateImage(CImageObj &imgSrc,CImageObj &imgDst,int deg)
{
	int x,y,nx,ny,cx,cy;
	float angle;
	int zy,dx,dy;
	int width,height;

	zy=imgSrc.m_Height-1;

	angle=PI/180.0f*deg;
	cx=imgSrc.m_Width / 2;
	cy=imgSrc.m_Height/ 2;

	// ũ    Ҵ
	width = abs(imgSrc.m_Height*cos(PI/2.0-angle)) + abs(imgSrc.m_Width*cos(angle));
	height= abs(imgSrc.m_Height*cos(angle)) + abs(imgSrc.m_Width*cos(PI/2.0-angle));
	imgDst.AllocBuff(width+1,height+1,imgSrc.m_ColorMode);

	// ȸϱ
	dx=(width-imgSrc.m_Width)/2;
	dy=(height-imgSrc.m_Height)/2;

	int color=0,col;
	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
		for(y=-dy;y<height-dy;y++)
		{
			for(x=-dx;x<width-dx;x++)
			{
				// ȸ߽  angle ŭ ȸѴ.
				nx=((zy-y)-cy)*sin(angle)+(x-cx)*cos(angle)+cx;
				ny=((zy-y)-cy)*cos(angle)-(x-cx)*sin(angle)+cy;
				//  ٽ  ܿ  Ѵ.
				ny=zy-ny;
				// ȸ ġ ׸.
				if(nx<0 || nx>imgSrc.m_Width-1 || ny<0 || ny> imgSrc.m_Height-1) imgDst[y+dy][(x+dx)*color+col]=0;
				else imgDst[y+dy][(x+dx)*color+col] = imgSrc[ny][nx*color+col];
			}
		}
	}

	return TRUE;
}

BOOL CImageProc::CvtRotate(CImageObj &imgSrc,CImageObj &imgDst,int deg)
{
	int x,y;
	int color=0,col;
	color=imgSrc.m_ColorMode/8;

	//   ȸ
	if(deg!=90 && deg!=180 && deg!=270)
	{
		RotateImage(imgSrc,imgDst,deg);
	}
	// 90,180,270 ȸ
	else 
	{
		// 90,270 ȸ  ũ ȯ
		if(deg==90 || deg==270) 
		{ 
			imgDst.AllocBuff(imgSrc.m_Height,imgSrc.m_Width,imgSrc.m_ColorMode);
		}

		for(col=0;col<color;col++)
		{
 			for(y=0; y<imgSrc.m_Height; y++) 
			{
				for(x=0; x<imgSrc.m_Width; x++) 
 				{
					if(deg==0)			imgDst[y][x*color+col] = imgSrc[y][x*color+col];
					else if(deg==90)	imgDst[x][y*color+col] = imgSrc[y][(imgSrc.m_Width-1-x)*color+col];
					else if(deg==180)	imgDst[y][x*color+col] = imgSrc[imgSrc.m_Height-1-y][(imgSrc.m_Width-1-x)*color+col];
					else if(deg==270)	imgDst[x][y*color+col] = imgSrc[imgSrc.m_Height-1-y][x*color+col];
				}
			}
		}
	}

	return TRUE;
}

// ̵ȯ
BOOL CImageProc::CvtTranslate(CImageObj &imgSrc,CImageObj &imgDst,int tx,int ty)
{
	int x,y;
	int color=0,col;
	color=imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
 		for(y=0; y<imgSrc.m_Height; y++) 
		{
			for(x=0; x<imgSrc.m_Width; x++) 
 			{
				if(y-ty>=0 && y-ty<imgSrc.m_Height && x-tx>=0 && x-tx<imgSrc.m_Width)
					imgDst[y][x*color+col] = imgSrc[y-ty][(x-tx)*color+col];
				else imgDst[y][x*color+col] = 0;
			}
		}
	}
	
	return TRUE;
}


// FFT ȯ Լ
BOOL IsPowerOf2(CImageObj &imgSrc)
{
	int ref_w=1;
	int ref_h=1;

	while(ref_w<imgSrc.m_Width) ref_w<<=1;
	while(ref_h<imgSrc.m_Height) ref_h<<=1;

	if(ref_w==imgSrc.m_Width && ref_h==imgSrc.m_Height) return TRUE;
	else return FALSE;
}

BOOL CImageProc::CvtZeroPadding(CImageObj &imgSrc,CImageObj &imgDst)
{
	// 2 ڽ Ǵ ũ⸦ ã´.
	int ref_w=1;
	int ref_h=1;
	while(ref_w<imgSrc.m_Width) ref_w<<=1;
	while(ref_h<imgSrc.m_Height) ref_h<<=1;

	imgDst.AllocBuff(ref_w,ref_h,imgSrc.m_ColorMode);
	imgDst.Copy(imgSrc);

	return TRUE;
}
 
BOOL CImageProc::CvtFFT(CImageObj &imgSrc,CImageObj &imgDst)
{
	CImageObj imgTmp;
	//  ũ⸦ ˻Ѵ.  256x256 or 512x512
	if(IsPowerOf2(imgSrc)==FALSE) 
	{
		//AfxMessageBox("ũⰡ 2 ¼϶ ϴ.");
		//return FALSE;
		CvtZeroPadding(imgSrc,imgDst);
		imgTmp = imgDst;
	}
	else 
	{
		imgTmp = imgSrc;
	}

	FFT2D(imgTmp,imgDst);
	return TRUE;
}

BOOL CImageProc::CvtIFFT(CImageObj &imgSrc,CImageObj &imgDst)
{
	//  ũ⸦ ˻Ѵ.  256x256 or 512x512
	if(IsPowerOf2(imgSrc)==FALSE) 
	{
		AfxMessageBox("ũⰡ 2 ¼϶ ϴ. (е)");
		return FALSE;
	}

	IFFT2D(imgSrc,imgDst);
	return TRUE;
}


void CImageProc::FFT2D(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,r,c,num,log2N;
	int val;
	CComplex *data1d;
	CImageObj imgTmp;
	imgTmp = imgSrc;

	//if(m_pFFT2D!=NULL) { AfxMessageBox("̹ FFTȯ ߽ϴ."); return; }

	//  Ҵ  Է
	int len=max(imgSrc.m_Width,imgSrc.m_Height);
	data1d = new CComplex [len];
	imgDst.AllocFFT2D();

	//  ʺ 
	num=imgSrc.m_Width;
	log2N=0;
	while(num>=2)
	{
		num>>=1;
		log2N++;
	}

	//   fft ȯ
 	for(y=0; y<imgSrc.m_Height; y++)
	{
		for(x=0; x<imgSrc.m_Width; x++) data1d[x].Set(imgSrc[y][x],0);	//  ʹ Ǽ

		FFT1D(data1d,imgSrc.m_Width,log2N);

		for(x=0; x<imgSrc.m_Width; x++) imgDst.m_pFFT2D[y][x] = data1d[x];
	}

	//   
	num=imgSrc.m_Height;
	log2N=0;
	while(num>=2)
	{
		num>>=1;
		log2N++;
	}

	//   fft ȯ
	for(x=0; x<imgSrc.m_Width; x++)
	{
		for(y=0; y<imgSrc.m_Height; y++) data1d[y]=imgDst.m_pFFT2D[y][x];

		FFT1D(data1d,imgSrc.m_Height,log2N);

		for(y=0; y<imgSrc.m_Height; y++) imgDst.m_pFFT2D[y][x] = data1d[y];
	}
	
	//  
 	for(y=0; y<imgSrc.m_Height; y++) 
	{
		for(x=0; x<imgSrc.m_Width; x++)
		{
			val = 20 * log( 
				sqrt((imgDst.m_pFFT2D[y][x].re*imgDst.m_pFFT2D[y][x].re) + 
				(imgDst.m_pFFT2D[y][x].im*imgDst.m_pFFT2D[y][x].im)) );
			if(val>255) val=255;
			if(val<0) val=0;
			imgTmp[y][x]=val;
		}
	}

	// 4  ¿ ĪŲ.
 	for(y=0; y<imgSrc.m_Height; y+=imgSrc.m_Height/2) 
	{
		for(x=0; x<imgSrc.m_Width; x+=imgSrc.m_Width/2)
		{
			for(r=0;r<imgSrc.m_Height/2;r++)
			{
				for(c=0;c<imgSrc.m_Width/2;c++)
				{
					imgDst[(imgSrc.m_Height/2-1)-r+y][(imgSrc.m_Width/2-1)-c+x] = imgTmp[y+r][x+c];
				}
			}
		}
	}

	//   
	delete [] data1d;
}

void CImageProc::FFT1D(CComplex *f, int N, int log2N)
{
	Shuffle(f,N,log2N);
	Butterfly(f,N,log2N,0);
}

void CImageProc::IFFT1D(CComplex *f, int N, int log2N)
{
	Shuffle(f,N,log2N);
	Butterfly(f,N,log2N,1);
}

void CImageProc::Shuffle(CComplex *f,int N, int log2N)
{
	int i,j,num,b;
	CComplex *temp;
	temp = new CComplex[N];

	for(i=0;i<N;i++)
	{
		num=0;
		for(j=0;j<log2N;j++)
		{
			b = (i & (1<<j))>>j;
			num = (num<<1) | b;
		}

		temp[i] = f[num];
	}

	for(i=0;i<N;i++) f[i] = temp[i];

	delete [] temp;
}

// ö Լ
void CImageProc::Butterfly(CComplex *f,int N, int log2N, int dir)
{
	CComplex *W,temp;	//intermediate CComplex numbers
	int i,j,m;	//loop variables
	double val;
	int start,size;

	W = new CComplex [N/2];

	for(i=0; i<log2N; i++)
	{
		val = pow(2,i+1);
		size = (int) val;

		// ȯ
		if(dir == 0)
		{
			for(j=0;j<size/2;j++) W[j].Set(cos(j*2.0*PI/val), -sin(j*2.0*PI/val));
		}
		// ȯ
		else 
		{
			for(j=0;j<size/2;j++) W[j].Set(cos(j*2.0*PI/val), sin(j*2.0*PI/val));
		}

		for(start=0; start<N-size/2; start+=size)
		{
			for(j=start; j<start+size/2; j++)
			{
				m=j+size/2;
				
				temp.re = (W[j-start].re*f[m].re)-(W[j-start].im*f[m].im);
				temp.im = (W[j-start].im*f[m].re)+(W[j-start].re*f[m].im);

				f[m] = f[j]-temp;
				f[j] = f[j]+temp;
			}
		}
	}

	// ȯ 
	if(dir == 1)
	{
		for(i=0;i<N;i++) f[i] /= N;
	}

	delete []W;
}


// Ǫ ȯ
void CImageProc::IFFT2D(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,num,log2N;
	CComplex *data1d;

	//  Ҵ  Է
	int len=max(imgSrc.m_Width,imgSrc.m_Height);
	data1d = new CComplex [len];
	imgDst.AllocFFT2D();

	//  ʺ 
	num=imgSrc.m_Width;
	log2N=0;
	while(num>=2)
	{
		num>>=1;
		log2N++;
	}

	//   fft ȯ
 	for(y=0; y<imgSrc.m_Height; y++)
	{
		if(imgSrc.m_pFFT2D==NULL) for(x=0; x<imgSrc.m_Width; x++) data1d[x].Set(imgSrc[y][x],0);
		else for(x=0; x<imgSrc.m_Width; x++) data1d[x] = imgSrc.m_pFFT2D[y][x];

		IFFT1D(data1d,imgSrc.m_Width,log2N);

		for(x=0; x<imgSrc.m_Width; x++) imgDst.m_pFFT2D[y][x] = data1d[x];
	}

	//   
	num=imgSrc.m_Height;
	log2N=0;
	while(num>=2)
	{
		num>>=1;
		log2N++;
	}

	//   fft ȯ
	for(x=0; x<imgSrc.m_Width; x++)
	{
		for(y=0; y<imgSrc.m_Height; y++) data1d[y] = imgDst.m_pFFT2D[y][x];

		IFFT1D(data1d,imgSrc.m_Height,log2N);

		for(y=0; y<imgSrc.m_Height; y++) imgDst.m_pFFT2D[y][x] = data1d[y];
	}
	
	//  
 	for(y=0; y<imgSrc.m_Height; y++) 
	{
		for(x=0; x<imgSrc.m_Width; x++)
		{
			imgDst[y][x] = imgDst.m_pFFT2D[y][x].re;
		}
	}

	//   
	delete [] data1d;
}

// lowpass Butterworth filter in two dimensions
BOOL CImageProc::CvtLpf(CImageObj &imgSrc,CImageObj &imgDst)
{
	//  ũ⸦ ˻Ѵ.  256x256 or 512x512
	if(IsPowerOf2(imgSrc)==FALSE) { AfxMessageBox("ũⰡ 2 ¼϶ ϴ. (е)"); return FALSE; }

	int i,j,x,y;
	double temp,D,N;
	D=32.0;
	N=4.0;

	CvtFFT(imgSrc,imgDst);

	// ļ 
 	for(y=0; y<imgSrc.m_Height; y++) 
	{
		for(x=0; x<imgSrc.m_Width; x++)
		{
			i = (x>imgSrc.m_Width/2)? x-imgSrc.m_Width:x;
			j = (y>imgSrc.m_Height/2)? y-imgSrc.m_Height:y;

			temp = 1.0/ (1.0+pow(sqrt((double)(i*i+j*j))/D, 2*N));

			imgDst.m_pFFT2D[y][x] *= temp;
		}
	}

	CvtIFFT(imgDst,imgDst);

	return TRUE;
}

// highpass Butterworth filter in two dimensions
BOOL CImageProc::CvtHpf(CImageObj &imgSrc,CImageObj &imgDst)
{
	//  ũ⸦ ˻Ѵ.  256x256 or 512x512
	if(IsPowerOf2(imgSrc)==FALSE) { AfxMessageBox("ũⰡ 2 ¼϶ ϴ. (е)"); return FALSE; }

	int i,j,x,y;
	double temp,D,N;
	D=128.0;
	N=4.0;

	CvtFFT(imgSrc,imgDst);

	// ļ 
 	for(y=0; y<imgSrc.m_Height; y++) 
	{
		for(x=0; x<imgSrc.m_Width; x++)
		{
			i = (x>imgSrc.m_Width/2)? x-imgSrc.m_Width:x;
			j = (y>imgSrc.m_Height/2)? y-imgSrc.m_Height:y;

			temp = 1.0/ (1.0 + pow( D/ sqrt((double)(i*i+j*j)), 2*N));

			imgDst.m_pFFT2D[y][x] *= temp;
		}
	}

	CvtIFFT(imgDst,imgDst);

	return TRUE;
}

BOOL CImageProc::CvtBpf(CImageObj &imgSrc,CImageObj &imgDst)
{
	//  ũ⸦ ˻Ѵ.  256x256 or 512x512
	if(IsPowerOf2(imgSrc)==FALSE) { AfxMessageBox("ũⰡ 2 ¼϶ ϴ. (е)"); return FALSE; }

	int i,j,x,y;
	double temp1,temp2,D1,D2,N;
	D1=32.0;
	D2=20.0;
	N=4.0;

	CvtFFT(imgSrc,imgDst);

	// ļ 
 	for(y=0; y<imgSrc.m_Height; y++) 
	{
		for(x=0; x<imgSrc.m_Width; x++)
		{
			i = (x>imgSrc.m_Width/2)? x-imgSrc.m_Width:x;
			j = (y>imgSrc.m_Height/2)? y-imgSrc.m_Height:y;

			temp1 = 1.0/ (1.0+pow(sqrt((double)(i*i+j*j))/D1, 2*N));
			temp2 = 1.0/ (1.0+pow(sqrt((double)(i*i+j*j))/D2, 2*N));

			imgDst.m_pFFT2D[y][x] *= (temp1-temp2);
		}
	}

	CvtIFFT(imgDst,imgDst);

	return TRUE;
}

BOOL CImageProc::CvtBsf(CImageObj &imgSrc,CImageObj &imgDst)
{
	//  ũ⸦ ˻Ѵ.  256x256 or 512x512
	if(IsPowerOf2(imgSrc)==FALSE) { AfxMessageBox("ũⰡ 2 ¼϶ ϴ. (е)"); return FALSE; }

	int i,j,x,y;
	double temp1,temp2,D1,D2,N;
	D1=32.0;
	D2=20.0;
	N=4.0;

	CvtFFT(imgSrc,imgDst);

	// ļ 
 	for(y=0; y<imgSrc.m_Height; y++) 
	{
		for(x=0; x<imgSrc.m_Width; x++)
		{
			i = (x>imgSrc.m_Width/2)? x-imgSrc.m_Width:x;
			j = (y>imgSrc.m_Height/2)? y-imgSrc.m_Height:y;

			temp1 = 1.0/ (1.0+pow(sqrt((double)(i*i+j*j))/D1, 2*N));
			temp2 = 1.0/ (1.0+pow(sqrt((double)(i*i+j*j))/D2, 2*N));

			imgDst.m_pFFT2D[y][x] *= (1.0-temp1-temp2);
		}
	}

	CvtIFFT(imgDst,imgDst);


	return TRUE;
}





// HPF
/*
BOOL CImageProc::HighPass()
{
	int sum = 0 ;
	int temp = 0 ; 

	int mask[3][3] = {	-1 , -1 , -1,
						-1 ,  9 , -1,
						-1 , -1 , -1 } ;

	BYTE **imgDst = MakeTempBuffer() ; 

	for ( int y = 1 ; y < m_lHeight-1 ; y++)
	{
		for (int x = 1 ; x < m_lWidth -1 ; x++)
		{
			for ( int wy = -1 ; wy <=1 ; wy++)
			{
				for ( int wx = -1 ; wx<=1 ; wx++)
				{
					temp =(int) imgSrc[y+wy][x+wx] ; 
					sum +=temp*(mask[wy+1][wx+1]) ; 
				}
				
			}
			if(sum<0) sum= 0 ; 
			else if( sum>255) sum=255 ; 

			imgDst[y][x] =(BYTE)sum ;
			sum=0;
		}
	}

	Dump(imgDst);
	DeleteTempBuffer(imgDst);
	return TRUE ; 
}



// LPF
BOOL CImageProc::LowPass()
{
	int sum = 0 ;
	int temp = 0 ; 

	int mask[3][3] = {1,1,1,
					  1,1,1,
					  1,1,1} ;

	BYTE **imgDst = MakeTempBuffer() ; 

	for ( int y = 1 ; y < m_lHeight-1 ; y++)
	{
		for (int x = 1 ; x < m_lWidth -1 ; x++)
		{
			for ( int wy = -1 ; wy <=1 ; wy++)
			{
				for ( int wx = -1 ; wx<=1 ; wx++)
				{
					temp =(int) imgSrc[y+wy][x+wx] ; 
					sum +=temp*(mask[wy+1][wx+1]/9) ; 
				}
				
			}
			if(sum<0) sum= 0 ; 
			else if( sum>255) sum=255 ; 

			imgDst[y][x] = (BYTE)sum ;
			sum=0;
	 
		}
	}

	Dump(imgDst);
	DeleteTempBuffer(imgDst);
	return TRUE ; 
}



float CImageObject::GaborFilter(long x, long y, float theta, float freq)
{
	static double deltaXsquare = 20.0;
	static double deltaYsquare = 10.0;
	
	double xx = x*cos(theta) + y*sin(theta);
	double yy = -x*sin(theta) + y*cos(theta);
	
	double result = exp(-0.5*(xx*xx/deltaXsquare + yy*yy/deltaYsquare))*cos(2*_PI_*freq*xx);
	
	return (float)result;
}


*/



////////////////////////////////////////////////////////////////////////////////////////////////////

/**************************************************************
* Functions :	 Լ
*
* History : 2005. 06. 20
* Modified: 2008. 07. 2,  H.C.H
*****************************************************************/


void CImageProc::ApplyDblMask(CImageObj &imgSrc,CImageObj &imgDst,int *mask1,int *mask2,int len,float scale,float offset)
{
	//if(imgSrc.m_ColorMode==IDM_RGB) return;	// ׷̿ 밡

	int x,y,i,j;
	int value1=0, value2=0,sum=0;
	int color,col;
	color = imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
		for(y=len/2; y<imgSrc.m_Height-len/2; y++)
		{
			for(x=len/2; x<imgSrc.m_Width-len/2; x++)
			{
				value1=0;
				value2=0;
				for(i=0;i<len;i++)
				{
					for(j=0;j<len;j++)
					{
						value1 += imgSrc[ y-len/2+j ][ (x-len/2+i)*color+col ] * mask1[i+j*len];
						value2 += imgSrc[ y-len/2+j ][ (x-len/2+i)*color+col ] * mask2[i+j*len];
					}
				}

				sum=abs(value1)+abs(value2);
				//sum=sqrt(value1*value1+value2*value2);

				imgDst[y][x*color+col]=max(min(sum*scale+offset,255),0);
			}
		}
	}
}

void CImageProc::ApplySglMask(CImageObj &imgSrc,CImageObj &imgDst,int *mask,int len,float scale,float offset)
{
	//if(imgSrc.m_ColorMode==IDM_RGB) return;	// ׷̿ 밡

	int x,y,i,j;
	float sum;
	int color,col;
	color = imgSrc.m_ColorMode/8;

	for(col=0;col<color;col++)
	{
		for(y=len/2; y<imgSrc.m_Height-len/2; y++)
		{
			for(x=len/2; x<imgSrc.m_Width-len/2; x++)
			{
				sum=0;
				for(i=0;i<len;i++)
				{
					for(j=0;j<len;j++)
					{
						sum += imgSrc[ y-len/2+j ][ (x-len/2+i)*color+col ] * mask[i+j*len];
					}
				}

				sum=fabs(sum);
				//if(value>255) sum=255;

				imgDst[y][x*color+col]=max(min(sum*scale+offset,255),0);
			}
		}
	}
}

// Sobel
BOOL CImageProc::CvtEdgeSobel(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int mask1[9]={-1,0,1,-2,0,2,-1,0,1};
	int mask2[9]={1,2,1,0,0,0,-1,-2,-1};
	//float scale = 1.0f/(4*1.414f);
	float scale = 1;
	float offset = 0;

	ApplyDblMask(imgSrc,imgDst,mask1,mask2,3,scale,offset);

	return TRUE;
}

// Prewitte
BOOL CImageProc::CvtEdgePrewitte(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int mask1[9]={-1,0,1,-1,0,1,-1,0,1};
	int mask2[9]={1,1,1,0,0,0,-1,-1,-1};
	//float scale = 1.0f/(3*1.414f);
	float scale = 1;
	float offset=0;

	ApplyDblMask(imgSrc,imgDst,mask1,mask2,3,scale,offset);

	return TRUE;
}

// Robert
BOOL CImageProc::CvtEdgeRobert(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int mask1[9]={0,0,-1,0,1,0,0,0,0};
	int mask2[9]={-1,0,0,0,1,0,0,0,0};
	float scale = 1.0f;
	float offset = 0;

	ApplyDblMask(imgSrc,imgDst,mask1,mask2,3,scale,offset);

	return TRUE;
}

// Laplacian
BOOL CImageProc::CvtEdgeLaplacian(CImageObj &imgSrc,CImageObj &imgDst,int mode)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;
	if(mode<0 || mode>3) mode=3;

	int mask[4][9] = {
		{ 0,-1, 0,-1, 4,-1, 0,-1, 0},	// 4 Laplacian ũ
		{ 0, 1, 0, 1,-4, 1, 0, 1, 0},	// 4 bi-Laplacian ũ
		{-1,-1,-1,-1, 8,-1,-1,-1,-1},	// 8 Laplacian ũ
		{ 1,-2, 1,-2, 4,-2, 1,-2, 1}	// 8 bi-Laplacian ũ
	};
	//float scale=1./(8*2);
	float scale = 1.0f;
	float offset=0;

	ApplySglMask(imgSrc,imgDst,mask[mode],3,scale,offset);

	return TRUE;
}

// Gaussian Smoothing
BOOL CImageProc::CvtGaussianSmoothing3(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int mask[9]={1,2,1,2,4,2,1,2,1};
	float scale=1./(4+8+4);
	//float scale=1;
	float offset=0;

	ApplySglMask(imgSrc,imgDst,mask,3,scale,offset);

	return TRUE;
}

BOOL CImageProc::CvtGaussianSmoothing5(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int mask[25]={
		1,1,2,1,1,
		1,2,4,2,1,
		2,4,8,4,2,
		1,2,4,2,1,
		1,1,2,1,1};

	float scale=1.0f/32.0f;
	//float scale=1;
	float offset=0;

	ApplySglMask(imgSrc,imgDst,mask,5,scale,offset);

	return TRUE;
}

// Laplacian of Gaussian
BOOL CImageProc::CvtEdgeLoG(CImageObj &imgSrc,CImageObj &imgDst,int mode)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	CImageObj imgTmp;
	imgTmp.AllocBuff(imgSrc);

	// þ 
	CvtGaussianSmoothing3(imgSrc,imgTmp);

	// öþ 
	CvtEdgeLaplacian(imgTmp,imgDst,mode);

	return TRUE;
}


//  ũν ˰ Լ
/*	Gaussian	*/
float gauss(float x, float sigma)
{
    return (float)exp((double) ((-x*x)/(2*sigma*sigma)));
}

float LoG (float x, float sigma)
{
	float x1;

	x1 = gauss (x, sigma);
	return (x*x-2*sigma*sigma)/(sigma*sigma*sigma*sigma) * x1;
}

float **f2d(int nc,int nr)
{
	int i;
	float **p2d;
	p2d = new float*[nr];
	for(i=0;i<nr;i++) p2d[i] = new float[nc];
	return p2d;
}

void freef2d(float** p2d,int nr)
{
	int i;
	for(i=0;i<nr;i++) delete [] p2d[i];
	delete [] p2d;
}

void convolution (CImageObj &imgSrc, float **mask, int nr, int nc, float **res)
{
	int i,j,ii,jj, n, m, k, kk;
	float x;

	k = nr/2; kk = nc/2;
	for (i=0; i<imgSrc.m_Height; i++)
	{
	  for (j=0; j<imgSrc.m_Width; j++)
	  {
	    x = 0.0;
	    for (ii=0; ii<nr; ii++)
	    {
	      n = i - k + ii;
	      if (n<0 || n>=imgSrc.m_Height) continue;
	      for (jj=0; jj<nc; jj++)
	      {
		m = j - kk + jj;
		if (m<0 || m>=imgSrc.m_Width) continue;
		x += mask[ii][jj] * (float)(imgSrc[n][m]);
	      }
	    }
	    res[i][j] = x;
	  }
	}
}

float norm (float x, float y)
{
	return (float) sqrt ( (double)(x*x + y*y) );
}

float distance (float a, float b, float c, float d)
{
	return norm ( (a-c), (b-d) );
}

void zero_cross (float **lapim,CImageObj &imgDst)
{
	int i,j;//,k,n,m, dx, dy;
	//float x, y, z;
	//int xi,xj,yi,yj, count = 0;

	for (i=1; i<imgDst.m_Height-1; i++)
	  for (j=1; j<imgDst.m_Width-1; j++)
	  {
	    imgDst[i][j] = 0;
	    if(lapim[i-1][j]*lapim[i+1][j]<0) {imgDst[i][j]=255; continue;}
	    if(lapim[i][j-1]*lapim[i][j+1]<0) {imgDst[i][j]=255; continue;}
	    if(lapim[i+1][j-1]*lapim[i-1][j+1]<0) {imgDst[i][j]=255; continue;}
	    if(lapim[i-1][j-1]*lapim[i+1][j+1]<0) {imgDst[i][j]=255; continue;}
	  }
}

// Zero Crossing
BOOL CImageProc::CvtEdgeZeroCross(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int width;
	float **smx;
	int i,j,n;
	float **lgau;
	float s=1.0f-0.7f;
	//float s=1.0+0.8;
	// Convolution of source image with a Gaussian in X and Y directions
	//smx = f2d (imgSrc.m_Height, imgSrc.m_Width);
	//CImageObj smx;
	//smx.AllocBuff(imgSrc.m_Width,imgSrc.m_Height,IDM_GRAY);
	smx = f2d(imgSrc.m_Width,imgSrc.m_Height);

	// Create a Gaussian and a derivative of Gaussian filter mask
	width = 3.35*s + 0.33;
	n = width+width + 1;
	//printf ("Smoothing with a Gaussian of size %dx%d\n", n, n);
	lgau = f2d(n,n);

	for (i=0; i<n; i++)
	  for (j=0; j<n; j++)
	    lgau[i][j] = LoG (distance ((float)i, (float)j,(float)width, (float)width), s);

	// Convolution with LoG
	convolution (imgSrc, lgau, n, n, smx);

	// Locate the zero crossings
	//printf ("Zero crossings:\n");
	zero_cross (smx, imgDst);

	// Clear the boundary
/*	for (i=0; i<imgDst.m_Height; i++)
	{
	  for (j=0; j<=width; j++) imgDst[i][j] = 0;
	  for (j=imgDst.m_Width-width-1; j<imgDst.m_Width; j++) imgDst[i][j] = 0;
	}
	for (j=0; j<imgDst.m_Width; j++)
	{
	  for (i=0; i<= width; i++) imgDst[i][j] = 0;
	  for (i=imgDst.m_Height-width-1; i<imgDst.m_Height; i++) imgDst[i][j] = 0;
	}
*/
	freef2d(smx,imgSrc.m_Height);
	freef2d(lgau,n);

	return TRUE;
}

// Canny
BOOL CImageProc::CvtEdgeCanny(CImageObj &imgSrc,CImageObj &imgDst,int threshold,int mode)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;
	if(mode<0 || mode>2) mode=0;

	CImageObj imgTmp,imgTmp2;
	imgTmp.AllocBuff(imgSrc);
	imgTmp2.AllocBuff(imgSrc);

	//Step1 : Smoothed by Gaussian Convolution
	//int mask[25]={2,4,5,4,2, 4,9,12,9,4, 5,12,15,12,5, 4,9,12,9,4, 2,4,5,4,2 };
	//ApplySglMask(imgSrc,imgTmp,mask,5,1.0f/115.0f,0);

	// þ 
	CvtGaussianSmoothing5(imgSrc,imgTmp);

	//Step2 : Edge Detector with Sobel Filter
	//int mask1[9]={-1,0,1,-2,0,2,-1,0,1};
	//int mask2[9]={1,2,1,0,0,0,-1,-2,-1};
	//ApplyDblMask(imgTmp,imgTmp2,mask1,mask2,3,1.0f,0);
	
	switch(mode)
	{
	case 0:	CvtEdgeSobel(imgTmp,imgTmp2); break;
	case 1:	CvtEdgePrewitte(imgTmp,imgTmp2); break;
	case 2: CvtEdgeRobert(imgTmp,imgTmp2); break;
	}
	
	//Step3 : Lower and Upper value whit Threshold
	ApplyBIN(imgTmp2,imgDst,threshold,255);

	return TRUE;
}

// ȭ
BOOL CImageProc::CvtThinning(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,i,j;
	long flag, Dx;
	unsigned char N[9];
	
//	Binary(Thres);
//	Invert();
	
	BYTE **TMP = BitMask(imgSrc,1);
	BYTE **CNT = MakeTempBuffer(imgSrc);
	BYTE **DMT = MakeTempBuffer(imgSrc);
	BYTE **EMT = MakeTempBuffer(imgSrc);
	
	
	do{
		flag = 0;
		for(Dx = 0 ; Dx < 4 ; Dx++)
		{
			//////////////////////////////////////////////
			// ȭϱ   ȹ ( Ἲ   template ȿ  ִ ȼ  )
			for(j= 1 ; j < imgSrc.m_Height-1 ; j++)	
				for(i= 1 ; i < imgSrc.m_Width-1 ; i++)
				{	
					if(imgSrc[j][i])
					{
						N[0] = imgSrc[j][i];		N[1] = imgSrc[j][i+1];	N[2] = imgSrc[j-1][i+1];
						N[3] = imgSrc[j-1][i];	N[4] = imgSrc[j-1][i-1];	N[5] = imgSrc[j][i-1];
						N[6] = imgSrc[j+1][i-1];	N[7] = imgSrc[j+1][i];	N[8] = imgSrc[j+1][i+1];
						// Ἲ ˻ 
						CNT[j][i] = N[1] - N[1]*N[2]*N[3]+ 
							N[3] - N[3]*N[4]*N[5]+ 
							N[5] - N[5]*N[6]*N[7]+ 
							N[7] - N[7]*N[8]*N[1];
						
						//
						EMT[j][i] = N[1] + N[2] + N[3] + N[4] + N[5] + N[6] + N[7] + N[8];
					}
					else
					{
						CNT[j][i] = 0;
						EMT[j][i] = 0;
					}
				}
				ClearData(imgSrc, DMT) ;
				//////////////////////////////////////////////////////////
				// template M1-M4   
				//////////////////////////////////////////////////////////
				for(j = 1 ; j < imgSrc.m_Height-1 ; j++)
					for(i= 1 ; i < imgSrc.m_Width-1 ; i++)
					{
						if(imgSrc[j][i] && (EMT[j][i] !=  1) && (CNT[j][i] == 1))
						{
							switch(Dx)
							{
							case 0:
								if(!imgSrc[j - 1][i] && imgSrc[j + 1][i])
								{
									DMT[j][i] = 1;
								}
								break;
							case 1:
								if(!imgSrc[j + 1][i] && imgSrc[j - 1][i])
								{
									DMT[j][i] = 1;
								}
								break;
							case 2:
								if(!imgSrc[j][i - 1] && imgSrc[j][i + 1])
								{
									DMT[j][i] = 1;
								}
								break;
							case 3:
								if(!imgSrc[j][i + 1] && imgSrc[j][i - 1])
								{
									DMT[j][i] = 1;
								}
								break;
							}
						}
					}
					for(y = 0 ; y < imgSrc.m_Height ; y++)	
						for(x = 0 ; x < imgSrc.m_Width ; x++)
						{	
							if(DMT[y][x])
							{
								imgSrc[y][x] = 0;
								flag++;
							}
						}
		}
	}while(flag);
	
	
	
	///////////////////
	for(y = 0 ; y < imgSrc.m_Height ; y++)
	{
		for(x = 0 ; x < imgSrc.m_Width ; x++)
		{
				if(imgSrc[y][x])
				imgSrc[y][x] = 255;
			else
				imgSrc[y][x] = 0;
			//imgSrc[y][x]=imgSrc[y][x]*=255;
		}
	}
	
	DeleteTempBuffer(TMP) ; 
	DeleteTempBuffer(CNT);
	DeleteTempBuffer(DMT) ;
	DeleteTempBuffer(EMT) ;

	return TRUE;
}


// ȭ
BOOL CImageProc::CvtThinningGray(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,i,j;
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	//BYTE **In, **Out;
	//xs,Xe,Ys,Ye;
	long count,T[9],trans,m,OK,turn=0;

	//In = imgSrc;
	//Out = imgDst;
	//Xs = 0;
	//Xe = imgSrc.m_Width;
	//Ys = 0;
	//Ye = imgSrc.m_Height;

	//x,y;
	for(y=0;y<imgSrc.m_Height;y++) for(x=0;x<imgSrc.m_Width;x++) imgDst[y][x]=0;

	do
	{
		OK=1;
		turn=(turn+1)%2;
		for(y=0+1;y<imgSrc.m_Height-1;y++) for(x=0+1;x<imgSrc.m_Width-1;x++)	
		if(imgSrc[y][x]==255)
		{
			count=0;
			for(i=-1;i<=1;i++) for(j=-1;j<=1;j++) if(imgSrc[y+j][x+i]==255) count++;
			if((count>2)&&(count<8))
			{
				T[0]=imgSrc[y-1][x-1];
				T[1]=imgSrc[y-1][x];
				T[2]=imgSrc[y-1][x+1];
				T[3]=imgSrc[y][x+1];
				T[4]=imgSrc[y+1][x+1];
				T[5]=imgSrc[y+1][x];
				T[6]=imgSrc[y+1][x-1];
				T[7]=imgSrc[y][x-1];
				T[8]=imgSrc[y-1][x-1];
				trans=0;
				for(m=0;m<=7;m++) if(T[m]==0 && T[m+1]==255) trans++;
				if(trans==1)
					if(turn==0 && (T[3]==0 || T[5]==0 || (T[1]==0 && T[7]==0)))
					{
						imgDst[y][x]=1;
						OK=0;
					} else 
					if(turn==1 && (T[1]==0 || T[7]==0 || (T[3]==0 && T[5]==0)))
					{
						imgDst[y][x]=1;
						OK=0;
					}		
			}
		}
		for(y=0;y<imgSrc.m_Height;y++) for(x=0;x<imgSrc.m_Width;x++) 
		{
			if(imgDst[y][x]==1) 
			{
				imgSrc[y][x] = imgDst[y][x]=0;
			}
		}
	} while(OK==0);

	return TRUE;
}

// ȭ Slow Motion
BOOL CImageProc::CvtThinningSlowGray(CImageObj &imgSrc,CImageObj &imgDst) 
{
	int x,y,i,j;
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	//BYTE **In, **Out;
	//xs,Xe,Ys,Ye;
	//long i,j,x,y;
	long count,T[9],trans,m,OK,turn=0;

	//In = imgSrc;
	//Out = imgDst;
	//Xs = 0;
	//Xe = imgSrc.m_Width;
	//Ys = 0;
	//Ye = imgSrc.m_Height;

	do
	{
		turn = (turn+1)%2;

		OK=1;
		for(y=0+1;y<imgSrc.m_Height-1;y++) for(x=0+1;x<imgSrc.m_Width-1;x++) 
		{
			if(imgSrc[y][x]==255)
			{
				count=0;
				for(i=-1;i<=1;i++) for(j=-1;j<=1;j++) 
				{ 
					if(imgSrc[y+j][x+i]==255) count++; 
				}
				if((count>2)&&(count<8))
				{
					T[0] = imgSrc[y-1][x-1];
					T[1] = imgSrc[y-1][x+0];
					T[2] = imgSrc[y-1][x+1];
					T[3] = imgSrc[y+0][x+1];
					T[4] = imgSrc[y+1][x+1];
					T[5] = imgSrc[y+1][x+0];
					T[6] = imgSrc[y+1][x-1];
					T[7] = imgSrc[y+0][x-1];
					T[8] = imgSrc[y-1][x-1];
					trans=0;
					for(m=0;m<=7;m++) if(T[m]==0 && T[m+1]==255) trans++;
					if(trans==1) {
						if(turn==0 && (T[3]==0 || T[5]==0 || (T[1]==0 && T[7]==0)))
						{
							imgDst[y][x]=1;
							OK=0;
						} 
						else if(turn==1 && (T[1]==0 || T[7]==0 || (T[3]==0 && T[5]==0)))
						{
							imgDst[y][x]=1;
							OK=0;
						}
					}
				}
			}
		}
		for(y=0;y<imgSrc.m_Height;y++) for(x=0;x<imgSrc.m_Width;x++) 
		{
			if(imgDst[y][x]==1) 
			{
				imgSrc[y][x]=imgDst[y][x]=0;
			}
		}

	} while(OK==0);

	return TRUE;
}

// Thinning algorithm: CACM 1984 march (Zhang and Suen)
// http://pages.cpsc.ucalgary.ca/~parker/soft.htm
BOOL CImageProc::CvtThinningZhangSuen(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int xx,yy;
	xx=imgSrc.m_Width;
	yy=imgSrc.m_Height;

	int i,j, cont, br,ar,p1,p2;
	int a[8];

	CImageObj imgTmp;
	imgTmp.AllocBuff(xx,yy,IDM_RGB);

	//  0,1 ٲ۴.
	for (i=0; i<yy; i++)
	{
		for (j=0; j<xx; j++) 
		{		
			imgDst[i][j] = (imgSrc[i][j]>100)?1:0;
		}
	}

	cont = 1;
	while (cont) 
	{
		cont = 0;

		// Sub-iteration 1:
		for (i=0; i<yy; i++)	// Scan the entire image
		{
			for (j=0; j<xx; j++) 
			{		
				if (imgDst[i][j] == 0) 
				{
					imgTmp[i][j] = 0;
					continue;
				}
				ar = t1a(imgDst, i, j, a, &br,xx,yy);	/* Function A */
				p1 = a[0]*a[2]*a[4];
				p2 = a[2]*a[4]*a[6];

				// step 1 : Pixel P    1 ̾ Ѵ. 
				// step 2 : Pixel P  2 ̻ ̿ Pixel 6  Pixel ̿Ͽ Ѵ. 
				// step 3 : Pixel P  I(i, j+1), I(i+1, j), I(i, j-1)߿   Pixel ̾ Ѵ 
				// step 4 : Pixel P  I(i-1, j), I(i+1, j), I(i, j-1)߿   Pixel ̾ Ѵ 
				if ( (ar == 1) && ((br>=2) && (br<=6)) && (p1 == 0) && (p2 == 0) )  
				{
					imgTmp[i][j] = 1;
					cont = 1;
				}
				else imgTmp[i][j] = 0;
			}
		}
		for (i=0; i<yy; i++) for (j=0; j<xx; j++) imgDst[i][j] -= imgTmp[i][j];

		// Sub iteration 2:
		for (i=0; i<yy; i++)	// Scan the entire image 
		{
			for (j=0; j<xx; j++) 
			{
				if (imgDst[i][j] == 0) 
				{
					imgTmp[i][j] = 0;
					continue;
				}
				ar = t1a (imgDst, i, j, a, &br,xx,yy);	/* Function A */
				p1 = a[0]*a[2]*a[6];
				p2 = a[0]*a[4]*a[6];
				// step 1-2:  ϰ, 
				// step 3 : Pixel P    I(i-1, j), I(i, j+1), I(i+1, j) ߿     Pixel   ̾  Ѵ 
				// step 4 : Pixel P    I(i, j+1), I(i-1, j), I(i, j-1) ߿     Pixel   ̾  Ѵ 
				if ( (ar == 1) && ((br>=2) && (br<=6)) && (p1 == 0) && (p2 == 0) )  
				{
					imgTmp[i][j] = 1;
					cont = 1;
				}
				else imgTmp[i][j] = 0;
			}
		}
		for (i=0; i<yy; i++) for (j=0; j<xx; j++) imgDst[i][j] -= imgTmp[i][j];
	}


	//  0,255 ٲ۴.
	for (i=0; i<yy; i++)
	{
		for (j=0; j<xx; j++) 
		{		
			imgDst[i][j] = (imgDst[i][j]>=1)?255:0;
		}
	}
	
	return TRUE;
}


/* [ a0 a4 
 * [ a1 a5
 * [ a2 a6 
 */

int CImageProc::t1a(CImageObj &imgSrc,int i,int j,int *a,int *b,int xx,int yy)
{
	// Return the number of 01 patterns in the sequence of pixels p2 p3 p4 p5 p6 p7 p8 p9.

	int n,m;

	for (n=0; n<8; n++) a[n] = 0;


	if (i-1 >= 0) 
	{
		a[0] = imgSrc[i-1][j];
		if (j+1 < yy) a[1] = imgSrc[i-1][j+1];
		if (j-1 >= 0) a[7] = imgSrc[i-1][j-1];
	}

	if (i+1 < yy) 
	{
		a[4] = imgSrc[i+1][j];
		if (j+1 < yy) a[3] = imgSrc[i+1][j+1];
		if (j-1 >= 0) a[5] = imgSrc[i+1][j-1];
	}

	if (j+1 < xx) a[2] = imgSrc[i][j+1];
	if (j-1 >= 0) a[6] = imgSrc[i][j-1];

	m= 0;	*b = 0;
	for (n=0; n<7; n++) 
	{
		if (a[n]==0 && a[n+1]==1) m++;
		*b = *b + a[n];
	}
	if (a[7] == 0 && a[0] == 1) m++;
	*b = *b + a[7];

	return m;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Stentiford
BOOL CImageProc::CvtThinningStentiford_LOM(CImageObj &imgSrc,CImageObj &imgDst)
{
	long x, y, j, i, flag, Dx;
	unsigned char N[9];
	
	CImageObj CNT,DMT,EMT;
	CNT.AllocBuff(imgSrc.m_Width,imgSrc.m_Height,IDM_GRAY);
	DMT.AllocBuff(imgSrc.m_Width,imgSrc.m_Height,IDM_GRAY);
	EMT.AllocBuff(imgSrc.m_Width,imgSrc.m_Height,IDM_GRAY);

	for(y=0;y<imgSrc.m_Height;y++)
	{
		for(x=0;x<imgSrc.m_Width;x++)
		{
			imgDst[y][x] = (imgSrc[y][x]>128)?1:0;
		}
	}

	do{
		flag = 0;
		for(Dx = 0 ; Dx < 4 ; Dx++)
		{

			// ȭϱ   ȹ ( Ἲ   template ȿ  ִ ȼ  )
			/*
			 *	N4 N3 N2
			 *  N5 N0 N1
			 *  N6 N7 N8
			 */
			for(j = 1 ; j < imgDst.m_Height-1 ; j++)	
			{
				for(i = 1 ; i < imgDst.m_Width-1 ; i++)
				{	
					if(imgDst[j][i])
					{
						N[0] = imgDst[j][i];		N[1] = imgDst[j][i+1];		N[2] = imgDst[j-1][i+1];
						N[3] = imgDst[j-1][i];		N[4] = imgDst[j-1][i-1];	N[5] = imgDst[j][i-1];
						N[6] = imgDst[j+1][i-1];	N[7] = imgDst[j+1][i];		N[8] = imgDst[j+1][i+1];
						
						// Ἲ ˻ 
						CNT[j][i] =		N[1] - N[1]*N[2]*N[3]
									+ 	N[3] - N[3]*N[4]*N[5]
									+	N[5] - N[5]*N[6]*N[7]
									+	N[7] - N[7]*N[8]*N[1];
						// ø ȼ
						EMT[j][i] = N[1] + N[2] + N[3] + N[4] + N[5] + N[6] + N[7] + N[8];
					}
					else
					{
						CNT[j][i] = 0;
						EMT[j][i] = 0;
					}
				}
			}

			//////////////////////////////////////////////////////////
			// template M1-M4  
			//////////////////////////////////////////////////////////
			DMT.Empty();
			for(j = 1 ; j < imgDst.m_Height-1 ; j++)
			{
				for(i = 1 ; i < imgDst.m_Width-1 ; i++)
				{
					if(imgDst[j][i] && EMT[j][i] !=  1 && CNT[j][i] == 1)
					{
						switch(Dx)
						{
						case 0: if(!imgDst[j-1][i] && imgDst[j+1][i]) DMT[j][i] = 1; break;
						case 1: if(!imgDst[j+1][i] && imgDst[j-1][i]) DMT[j][i] = 1; break;
						case 2: if(!imgDst[j][i-1] && imgDst[j][i+1]) DMT[j][i] = 1; break;
						case 3: if(!imgDst[j][i+1] && imgDst[j][i-1]) DMT[j][i] = 1; break;
						}
					}
				}
			}

			// ȼ 
			for(y = 0 ; y < imgDst.m_Height ; y++)	
			{
					for(x = 0 ; x < imgDst.m_Width ; x++)
					{	
						if(DMT[y][x])
						{
							imgDst[y][x] = 0;
							flag++;
						}
					}
			}
		}
	}while(flag);

	// ð Ѵ.
	for( j = 1 ; j < imgDst.m_Height-1 ; j++ )
	{
		for( i = 1 ; i < imgDst.m_Width-1 ; i++)
		{
			if( imgDst[j][i] )
			{
				N[0] = imgDst[j][i];		N[1] = imgDst[j][i+1];		N[2] = imgDst[j-1][i+1];
				N[3] = imgDst[j-1][i];		N[4] = imgDst[j-1][i-1];	N[5] = imgDst[j][i-1];
				N[6] = imgDst[j+1][i-1];	N[7] = imgDst[j+1][i];		N[8] = imgDst[j+1][i+1];
				
				if((N[1] && N[3] && !N[6]) || (N[3] && N[5] && !N[8]) || (N[5] && N[7] && !N[2]) || (N[7] && N[1] && !N[4]))
					imgDst[j][i] = 0;
			}
		}
	}
	
	//  
	for(y = 0 ; y < imgDst.m_Height ; y++)
	{
		for(x = 0 ; x < imgDst.m_Width ; x++)
		{
			imgDst[y][x] = (imgDst[y][x]==1)?255:0;
		}
	}
	
	

	return TRUE;
}

int CImageProc::nays8 (CImageObj &imgSrc, int r, int c)
{
	int i,j,k=0;

	for (i=r-1; i<=r+1; i++)
	  for (j=c-1; j<=c+1; j++)
	    if (i!=r || c!=j)
	      if (imgSrc[i][j] == 0) k++;
	return k;
}

int CImageProc::Yokoi (CImageObj &imgSrc, int r, int c)
{
	int N[9];
	int i,k, i1, i2;

	N[0] = imgSrc[r][c]      != 0;
	N[1] = imgSrc[r][c+1]    != 0;
	N[2] = imgSrc[r-1][c+1]  != 0;
	N[3] = imgSrc[r-1][c]    != 0;
	N[4] = imgSrc[r-1][c-1]  != 0;
	N[5] = imgSrc[r][c-1]    != 0;
	N[6] = imgSrc[r+1][c-1]  != 0;
	N[7] = imgSrc[r+1][c]    != 0;
	N[8] = imgSrc[r+1][c+1]  != 0;

	k = 0;
	for (i=1; i<=7; i+=2)
	{
	  i1 = i+1; if (i1 > 8) i1 -= 8;
	  i2 = i+2; if (i2 > 8) i2 -= 8;
	  k += (N[i] - N[i]*N[i1]*N[i2]);
	}

/*	if (DEBUG)
	{
	  printf ("Yokoi: (%d,%d)\n",r, c);
	  printf ("%d %d %d\n", imgSrc[r-1][c-1], imgSrc[r-1][c],
			imgSrc[r-1][c+1]);
	  printf ("%d %d %d\n", imgSrc[r][c-1], imgSrc[r][c],
			imgSrc[r][c+1]);
	  printf ("%d %d %d\n", imgSrc[r+1][c-1], imgSrc[r+1][c],
			imgSrc[r+1][c+1]);
	  for (i=0; i<9; i++) printf ("%2d ", N[i]);
	  printf ("\n");
	  printf ("Y = %d\n", k);
	}
*/
	return k;
}

void CImageProc::pre_smooth (CImageObj &imgSrc,CImageObj &imgDst)
{
	int i,j;

	for (i=1; i<imgSrc.m_Height-1; i++)
	  for (j=1; j<imgSrc.m_Width-1; j++)
	    if (imgSrc[i][j] == 0)
		if (nays8(imgSrc, i, j) <= 2 && Yokoi (imgSrc, i, j)<2) imgDst[i][j] = 2;

	for (i=0; i<imgSrc.m_Height; i++)
	  for (j=0; j<imgSrc.m_Width; j++)
	    if (imgSrc[i][j] == 2) imgDst[i][j] = 1;
}

void CImageProc::match_du (CImageObj &imgSrc,CImageObj &imgDst, int r, int c, int k)
{

/* D1 */
	if (imgSrc[r-2][c-2] == 0 && imgSrc[r-2][c-1] == 0 &&
	    imgSrc[r-2][c]   == 1 && imgSrc[r-2][c+1] == 0 &&
	    imgSrc[r-2][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 1 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 0 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 0 && imgSrc[r+2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* D2 */
	if (k >= 2)
	if (imgSrc[r-2][c-2] == 0 && imgSrc[r-2][c-1] == 1 &&
	    imgSrc[r-2][c]   == 1 && imgSrc[r-2][c+1] == 0 &&
	    imgSrc[r-2][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 1 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 0 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 0 && imgSrc[r+2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* D3 */
	if (k>=3)
	if (imgSrc[r-2][c-2] == 0 && imgSrc[r-2][c-1] == 0 &&
	    imgSrc[r-2][c]   == 1 && imgSrc[r-2][c+1] == 1 &&
	    imgSrc[r-2][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 1 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 0 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 0 && imgSrc[r+2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* D4 */
	if (k>=4)
	if (imgSrc[r-2][c-2] == 0 && imgSrc[r-2][c-1] == 1 &&
	    imgSrc[r-2][c]   == 1 && imgSrc[r-2][c+1] == 0 &&
	    imgSrc[r-2][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 1 &&
	    imgSrc[r-1][c]   == 1 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 0 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 0 && imgSrc[r+2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* D5 */
	if (k>=5)
	if (imgSrc[r-2][c-2] == 0 && imgSrc[r-2][c-1] == 0 &&
	    imgSrc[r-2][c]   == 1 && imgSrc[r-2][c+1] == 1 &&
	    imgSrc[r-2][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 1 && imgSrc[r-1][c+1] == 1 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 0 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 0 && imgSrc[r+2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* U1 */
	if (imgSrc[r+2][c-2] == 0 && imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 1 && imgSrc[r+2][c+1] == 0 &&
	    imgSrc[r+2][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 1 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 0 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 0 && imgSrc[r-1][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* U2 */
	if (k>=2)
	if (imgSrc[r+2][c-2] == 0 && imgSrc[r+2][c-1] == 1 &&
	    imgSrc[r+2][c]   == 1 && imgSrc[r+2][c+1] == 0 &&
	    imgSrc[r+2][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 1 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 0 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r-2][c-1] == 0 &&
	    imgSrc[r-2][c]   == 0 && imgSrc[r-2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* U3 */
	if (k>=3)
	if (imgSrc[r+2][c-2] == 0 && imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 1 && imgSrc[r+2][c+1] == 1 &&
	    imgSrc[r+2][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 1 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 0 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r-2][c-1] == 0 &&
	    imgSrc[r-2][c]   == 0 && imgSrc[r-2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* U4 */
	if (k>=4)
	if (imgSrc[r+2][c-2] == 0 && imgSrc[r+2][c-1] == 1 &&
	    imgSrc[r+2][c]   == 1 && imgSrc[r+2][c+1] == 0 &&
	    imgSrc[r+2][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 1 &&
	    imgSrc[r+1][c]   == 1 && imgSrc[r+1][c+1] == 0 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 0 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r-2][c-1] == 0 &&
	    imgSrc[r-2][c]   == 0 && imgSrc[r-2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}

/* U5 */
	if (k>=5)
	if (imgSrc[r+2][c-2] == 0 && imgSrc[r+2][c-1] == 0 &&
	    imgSrc[r+2][c]   == 1 && imgSrc[r+2][c+1] == 1 &&
	    imgSrc[r+2][c+2] == 0 &&
	    imgSrc[r+1][c-2] == 0 && imgSrc[r+1][c-1] == 0 &&
	    imgSrc[r+1][c]   == 1 && imgSrc[r+1][c+1] == 1 &&
	    imgSrc[r+1][c+2] == 0 &&
	    imgSrc[r][c-2] == 0 && imgSrc[r][c-1] == 0 &&
	    imgSrc[r][c]   == 0 && imgSrc[r][c+1] == 0 &&
	    imgSrc[r][c+2] == 0 &&
	    imgSrc[r-1][c-2] == 0 && imgSrc[r-1][c-1] == 0 &&
	    imgSrc[r-1][c]   == 0 && imgSrc[r-1][c+1] == 0 &&
	    imgSrc[r-1][c+2] == 0 &&
	    imgSrc[r-2][c-1] == 0 &&
	    imgSrc[r-2][c]   == 0 && imgSrc[r-2][c+1] == 0 )
	{
		imgDst[r][c] = 2;
		return;
	}
}

void CImageProc::aae (CImageObj &imgSrc,CImageObj &imgDst)
{
	int i,j, again = 0, k;

	again = 0;
	for (k=5; k>= 1; k-=2)
	{
	  for (i=2; i<imgSrc.m_Height-2; i++)
	    for (j=2; j<imgSrc.m_Width-2; j++)
	      if (imgSrc[i][j] == 0)
			match_du (imgSrc,imgDst, i, j, k);

	  for (i=2; i<imgSrc.m_Height-2; i++)
	    for (j=2; j<imgSrc.m_Width-2; j++)
	    if (imgSrc[i][j] == 2)
	    {
			again = 1;
			imgDst[i][j] = 1;
	    }

	  if (again == 0) break;
	} 
}


BOOL CImageProc::CvtThinningStentiford(CImageObj &imgSrc,CImageObj &imgDst)
{
	int i,j, again=1;


	pre_smooth (imgSrc,imgDst);
	aae (imgSrc,imgDst);


	/* BLACK = 0, WHITE = 1. */
	for (i=0; i<imgSrc.m_Height; i++)
	{
		for (j=0; j<imgSrc.m_Width; j++)
		{
			if (imgSrc[i][j] > 50) imgDst[i][j] = 1;
			else imgDst[i][j] = 0;
		}
	}	

	// ׵θ ׸.
	for (i=0; i<imgDst.m_Height; i++)
	{
	  imgDst[i][0] = 1;
	  imgDst[i][imgDst.m_Width-1] = 1;
	}
	for (j=0; j<imgDst.m_Width; j++)
	{
	  imgDst[0][j] = 1;
	  imgDst[imgDst.m_Height-1][j] = 1;
	}



	/* Mark and delete */
	while (again)
	{
		again = 0;

		/* Matching template M1 - scan top-bottom, left - right */
		for (i=1; i<imgDst.m_Height-1; i++)
			for (j=1; j<imgDst.m_Width-1; j++)
			  if (imgDst[i][j] == 0)
				if (imgDst[i-1][j] == 1 && imgDst[i+1][j] != 1)
				  if (nays8(imgDst, i, j) != 1  && Yokoi (imgDst, i, j) == 1) imgDst[i][j] = 2;

		/* Template M2 bottom-top, left-right */
		for (j=1; j<imgDst.m_Width-1; j++)
			for (i=imgDst.m_Height-2; i>=1; i--)
			  if (imgDst[i][j] == 0)
				if (imgDst[i][j-1] == 1 && imgDst[i][j+1] != 1)
				  if (nays8(imgDst, i, j) != 1  && Yokoi (imgDst, i, j) == 1) imgDst[i][j] = 2;

		/* Template M3 right-left, bottom-top */
		for (i=imgDst.m_Height-2; i>=1; i--)
			for (j=imgDst.m_Width-2; j>=1; j--)
			  if (imgDst[i][j] == 0)
				if (imgDst[i-1][j] != 1 && imgDst[i+1][j] == 1)
				  if (nays8(imgDst, i, j) != 1  && Yokoi (imgDst, i, j) == 1) imgDst[i][j] = 2;

		/* Template M4 */
		for (j=imgDst.m_Width-2; j>=1; j--)
			for (i=1; i<imgDst.m_Height-1; i++)
			  if (imgDst[i][j] == 0)
				if (imgDst[i][j-1] != 1 && imgDst[i][j+1] == 1)
				  if (nays8(imgDst, i, j) != 1  && Yokoi (imgDst, i, j) == 1) imgDst[i][j] = 2;

		/* Delete pixels that are marked (== 2) */
		for (i=1; i<imgDst.m_Height-1; i++)
		{
			for (j=1; j<imgDst.m_Width-1; j++)
			{
				if (imgDst[i][j] == 2)
				{
					imgDst[i][j] = 1;
					again = 1;
				}
			}
		}
	}

	for (i=1; i<imgDst.m_Height-1; i++)
	{
		for (j=1; j<imgSrc.m_Width-1; j++)
		{
			if (imgDst[i][j] > 0) imgDst[i][j] = 255;
		}
	}

	return TRUE;
}



// Hough Transform
BOOL CImageProc::CvtHoughTransform(CImageObj &imgSrc,CImageObj &imgHough,CImageObj &imgDst)
{
	PHOUGHLINE pline = new HOUGHLINE[MAX_HOUGH];
	int nline=0,i;

	CvtHoughImage(imgSrc,imgHough,pline,nline);

	//imgTmp=imgDst;
	//imgDst.Empty();
	//CvtInvHoughImage(imgHough,imgDst);

	imgDst=imgSrc;

	for(i=0;i<nline;i++)
	{
		DrawHoughLine(imgDst,pline[i].rho,pline[i].ang,pline[i].color);
	}

	//CString str;
	//str.Format(_T("ȯ( μ) : rho= %lf, ang=%lf"), rho,ang);
	//AfxMessageBox(str);

	delete [] pline;

	return TRUE;
}

// ȯ - óα׷ å -IT EXPERT
BOOL CImageProc::CvtHoughImage(CImageObj &imgSrc,CImageObj &imgDst,PHOUGHLINE pline,int &nline)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int x,y,c,r,w,h;
	int max;
	double	*SIN,*COS;

	w=imgSrc.m_Width;
	h=imgSrc.m_Height;

	int nRho=(int)(sqrt((double)(w*w+h*h))*2);
	int nAng=360;

	// ̺ 
	SIN = new double [nAng];
	COS = new double [nAng];
	for(x=0;x<nAng;x++)
	{
		SIN[x]=(double)sin(x*PI/nAng);
		COS[x]=(double)cos(x*PI/nAng);
	}

	//  
	int **pHuff = new int*[nRho];
	for(y=0;y<nRho;y++)
	{
		pHuff[y] = new int[nAng];
		memset(pHuff[y],0,sizeof(int)*nAng);
	}

	//  ȯ 
	for(y=0;y<h;y++) 
	{
		for(x=0;x<w;x++)
		{
			if(imgSrc[y][x]>128)
			{
				for(c=0;c<nAng;c++)
				{
					r = (int)floor( x*SIN[c]+y*COS[c]+0.5 );
					r += (nRho/2);
					pHuff[r][c]++;
				}
			}
		}
	}

	// ִ밪 ã
	max=0;
	for(r=0;r<nRho;r++) 
	{
		for(c=0;c<nAng;c++) 
		{
			if(max < pHuff[r][c] ) max=pHuff[r][c];
		}
	}
	
	//  Ѵ.
	for(r=0;r<nRho;r++) 
	{
		for(c=0;c<nAng;c++) 
		{
			x = (int) ((double) c * imgDst.m_Width / nAng);
			y = (int) ((double) r * imgDst.m_Height / nRho);
			imgDst[y][x]=pHuff[r][c]*255/max;
		}
	}
	// ׷ Ȱȭ
	CvHistoEqual(imgDst,imgDst);

	//  ã´.
	for(r=0;r<nRho;r++) 
	{
		for(c=0;c<nAng;c++) 
		{
			if(pHuff[r][c]>=max/2.0 && nline<MAX_HOUGH)
			{
				pline[nline].rho = r - nRho/2;
				pline[nline].ang = c * 180.0 / nAng;
				pline[nline].color = 255;
				nline++;
			}
		}
	}

	// ޸ 
	delete [] SIN;
	delete [] COS;
	for(y=0;y<nRho;y++) delete [] pHuff[y];
	delete [] pHuff;

	return TRUE;
}

// ȯ - óα׷ å -IT EXPERT
BOOL CImageProc::DrawHoughLine(CImageObj &imgSrc,float &rho,float &ang,int color)
{
	int x1,y1,x2,y2,tmp,x,y;
	double m;

	//  
	if(ang==90)
	{
		x1 = (int)(rho+0.5);
		for(y1=0;y1<imgSrc.m_Height;y1++) imgSrc[y1][x1] = color;
	}
	else 
	{
		x1=0;
		y1=(int)floor(rho/cos(ang*PI/180)+0.5);
		x2=imgSrc.m_Width-1;
		y2=(int)floor( (rho-x2*sin(ang*PI/180)) / cos(ang*PI/180) + 0.5);

		m = (double) (y2-y1) / (x2-x1);
		if( (m>-1) && (m<1) ) 
		{
			if( x1>x2)
			{
				tmp=x1; x1=x2; x2=tmp;
				tmp=y1; y1=y2; y2=tmp;
			}
			for(x=x1;x<x2;x++)
			{
				y = (int)floor(m*(x-x1) + y1 + 0.5);
				if(x>=0 && x<imgSrc.m_Width && y>=0 && y<imgSrc.m_Height) imgSrc[y][x]=color;
			}
		}
		else 
		{
			if(y1>y2)
			{
				tmp=x1; x1=x2; x2=tmp;
				tmp=y1; y1=y2; y2=tmp;
			}
			for(y=y1;y<y2;y++)
			{
				x = (int)floor(m*(y-y1) + x1 + 0.5);
				if(x>=0 && x<imgSrc.m_Width && y>=0 && y<imgSrc.m_Height) imgSrc[y][x]=color;
			}
		}
	}


	return TRUE;
}

/*
   ȯ ҽ  ߴ. (ΰ ҽ ſ ϴ)
	1.  LOM ҽ
	2.  ̷  ó  -  
*/
BOOL CImageProc::CvtHoughTransform2(CImageObj &imgSrc,CImageObj &imgHough,CImageObj &imgDst)
{
	CImageObj imgEdg(imgSrc),imgBin(imgSrc),imgHBin(imgSrc);
	//imgEdg.AllocBuff(imgSrc);
	//imgBin.AllocBuff(imgSrc);
	//imgHBin.AllocBuff(imgSrc);

	//ĳ  ϱ
	CvtEdgeCanny(imgSrc,imgEdg);

	//   ȭ ϱ
	ApplyBIN(imgEdg,imgBin,30);

	//  ȯ ϱ
	CvtHoughImage_LOM(imgBin,imgHough);

	// ȯ  ȭϱ
	ApplyBIN(imgHough,imgHBin,50);

	//  ȯ ϱ
	CvtInvHoughImage_LOM(imgBin,imgHBin,imgDst);

	return TRUE;
}

void CImageProc::CosSin(double *COS, double *SIN, int Len)
{
	double theta;
	int i;

	for(i=0;i<Len;i++)
	{
		theta= ((float)i*180.0f/(Len-1) - 90.0f)  * PI/180.0f;

		COS[i]=(double)cos((double)theta);
		SIN[i]=(double)sin((double)theta);
	}
}

// ȯϱ      Ѵ.
//  ĳ  ⸦ Ѵ.
BOOL CImageProc::CvtHoughImage_LOM(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int x,y,c,r,w,h;
	//WORD  max;
	double SQRTD;
	double	*SIN,*COS;

	w=imgSrc.m_Width;
	h=imgSrc.m_Height;

	SQRTD=sqrt((double)(w*w+h*h));

	// ̺ 
	SIN = new double [h];
	COS = new double [h];
	CosSin(COS,SIN,h);

	//  
	for(y=0;y<h;y++) 
	{
		for(x=0;x<w;x++)
		{
			if(imgSrc[y][x]==255)	//  ȯѴ.
			{
				for(r=0;r<h;r++)
				{
					c = (int)floor( ( (y*COS[r]+x*SIN[r]) + SQRTD ) / (SQRTD*2.0f) * (w-1) +0.5f );
					//if(r<0) r = abs(r)+SQRTD/2.0f;
					imgDst[r][c]++;
				}
			}
		}
	}

	/*
	// ִ밪 ã
	max=0;
	for(y=0;y<h;y++) 
	{
		for(x=0;x<w;x++) 
		{
			if(max < imgDst[y][x] ) 
			{
				max=imgDst[y][x];
				//rho = (float)y * SQRTD /(h-1) - SQRTD/2.0f;
				//ang = (float)x * 180.0f/(w-1);
			}
		}
	}
	// ׷̿ Ѵ.
	for(y=0;y<h;y++)
	{
		for(x=0;x<w;x++) 
		{
			imgDst[y][x]=imgDst[y][x]*255/max;
		}
	}
	*/

	// ޸ 
	delete [] SIN;
	delete [] COS;

	return TRUE;
}
 
//  ȯ
BOOL CImageProc::CvtInvHoughImage_LOM(CImageObj &imgSrc,CImageObj &imgHough,CImageObj &imgDst)
{
	//unsigned long MAXIMUM = 0;
	DWORD x,y,i,j,w,h,max=0;

	int xx;
	//int yy;
	double r;
	double SQRTD;
	double	*SIN,*COS;

	w=imgSrc.m_Width;
	h=imgSrc.m_Height;

	SQRTD=sqrt((double)(w*w+h*h));

	// ̺ 
	SIN = new double [h];
	COS = new double [h];
	CosSin(COS,SIN,h);

	for(y=0;y<h;y++)
	{
		for(x=0;x<w;x++)
		{
			if(imgHough[y][x]==255)		// ȯ 
			{
				xx=0.0f;

				for(i=0;i<h;i++)
				{
					r = (float)x * 2.0f * SQRTD/(h-1) - SQRTD;

					if (SIN[y]==0.0f) xx++;
					else xx = (r-(float)i * COS[y])/SIN[y];
					
					j=(int)floor(xx+0.5f);

					if(j>=0 && j<w)
					{
						if(imgSrc[i][j]==255) imgDst[i][j]=255;
						//else imgDst[l][xx]++;
						//imgDst[l][xx]=255;
					}
				}
			}
		}
	}

	// ޸ 
	delete [] SIN;
	delete [] COS;

	return TRUE;
}


/**************************************************************
* Functions :	輱 Լ
*
* History : 2005. 06. 20
* Modified: 2008. 07. 2,  H.C.H
*****************************************************************/



// üڵ α׷ - ͳݿ 8-connection 
PIXLIST plist;

PIXLIST newp (int N)
{
	PIXLIST x;

	x = (PIXLIST)malloc (sizeof (struct _pixlist));
	x->N = N;
	x->n = 0;
	x->list = (int **)malloc (sizeof(int *) * 2);
	x->list[0] = (int *)malloc (sizeof(int)*N);
	x->list[1] = (int *)malloc (sizeof(int)*N);
	return x;
}

void delp (PIXLIST x)
{
	free(x->list[0]);
	free(x->list[1]);
	free(x->list);
	free(x);

	return;
}


// Convert the boundary image into a list of pixels 
BOOL CImageProc::CvtContourTracing(CImageObj &imgSrc,CImageObj &imgDst)							  
{
	int x, y, k, nn,label=50;
	PIXLIST q;

	k = imgSrc.m_Width * imgSrc.m_Height;
	q = newp (k);

	for (y=0; y<imgSrc.m_Height; y++)
	{
		for (x=0; x<imgSrc.m_Width; x++)
		{
			if (imgSrc[y][x] == 255 && imgDst[y][x] == 0)
			{
				GetContourTracing(imgSrc, imgDst, y, x, q, k, &nn, label);
			}
		}
	}

	// üڵ忡 ä    äǷ ȭ ؼ Ѵ.
	ApplyBIN(imgDst,imgDst,128);

	delp(q);

	return TRUE;
}


 
int range (CImageObj &imgSrc, int i, int j)
{
	if ((i<0) || (i>=imgSrc.m_Height)) return 0;
	if ((j<0) || (j>=imgSrc.m_Width)) return 0;
	return 1;
}


//stack friendly and fast floodfill algorithm
void floodFillScanline(CImageObj &imgSrc,int x, int y, int newColor, int oldColor)
{
    if(oldColor == newColor) return;

	//int col=imgSrc[y][x];
    if(imgSrc[y][x] != oldColor) return;
      
    int y1;
    
    //draw current scanline from start position to the top
    y1 = y;
    while(y1 < imgSrc.m_Height && imgSrc[y1][x] == oldColor)
    {
        imgSrc[y1][x] = newColor;
        y1++;
    }    
    
    //draw current scanline from start position to the bottom
    y1 = y - 1;
    while(y1 >= 0 && imgSrc[y1][x] == oldColor)
    {
        imgSrc[y1][x] = newColor;
        y1--;
    }
    
    //test for new scanlines to the left
    y1 = y;
    while(y1 < imgSrc.m_Height && imgSrc[y1][x] == newColor)
    {
        if(x > 0 && imgSrc[y1][x-1] == oldColor) 
        {
            floodFillScanline(imgSrc, x - 1, y1, newColor, oldColor);
        } 
        y1++;
    }
    y1 = y - 1;
    while(y1 >= 0 && imgSrc[y1][x] == newColor)
    {
        if(x > 0 && imgSrc[y1][x - 1] == oldColor) 
        {
            floodFillScanline(imgSrc, x - 1, y1, newColor, oldColor);
        }
        y1--;
    } 
    
    //test for new scanlines to the right 
    y1 = y;
    while(y1 < imgSrc.m_Height && imgSrc[y1][x] == newColor)
    {
        if(x < imgSrc.m_Width - 1 && imgSrc[y1][x + 1] == oldColor) 
        {           
            floodFillScanline(imgSrc, x + 1, y1, newColor, oldColor);
        } 
        y1++;
    }
    y1 = y - 1;
    while(y1 >= 0 && imgSrc[y1][x] == newColor)
    {
        if(x < imgSrc.m_Width - 1 && imgSrc[y1][x + 1] == oldColor) 
        {
            floodFillScanline(imgSrc, x + 1, y1, newColor, oldColor);
        }
        y1--;
    }
}


BOOL CImageProc::GetContourTracing(CImageObj &imgSrc,CImageObj &imgDst,int y, int x, PIXLIST c, int pmax, int *nn,int label)
{
	int val,n,m,q,r, di[9],dj[9],ii, d, dii;
	int lastdir, jj, i,j;

	// label is over 1
	if(label<=0) label=1;

	//  Table given index offset for each of the 8 directions.          
	di[0] = 0;      di[1] = -1;     di[2] = -1;     di[3] = -1;
	dj[0] = 1;      dj[1] = 1;      dj[2] = 0;      dj[3] = -1;
	di[4] = 0;      di[5] = 1;      di[6] = 1;      di[7] = 1;
	dj[4] = -1;     dj[5] = -1;     dj[6] = 0;      dj[7] = 1;

	for (ii=0; ii<pmax; ii++)
	{
	  c->list[0][ii] = -1;
	  c->list[1][ii] = -1;
	}
	
	val = imgSrc[y][x];
	q = y;
	r = x;
	lastdir = 4;

	c->list[0][0] = q;	// y
	c->list[1][0] = r;	// x
	n = 1;

	do
	{
		m = 0;
		dii = -1;     d = 100;
		for (ii=lastdir+1; ii<lastdir+8; ii++) 
		{   
			// Look for next 
			jj = ii%8;
			
			if (range(imgSrc,di[jj]+q, dj[jj]+r))
			{
				if ( imgSrc[di[jj]+q][dj[jj]+r] == val && imgDst[di[jj]+q][dj[jj]+r]==0) 
				{
					dii = jj;    m = 1;
					break;
				} 
			}
		}

		if (m)        // Found a next pixel ... 
		{
			q += di[dii];       
			r += dj[dii];

			if (n<pmax)
			{
				c->list[0][n] = q;
				c->list[1][n] = r;
				n++;
			}
			lastdir = (dii+5)%8;
		} 
		else break; // NO next pixel 

		if (n>pmax) break;

	} while ( (q!=y) || (r!=x) );   // Stop when next to start pixel


	
	// 輱 ׸.
	for (i=0; i<n+1; i++)
	{
	  imgDst[c->list[0][i]][c->list[1][i]] = 255;
	}
	

	//  ä Լ.
	// 	
	long cx=0,cy=0;
	int found=0;
	for(i=0;i<n;i++) 
	{
		cy = c->list[0][i];
		cx = c->list[1][i]+1;

		for(j=i+1;j<n;j++) 
		{
			// ǥ   ã´.
			if(cy == c->list[0][j]) 
			{
				// ǥ  ã´.
				if( imgDst[cy][cx]==0 && imgDst[cy][cx+1]==0  && imgDst[cy][cx+2]==0 ) 
				{
					found=1;
					break;
				}
				break;	// ѹ ãƼ    ̵Ѵ.
			}
		}
		if(found) break;
	}
	

	if(found) floodFillScanline(imgDst, cx, cy, label, 0);
	
	*nn = n;

	return TRUE;
}



// Blob Coloring
BOOL CImageProc::CvtBlobColoring(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;


	int x, y, k, nn,label=200;
	PIXLIST q;

	k = imgSrc.m_Width * imgSrc.m_Height;
	q = newp (k);

	for (y=0; y<imgSrc.m_Height; y++)
	{
		for (x=0; x<imgSrc.m_Width; x++)
		{
			if (imgSrc[y][x] != 0 && imgDst[y][x] == 0)
			{
				GetContourTracing(imgSrc, imgDst, y, x, q, k, &nn,label);
				//q->n = nn;
				if(label>20) label-=20;
				else label=200;
				//return TRUE;
			}
		}
	}

	delp(q);

	return TRUE;
}

// ChainCode BlobColoring
BOOL CImageProc::CvtChainCode_BlobColoring(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int x,y,cnt=255,xx,yy;
	int value1=0, value2=0,sum=0;

	// 255 Ǵ   ȼ X, Y Ÿ 
	long	Sx,Sy;
	int 	d,MaxBd;
	POINT	Boundary[10000];	//ϳ    ϴ  

	//̹  ù ٺ Y  ȼ Ͽ X  ĵ 
 	for(y=0; y<imgSrc.m_Height; y++) 
	{
		for(x=0; x<imgSrc.m_Width; x++) 
 		{
			//̹ ù °  ù ȼ Ǹ 
 			if(imgSrc[y][x]==255 && imgDst[y][x]==0 )
 			{
				// ȼ  Sx Sy 
 				xx=Sx=x;
 				yy=Sy=y;
 				MaxBd=d=0;
				if(pDC!=NULL) pDC->MoveTo(Sx+2,Sy+2);

 				do
 				{
 					if(imgSrc[yy][xx]==255) //Y l X c شϴ ȼ Ͱ 255̸ 
 					{
 						d++;
 						if(d==4) d=0;
 						imgDst[y][x] = 255;
						//  ߿  ͸ 
						if(MaxBd<10000)
						{
 							Boundary[MaxBd].x=xx;
 							Boundary[MaxBd].y=yy;
							if(pDC!=NULL) { DelayTime(100); pDC->LineTo(Boundary[MaxBd].x+2,Boundary[MaxBd].y+2); }
 							MaxBd++;
						}
						else 
						{
							break;
						}
 					}
 					else 
 					{
						// ¿ ߿  ̵ ϴ  d
						d--;	//Ͱ   d--
 						if(d==-1) d=3;
 					}
 					switch(d)
					{
 					case 0:xx++;break;//right
 					case 1:yy--;break;//up
 					case 2:xx--;break;//left
 					case 3:yy++;break;//down
 					}
					//̹ ü ϳ  
					//c ̹ X    ų Y     Ǵ  뷮 ģ 
					if(xx<0) xx=0;
					if(xx>=imgSrc.m_Width) xx=imgSrc.m_Width-1;
					if(yy<0) yy=0;
					if(yy>=imgSrc.m_Height) yy=imgSrc.m_Height-1;

					/*
					if(c>=sz.cx|| c<0 || l>=sz.cy|| l<0 || MaxBd>=10000)
 					{
						m_Image->SwapImage(m_tempImage);
					}
					*/
				
					//ӽ  c, l ʱ ȼ Sx,Sy   ´.
 				} while(!(xx==Sx && yy==Sy));

				// ϳ Ǹ  ,  ִ ,      ޸ Ͽ ĥѴ.
				BlobColor(imgSrc,imgDst,Boundary,MaxBd,cnt);
				
				cnt--;//  ÷    ȣ 
				if(cnt<50) cnt=255;
			}
 		}
	}

	return TRUE;
}

BOOL CImageProc::BlobColor(CImageObj &imgSrc,CImageObj &imgDst,POINT *Bd,long Max,BYTE color)
{
	long i,j,k;
//	int l,m;

	for(i=0;i<Max;i++) 
	{
		for(j=i+1;j<Max;j++) 
		{
			if(Bd[i].y==Bd[j].y) 
			{
				for(k=min(Bd[i].x,Bd[j].x);k<=max(Bd[i].x,Bd[j].x);k++)
				if(imgSrc[Bd[i].y][k]==255) imgDst[Bd[i].y][k]=40+(color%20)*10;
				break;
			}
		}
	}

	return TRUE;
}


// Border Following
BOOL CImageProc::CvtBorderFollowing(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	long Dir,xx,yy,x,y,cnt;
	int MaxBd, Sx, Sy;
//	int i,j;
	POINT Boundary[10000];
	//unsigned char bTemp[300][300]={0,};

	for(cnt=0,y=0 ; y<imgSrc.m_Height; y++)//y 
	{
		for(x=0 ; x<imgSrc.m_Width; x++)//x
		{

			if(imgSrc[y][x]==255 && imgDst[y][x]==0)
			{				
				xx = Sx = x;
				yy = Sy = y;
				MaxBd = 0;
				Dir = RIGHT;

				if(pDC!=NULL) pDC->MoveTo(Sx+2,Sy+2);


				do
				{
					if(imgSrc[yy][xx]==255)
					{
						imgDst[y][x]=255;
						//if(imgDst[y][x]>10) break;
						if(MaxBd<10000) 
						{
							Boundary[MaxBd].x = xx ;
							Boundary[MaxBd].y = yy ;
							if(pDC!=NULL) pDC->LineTo(Boundary[MaxBd].x+2,Boundary[MaxBd].y+2);
							MaxBd++;
						}
					}

					switch(Dir)
					{
					case RIGHT:
						if(imgSrc[yy][xx-1]!=0) Dir = UP;
						else if(imgSrc[yy+1][xx]!=0) Dir = RIGHT;
						else if(imgSrc[yy][xx+1]!=0) Dir = DOWN;
						else						Dir = LEFT;
						break;
					case DOWN:
						if(imgSrc[yy+1][xx]!=0) Dir = RIGHT;
						else if(imgSrc[yy][xx+1]!=0) Dir = DOWN;
						else if(imgSrc[yy-1][xx]!=0) Dir = LEFT;
						else						Dir = UP;
						break;
					case LEFT:
						if(imgSrc[yy][xx+1]!=0) Dir = DOWN ;
						else if(imgSrc[yy-1][xx]!=0) Dir = LEFT ;
						else if(imgSrc[yy][xx-1]!=0) Dir = UP;
						else						Dir = RIGHT;
						break;
					case UP:
						if(imgSrc[yy-1][xx]!=0) Dir = LEFT ;
						else if(imgSrc[yy][xx-1]!=0) Dir = UP ;
						else if(imgSrc[yy+1][xx]!=0) Dir = RIGHT;
						else						Dir = DOWN;
						break;
					}

					switch(Dir)
					{
					case RIGHT:yy++; break;
					case DOWN: xx++; break;
					case LEFT: yy--; break;
					case UP:   xx--; break;
					}

					if(pDC!=NULL) DelayTime(900);

					if(xx<1) xx=1;
					if(xx>=imgSrc.m_Width) xx=imgSrc.m_Width-1;
					if(yy<1) yy=1;
					if(yy>=imgSrc.m_Height) yy=imgSrc.m_Height-1;
					
				//	if(i>=m_nWidth || i<0 ||j >= m_nHeight ||j <0 || MaxBd>= 10000)
				//	{
				//		AfxMessageBox("Size Over or Region Number Over");
				//		return ;
				//	}

				} while(!( xx== Sx && yy == Sy));// ó ڸ ǵ  

				//÷  Լ
				BlobColor(imgSrc,imgDst,Boundary,MaxBd,cnt);

				cnt++;
			}
		}
	}
	//ApplyByte(imgDst,bTemp);


	return TRUE;
}

// Raster Scan

int sort_function(const void *a, const void *b)
{
	return(strcmp((char*) a,(char*) b) );
}


BOOL CImageProc::CvtRasterScan(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	BYTE	cnt;			// (  ϰ coloring Ҷ 
	int		x, y;
	int		Bno;
	WORD	Low,Hi;
	
	//WORD	Lut[10000],	NLut[10000],SortNo[10000];
	WORD*	Lut = new WORD [10000];
	WORD*	NLut = new WORD [10000];
	WORD*	SortNo = new WORD [10000];
	DWORD	i,j,k,tno;
	
	//POINT	Equ[100000];	//Equivalence table
	POINT*	Equ = new POINT [100000];	//Equivalence table
	//ByTE **imgDst = MakeTempBuffer() ; 

	//InitBuffer(imgDst);

	//for(y=0; y<imgSrc.m_Height; y++) 
	//	for(x=0; x<imgSrc.m_Width; x++) imgDst[y][x]=0;

	//̹ ֿܰ 0 
 	for(y=0;y<imgSrc.m_Height;y++) imgSrc[y][0]=imgSrc[y][imgSrc.m_Width-1]=0;
	for(x=0;x<imgSrc.m_Width;x++)  imgSrc[0][x]=imgSrc[imgSrc.m_Height-1][x]=0;

	//  Ʒ, ʿ  ĵѴ.
	for(tno=0,cnt=1,y=1;y<imgSrc.m_Height;y++) for(x=1;x<imgSrc.m_Width;x++) 
	{
		//scanning ߿ ȼ(imgSrc[y][x])  0̾ƴϸ,
		if(imgSrc[y][x]!=0)
		{
			//ʰ  ȼ 0̸ ο  
			if(imgSrc[y-1][x] == 0 && imgSrc[y][x-1] == 0)
			{
				imgDst[y][x]=cnt;
				cnt++;
				if(cnt > 9999) { delete Equ; delete Lut; delete NLut; delete SortNo; return NULL; }
				if(pDC!=NULL) { DelayTime(50); pDC->SetPixel(x+2,y+2,RGB(0,255,0)); }
			} 
			
			//ȼ 0̾ƴѰ,(̹  Ǿ ) 
			else if(imgSrc[y-1][x]==0 && imgSrc[y][x-1]!=0)
			{
				imgDst[y][x]=imgDst[y][x-1];
				if(pDC!=NULL) { DelayTime(50); pDC->SetPixel(x+2,y+2,RGB(0,255,0)); }
			}

			//ȼ 0̾ƴѰ,(̹  Ǿ ) 
			else if(imgSrc[y-1][x]!=0 && imgSrc[y][x-1]==0)
			{
				imgDst[y][x]=imgDst[y-1][x];
				if(pDC!=NULL) { DelayTime(50); pDC->SetPixel(x+2,y+2,RGB(0,255,0)); }
			}

			//ʰ  ȼ  ̹  Ǿ ,
			else if(imgSrc[y-1][x]!=0 && imgSrc[y][x-1]!=0) 
			{
				//  ġ ̺ ġ 󺧷 Է
				imgDst[y][x]=imgDst[y-1][x];
				if(pDC!=NULL) { DelayTime(50); pDC->SetPixel(x+2,y+2,RGB(0,255,0)); }

				//ʶ󺧰 ʶ ٸ ,
				if(imgDst[y][x-1]!=imgDst[y-1][x])
				{
					Low=min(imgDst[y][x-1],imgDst[y-1][x]);
					Hi=max(imgDst[y][x-1],imgDst[y-1][x]);
					for(i=0;i<tno;i++)
						if( (Low==Equ[i].x) && (Hi==Equ[i].y) ) break;
					if(i==tno) // no matching data so update equ table
					{
						Equ[tno].x=Low;
						Equ[tno].y=Hi;
						tno++;
						if(tno>9999) { delete Equ; delete Lut; delete NLut; delete SortNo;  return NULL; }
					}
				}
			} 
		}
	}

	// Set LookUp-Table from 0 to cnt
	for(i=0;i<cnt;i++) Lut[i]=NLut[i]=i;
	// LUT  Equivalent Table 뿡  
	for(i=0;i<tno;i++)
	{
		k=Lut[Equ[i].y];
		for(j=0;j<cnt;j++)
			if(k==Lut[j]) Lut[j]=Lut[Equ[i].x];
	}
	//reassign the no of lut from 0 to max no of blob
	//Bno:Blob 
	//SortNo:  Lut   ο  Ѵ.
	Bno=0;
	SortNo[Bno]=Lut[0];
	Bno++;
	for(i=0;i<cnt;i++)
	{
		for(j=0;j<Bno;j++) if(SortNo[j] ==Lut[i]) break;
		if(j==Bno) 
		{
			SortNo[Bno]=Lut[i];
			Bno++;
		}
	}

	//SortNo  SortingѴ.
	qsort(SortNo,Bno,2,sort_function);

	//Ӱ Sorting No ο Lut NLut .
	for(i=0;i<cnt;i++) 
		for(j=0;j<Bno;j++) if(Lut[i]==SortNo[j]) NLut[i]=j;

	//Dst ̹ NLut  ٲ۴.
	for(y=0;y<imgSrc.m_Height;y++) for(x=0;x<imgSrc.m_Width;x++) 
		if(imgSrc[y][x]!=0) imgDst[y][x]=40+(NLut[imgDst[y][x]]%10)*20;
		
	//Dump(imgDst);
	//DeleteTempBuffer(imgDst);
	
	delete Equ; 
	delete Lut; 
	delete NLut; 
	delete SortNo; 
	return TRUE;
}

// Grass Fire
int push(short *stackx, short *stacky, short vx, short vy, int *top)
{
	if(*top>=300000) return(-1);
	(*top)++;
	stackx[*top]=vx;
	stacky[*top]=vy;
	return(1);
}

int pop(short *stackx, short *stacky, short *vx, short *vy, int *top)
{
	if(*top==0) return(-1);
	*vx=stackx[*top];
	*vy=stacky[*top];
	(*top)--;
	return(1);
}

BOOL CImageProc::CvtGrassFire(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	long X,Y,x,y,MaxBd[2],cnt,turn,i;
	long Ys,Ye,Xs,Xe;
	Xs = 0;
	Xe = imgSrc.m_Width;
	Ys = 0;
	Ye = imgSrc.m_Height;

	POINT ** Boundary;
	//Boundary=(POINT **)malloc(2*sizeof(POINT *));
	//Boundary[0]=(POINT *)malloc(ImgWidth*ImgHeight*sizeof(POINT));
	//Boundary[1]=(POINT *)malloc(ImgWidth*ImgHeight*sizeof(POINT));
	Boundary = new POINT *[2];
	Boundary[0] = new POINT[imgSrc.m_Width*imgSrc.m_Height];
	Boundary[1] = new POINT[imgSrc.m_Width*imgSrc.m_Height];

	imgDst = imgSrc;
	
	MaxBd[0]=MaxBd[1]=0;
	cnt=0;
	for(Y=Ys;Y<Ye;Y++) for(X=Xs;X<Xe;X++) 
	{
		if(imgDst[X][Y]==255)
		{
			imgDst[X][Y]=50+(cnt*10)%200;
			turn=0;
			Boundary[0][0].x=X;
			Boundary[0][0].y=Y;
			MaxBd[0]=1;
			if(pDC!=NULL)
			{
				DelayTime(50);
				pDC->SetPixel((Boundary[0][0].y)+2,imgSrc.m_Width-Boundary[0][0].x+2,RGB(0,50+(cnt*10)%200,0));
			}
			do
			{
				MaxBd[(turn+1)%2]=0;
				for(i=0;i<MaxBd[turn];i++)
				{
					for(y=-1;y<=1;y++)	for(x=-1;x<=1;x++)
					{
						if(x==0 && y==0) continue;
						if(imgDst[Boundary[turn][i].x+x][Boundary[turn][i].y+y]==255) 
						{
							imgDst[Boundary[turn][i].x+x][Boundary[turn][i].y+y]=50+(cnt*10)%200;
							Boundary[(turn+1)%2][MaxBd[(turn+1)%2]].x=Boundary[turn][i].x+x;
							Boundary[(turn+1)%2][MaxBd[(turn+1)%2]].y=Boundary[turn][i].y+y;
							MaxBd[(turn+1)%2]++;
							if(pDC!=NULL)
							{
								DelayTime(50);
								pDC->SetPixel((Boundary[turn][i].y+y)+2,Boundary[turn][i].x+x+2,RGB(0,50+(cnt*10)%200,0));
							}
						}
					}
				}
				turn=((++turn)%2);
			} while(MaxBd[turn]!=0);
		}
		cnt++;
	}
	//free((POINT *)Boundary[0]);
	//free((POINT *)Boundary[1]);
	//free((POINT **)Boundary);
	delete [] Boundary[0];
	delete [] Boundary[1];
	delete [] Boundary;

	return TRUE;
}


void CImageProc::DelayTime(DWORD t)
{
	float f;
	if(t<1000) 
	{
		for(int j=0;j<100;j++) 
			for(int i=0;i<t;i++) f=f/1*1;
		return;
	}
	DWORD dwWorkTime;
	DWORD dwStart = GetTickCount();
	do
	{
		dwWorkTime=GetTickCount() - dwStart;
	} while(dwWorkTime < t);
}


// Polygon approximation
BOOL CImageProc::CvtAmeba(CImageObj &imgSrc,CImageObj &imgDst,CDC *pDC)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;


	return TRUE;
}


//New Ameba Method 1998.5.7 
/*
HGLOBAL LOM_New_Ameba(HGLOBAL hSrc,WORD x,WORD y,int Gap,int PolyErr,UINT LOM_Process)
{

//For Polygonal Approx. Results
NODE * BdStack=NULL;
CPIXEL *pBd;
	
BOOL Flag;
static int Level;
//For Boundary Data Storage
NODE * outstack[2]={NULL,NULL};
CPIXEL Bd;
	for(Level=0,c=-1;c<=1;c++) for(l=-1;l<=1;l++)
	{
		Level+=S(x+c,Wy-y+l);
		Bd.C=x+c;
		Bd.L=Wy-y+l;
		Bd.cost=S(Bd.C,Bd.L);
		push(&outstack[0],Bd);
	}
	Level=Level/9;
	//Set Destination Image to HI
	for(c=-1;c<=1;c++) for(l=-1;l<=1;l++) D(x+c,Wy-y+l)=255;
	//Set Boundary Image of SOurce to LOW
	for(L=0;L<Wy;L++) S(0,L)=S(Wx-1,L)=0;
	for(C=0;C<Wx;C++) S(C,0)=S(C,Wy-1)=0;
	i=0;
	while(LOM_Do_Ameba_Expand(p,q,Wx,Wy,&outstack[i%2],&outstack[(i+1)%2],&Level,Gap)) 
	{
		i=(++i)%2;
	}
	while(outstack[i%2] !=NULL) Bd=pop(&outstack[i%2]); //clear stack data
	while(outstack[(i+1)%2] !=NULL) Bd=pop(&outstack[i%2]); //clear stack data

	ROI=LOM_Ameba_GetRegion(q,Wx,Wy);
	//generate boundary data of Destination image & save to statck
	for(L=(ROI.top+ROI.bottom)/2;L<=ROI.bottom;L++) for(C=ROI.left;C<=ROI.right;C++) 
	{
		//the start position is shifted half of height to avoid undesired resion detection
		if(D(C,L)==255 && D(C+1,L)==255 ) 
		//we consider the case that the single peak makes the algorithm unlimited loop calculation.
		{
			c=Sx=C;
			l=Sy=L;
			NoBd=d=0;
			do
			{
				if(D(c,l)==255) 
				{
					d++;
					if(d==4) d=0;
					Bd.C=c;
					Bd.L=l;
					Bd.cost=S(c,l);
					push(&outstack[0],Bd);
					NoBd++;
				}
				else 
				{
					d--;
					if(d==-1) d=3;
				}
				switch(d)
				{
					case 0:c++;break;
					case 1:l--;break;
					case 2:c--;break;
					case 3:l++;break;
				}
				if(c<0 || c>=Wx||  l>=Wy|| l<0) 
				{
					GlobalUnlock(hSrc);
					GlobalUnlock(hDst);
					return hDst;
				}
			} while(!(c==Sx && l==Sy));
			C=Wx;
			L=Wy;
		}//end of if
	}//end of for loop
	//Clear Destination Image
	for(L=0;L<Wy;L++) for(C=0;C<Wx;C++) D(C,L)=S(C,L);
	else for(L=0;L<Wy;L++) for(C=0;C<Wx;C++) 
		D(C,L)=0;
		//D(C,L)=S(C,L);
	//Save Boundary Data to Heap Memory
	i=0;
	pBd = (CPIXEL *) HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(CPIXEL)*NoBd) ;
	while(outstack[0] !=NULL)
	{
		Bd=pop(&outstack[0]);
		pBd[i].C=Bd.C;
		pBd[i].L=Bd.L;
		pBd[i].cost=i;
		i++;
		if(LOM_Process==IDM_AMEBA_BD) 
			D(Bd.C,Bd.L)=255; //Boundary Data
	}
	NoPt=0;//No of Corner Point
	curve_split(pBd,&BdStack,NoBd-1,PolyErr,&NoPt);
	HeapFree (GetProcessHeap(),0,pBd) ;
	pBd = (CPIXEL *) HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(CPIXEL)*NoPt) ;
	i=0;
	while(BdStack !=NULL)
	{
		pBd[i]=pop(&BdStack);
		if(LOM_Process==IDM_AMEBA_BD) D(pBd[i].C,pBd[i].L)=255; //Corner Points
		i++;
	}
	if(LOM_Process==IDM_AMEBA_BD) goto ameba_err; 
	if(i!=NoPt) goto ameba_err;
	LOM_Sort_Bdpoints(pBd,NoPt);
	for(i=0;i<NoPt-1;i++)
		LOM_LinetoImage(p,q,Wx,Wy,pBd[i],pBd[i+1]);
	LOM_LinetoImage(p,q,Wx,Wy,pBd[i],pBd[0]);
ameba_err:
	HeapFree (GetProcessHeap(),0,pBd) ;
	
	return hDst;
}
//expand to the boundary direction  
BOOL LOM_Do_Ameba_Expand(BYTE *p,BYTE *q,DWORD Wx,DWORD Wy,NODE ** 
Srcstack,NODE ** Dststack,int *Level,int gap)
{
int c,l,i,j;
CPIXEL Bd,NewBd;
BOOL Flag;

	Flag=FALSE;
	while(*Srcstack !=NULL)
	{
		Bd=pop(Srcstack);
		for(l=max(Bd.L-1,1);l<=min(Bd.L+1,Wy-1);l++)
		for(c=max(Bd.C-1,1);c<=min(Bd.C+1,Wx-1);c++)
		if(D(c,l)==0)
		{
			if(max((*Level-gap),1) <= S(c,l) && S(c,l) <= 
			min((*Level+gap),255) )
			{
				D(c,l)=255;
				NewBd.C=c;
				NewBd.L=l;
				NewBd.cost=S(c,l);
				push(Dststack,NewBd);
				Flag=TRUE;
			}
		}
	}
	return Flag;
}


int curve_split(CPIXEL *x, NODE ** StackPtr,int n,double T,int * NoPt)
{
	double *d,dmax;
	int i,ok=1,imax;

	if(*StackPtr == NULL) 
	{
		push(StackPtr,x[1]);
		(*NoPt)++;
	}
	d=(double *)calloc(n+1,sizeof(double));
	for(i=2;i<n;i++) d[i]=dist(x[1].C,x[1].L,x[i].C,x[i].L,x[n].C,x[n].L);
	for(i=3;i<n-1;i++) if(d[i] >= T) 
	{
		ok=0;
		goto cont;
	}
	cont: if (ok==1) return 0;
	dmax=0.0;
	for(i=3;i<n-1;i++) if(d[i]>dmax)
	{
		dmax=d[i];
		imax=i;
	}
	free(d);

	curve_split(x,StackPtr,imax,T,NoPt);
	push(StackPtr,x[imax]);
	(*NoPt)++;
	curve_split(x+imax,	StackPtr,	n-imax,	T,NoPt);
}

double dist(int x1,int y1,int x2,int y2,int x3,int y3)
{
int xb,yb,xc,yc;
double eg,par,angle,x;

	xb=x2-x1;	yb=y2-y1;
	xc=x3-x1;	yc=y3-y1;
	eg=abs((double)(xb*xc+yb*yc));
	par=sqrt(xb*xb+yb*yb)*sqrt(xc*xc+yc*yc);
	if( (par==0) || (eg/par > 1) ) return 0.0;
	angle=asin(eg/par);
	x=cos(angle)*sqrt(xb*xb+yb*yb);
	return abs(x);
}

void LOM_Sort_Bdpoints(CPIXEL *p,int n)
{
	int i,j,k;
	CPIXEL min;

	for(i=0;i<n-1;i++)
	{
		k=i;
		min=p[k];
		for(j=i+1;j<n;j++)
		if(p[j].cost < min.cost)
		{
			k=j;
			min=p[k];
		}
		p[k]=p[i];
		p[i]=min;
	}
}
*/

/**************************************************************
* Functions :	 Լ
*
* History : 2005. 06. 20
* Modified: 2008. 07. 2,  H.C.H
*****************************************************************/

// Add Salt & Pepper Noise
BOOL CImageProc::CvtAddSaltPepperNoise(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,color,col;
	unsigned int noise;
	int amount=10;			//   0~100

	color=imgSrc.m_ColorMode/8;
	imgDst = imgSrc;

	srand((unsigned)time(NULL));

	for(col=0;col<color;col++)
	{
		for(y=1; y<imgSrc.m_Height-1; y++)
		{
			for(x=1; x<imgSrc.m_Width-1; x++)
			{
				noise=(int)(rand()*100/RAND_MAX);
				if(noise<amount/2) imgDst[y][x*color+col]=0;
				else if(noise<amount) imgDst[y][x*color+col]=255;
			}
		}
	}

	return TRUE;
}


// ó α׷ 
double GaussianRand(double mean, double std)
{
	double x1,x2,radius, factor,y1;
	static double y2;
	static int use_last=0;

	if(use_last)
	{
		y1=y2;
		use_last=0;
	}
	else 
	{
		do {
			x1 = 2.0 * rand() / RAND_MAX - 1.0;
			x2 = 2.0 * rand() / RAND_MAX - 1.0;
			radius = x1*x1 + x2*x2;
		} while(radius < 0.00000001 || radius >= 1.0);

		factor = sqrt( (-2.0 * log(radius)) / radius );

		y1 = x1 * factor;
		y2 = x2 * factor;

		use_last = 1;
	}

	return (mean + y1*std);
}

// Add Gaussian Noise
BOOL CImageProc::CvtAddGaussianNoise(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,color,col;
	unsigned int noise;
	int amount=10;			//   0~100

	color=imgSrc.m_ColorMode/8;
	imgDst = imgSrc;

	srand((unsigned)time(NULL));

	for(col=0;col<color;col++)
	{
		for(y=0; y<imgSrc.m_Height; y++)
		{
			for(x=0; x<imgSrc.m_Width; x++)
			{
				noise = imgDst[y][x*color+col] + GaussianRand(0,amount);
				if(noise<0) noise=0;
				if(noise>255) noise=255;
				imgDst[y][x*color+col]=noise;
			}
		}
	}

	return TRUE;
}

// Mean ͸
BOOL CImageProc::CvtMeanFilter(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,color,col,i,j;
	int sum,M=3;

	color=imgSrc.m_ColorMode/8;
	imgDst=imgSrc;

	for(col=0;col<color;col++)
	{
		for(y=M/2; y<imgSrc.m_Height-M/2; y++ )
		{
			for(x=M/2; x<imgSrc.m_Width-M/2; x++)
			{
				sum=0;
				for(i=-M/2;i<=M/2;i++)
				{
					for(j=-M/2;j<=M/2;j++)
					{
						sum+=imgSrc[y+j][(x+i)*color+col];
					}
				}
				imgDst[y][x*color+col]=sum/(M*M);
			}
		}
	}

	return TRUE;
}

// Median Լ
int CImageProc::Median(int *buf, int len)
{
	int i,j,tmp;
	for (i=0;i<len-1;i++)
	{
		for (j=0;j<len-1;j++) 
		{
			if(buf[j+1]<buf[j]) 
			{
				tmp=buf[j+1];
				buf[j+1]=buf[j];
				buf[j]=tmp;
			}
		}
	}
	return buf[len/2];
}

// Median ͸
BOOL CImageProc::CvtMedianFilter(CImageObj &imgSrc,CImageObj &imgDst)
{
	int x,y,color,col,i,j;
	int sum,M=3;
	int buf[256];

	color=imgSrc.m_ColorMode/8;
	imgDst=imgSrc;

	for(col=0;col<color;col++)
	{
		for(y=M/2; y<imgSrc.m_Height-M/2; y++ )
		{
			for(x=M/2; x<imgSrc.m_Width-M/2; x++)
			{
				sum=0;
				for(i=-M/2;i<=M/2;i++)
				{
					for(j=-M/2;j<=M/2;j++)
					{
						buf[(i+M/2)*M+(j+M/2)]=imgSrc[y+j][(x+i)*color+col];
					}
				}
				imgDst[y][x*color+col]=Median(buf,M*M);
			}
		}
	}

	return TRUE;
}


/**************************************************************
* Functions :	 Լ
*
*Author : 
*	âȣ,ڼ,,,ȯ
*
*Funtions: 	
*	void Erosion()		- ħ  
*	void Dilation()		- â 
*
* History : 2005. 06. 20
* Modified: 2008. 02. 26
*****************************************************************/

// Opening
BOOL CImageProc::CvtOpening(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	CImageObj imgTmp;
	imgTmp.AllocBuff(imgSrc);

	CvtDilation(imgSrc,imgTmp);
	CvtErosion(imgTmp,imgDst);

	return TRUE;
}

// Closing
BOOL CImageProc::CvtClosing(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	CImageObj imgTmp;
	imgTmp.AllocBuff(imgSrc);

	CvtErosion(imgSrc,imgTmp);
	CvtDilation(imgTmp,imgDst);

	return TRUE;
}

// Erosion
BOOL CImageProc::CvtErosion(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int x,y,w,h;
	int nMin = INT_MAX ;				//nMin Ʈ ִġ ʱȭ.

	//BYTE **imgDst = MakeTempBuffer() ; // .
	
	for (y= 1 ; y <imgSrc.m_Height-1 ; y++)
	{
		for (x=1 ; x < imgSrc.m_Width-1 ; x++)
		{
			for (h=-1 ; h <=1 ; h++)
			{
				for(w = -1 ; w <= 1 ; w++ )
				{
					nMin = min( nMin , imgSrc[y+h][x+w]) ;	//3X3  ũ ּ ׷  . 
				}
			}
			imgDst[y][x] = nMin ; 
			nMin = 	INT_MAX ; 		
		}
	}

//	Dump(imgDst);
	//DeleteTempBuffer(imgDst) ; 

	return TRUE;
}

// Dilation
BOOL CImageProc::CvtDilation(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	int x,y,w,h;
	int nMax = INT_MIN ;				//nMin Ʈ ִġ ʱȭ.
	//BYTE **imgDst = MakeTempBuffer() ; 

	for (y= 1 ; y < imgSrc.m_Height-1 ; y++)
	{
		for (x= 1 ; x < imgSrc.m_Width -1 ; x++)
		{
			for (h= -1 ; h <=1 ; h++)
			{
				for (w= -1 ; w<=1 ; w++)
				{
					nMax = max(nMax , imgSrc[y+h][x+w]);

				}
				
			}
			imgDst[y][x] = nMax ;
			nMax = INT_MIN ; 

		}
	}

	return TRUE;
}




  /**
    * Produces a BinaryImage by a hit or miss transform of 
    * another BinaryImage. The source image is not altered.
    * @param image Source image for hit or miss transform.
    * @param structEl The structure element to be used.
    * @return The resulting image.
    */

BOOL HitOrMiss(CImageObj &imgSrc,CImageObj &imgDst,int (&kernel)[4][3][3],int nKernel)
{
	// 3x3 Ŀ
	int elHeight = 3;
	int elWidth = 3;

	int vCenter = 1;
	int hCenter = 1;

	int height = imgSrc.m_Height;
	int width = imgSrc.m_Width;
    
	int indRow, indCol;
	int isHitMiss;

	for(int n=0;n<nKernel;n++)
	{
		for (int row = 0; row < height; row++)
		{
			for (int col = 0; col < width; col++)
			{
				isHitMiss = true;

				for (int i = 0; i < elHeight && isHitMiss; i++)
				{
					for (int j = 0; j < elWidth && isHitMiss; j++)
					{
						indRow = row + i - vCenter;
						indCol = col + j - hCenter;

						if (indRow >= 0 && indRow < height && indCol >= 0 && indCol < width)
						{
							if (kernel[n][i][j] == 1)
							{
								isHitMiss = isHitMiss && imgSrc[indRow][indCol];
							}
							else if (kernel[n][i][j] == 0)
							{
								isHitMiss = isHitMiss && !imgSrc[indRow][indCol];
							}
						}
						else
						{
							isHitMiss = false;
						}
					}
				}

				imgDst[row][col] |= isHitMiss*255;

			}
		}
	}

	return TRUE;
}

// /
BOOL CImageProc::CvtHitMissTransform(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	// Ŀ 3x3 Ǿ ,  4 kernel Ѵ.
	int kernel[4][3][3]={
		{ {2,1,2},{0,1,1},{0,0,2} },
		{ {2,1,2},{1,1,0},{2,0,0} },
		{ {2,0,0},{1,1,0},{2,1,2} },
		{ {0,0,2},{0,1,1},{2,1,2} }	};

	HitOrMiss(imgSrc,imgDst,kernel,4);

	return TRUE;
}


BOOL CImageProc::CvtGErosion(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	unsigned char temp[3][3] = {0,};
	unsigned char mask[3][3] = {0,};
	unsigned char bTemp[300][300] = {0,};

	int x,y,i,j,row,column;
	int sum=0,min=1000;

	for(y=0; y < imgSrc.m_Height-3; y++)
	{
		for(x=0; x < imgSrc.m_Width-3; x++)
		{
			for(row=0; row<3; row++)
			{
				for(column=0; column<3; column++)
				{
					temp[row][column] = imgSrc[y+row][x+column];
				}
			}
			for(i=0; i<3; i++)
			{
				for(j=0; j<3; j++)
				{
					sum = temp[i][j]+mask[i][j];
					if(min > sum) min = sum;
				}
			}
			bTemp[1+y][1+x] = min;
			sum=0;
			min= 1000;
		}
	}
	ApplyByte(imgDst,bTemp);

	return TRUE;
}

BOOL CImageProc::CvtGDilation(CImageObj &imgSrc,CImageObj &imgDst)
{
	if(imgSrc.m_ColorMode!=IDM_GRAY) return FALSE;

	unsigned char temp[3][3] = {0,};
	unsigned char mask[3][3] = {0,};
	unsigned char bTemp[300][300] = {0,};

	int x,y,row,column,i,j;
	int sum=0,max=(-1000);

	for(y=0; y < imgSrc.m_Height-3; y++)
	{
		for(x=0; x < imgSrc.m_Width-3; x++)
		{
			for(row=0; row<3; row++)
			{
				for(column=0; column<3; column++)
				{
					temp[row][column] = imgSrc[y+row][x+column];
				}
			}
			for(i=0; i<3; i++)
			{
				for(j=0; j<3; j++)
				{
					sum = temp[i][j]+mask[i][j];
					if(max < sum) max = sum;
				}
			}
			bTemp[1+y][1+x] = max;
			sum=0;
			max = (-1000);
		}
	}
	ApplyByte(imgDst,bTemp);

	return TRUE;
}


/**************************************************************
* Functions :	Ÿ   Լ
*
* Modified: 2008. 07. 4
*****************************************************************/

void CImageProc::ApplyLUT(CImageObj &imgSrc,CImageObj &imgDst,int (&LUT)[256])
{
	int x,y;

	if(imgSrc.m_ColorMode==IDM_GRAY)
	{
		for(y = 0 ; y < imgSrc.m_Height ; y++)
		{
			for(x = 0 ; x < imgSrc.m_Width ; x++)
			{
				imgDst[y][x] = LUT[ imgSrc[y][x] ];
			}
		}
	}
	else 
	{
		for(y = 0 ; y < imgSrc.m_Height ; y++)
		{
			for(x = 0 ; x < imgSrc.m_Width ; x++)
			{
				imgDst[y][x*3+0] = LUT[ imgSrc[y][x*3+0] ];
				imgDst[y][x*3+1] = LUT[ imgSrc[y][x*3+1] ];
				imgDst[y][x*3+2] = LUT[ imgSrc[y][x*3+2] ];
			}
		}
	}
}

void CImageProc::ApplyBIN(CImageObj &imgSrc,CImageObj &imgDst,int Threshold,int Limit)
{
	int x,y;
	if(Limit<0) Limit=Threshold;

	if(imgSrc.m_ColorMode==IDM_GRAY)
	{
		for(y = 0 ; y < imgSrc.m_Height ; y++)
		{
			for(x = 0 ; x < imgSrc.m_Width ; x++)
			{
				if(imgSrc[y][x] < Threshold) imgDst[y][x] = 0;
				else if(imgSrc[y][x] >= Limit) imgDst[y][x] = 255;
				else imgDst[y][x] = imgSrc[y][x];
			}
		}
	}
	else 
	{
		for(y = 0 ; y < imgSrc.m_Height ; y++)
		{
			for(x = 0 ; x < imgSrc.m_Width ; x++)
			{
				if(imgSrc[y][x*3+0] < Threshold) imgDst[y][x*3+0] = 0;
				else imgDst[y][x*3+0] = 255;
				if(imgSrc[y][x*3+1] < Threshold) imgDst[y][x*3+1] = 0;
				else imgDst[y][x*3+1] = 255;
				if(imgSrc[y][x*3+2] < Threshold) imgDst[y][x*3+2] = 0;
				else imgDst[y][x*3+2] = 255;
			}
		}
	}
}


void CImageProc::ApplyByte(CImageObj &imgDst,BYTE bTemp[][300])
{
	int x,y;
	for(y=0; y < imgDst.m_Height; y++)
	{
		for(x=0; x < imgDst.m_Width; x++)
		{
			imgDst[y][x] = bTemp[y][x];
		}
	}
}


void CImageProc::ApplyMask(CImageObj &imgDst,BYTE mask)
{
	int x,y;
	
	for(y = 0 ; y < imgDst.m_Height ; y++)
	{
		for(x = 0 ; x < imgDst.m_Width ; x++)
		{
			imgDst[y][x] &= mask;
		}
	}
}


// ----------------------------------------------------
//  ʿ   .
BYTE** CImageProc::BitMask(CImageObj &imgSrc,BYTE mask)
{
	int x,y;
	
	BYTE** imgDst ; 
	imgDst = MakeTempBuffer(imgSrc);

	for(y = 0 ; y < imgSrc.m_Height ; y++)
	{
		for(x = 0 ; x < imgSrc.m_Width ; x++)
		{
			imgDst[y][x] = imgSrc[y][x] & mask;
		}
	}
	
	return imgDst  ; 
}

BYTE** CImageProc::MakeTempBuffer(CImageObj &imgSrc)
{
	int i;
	BYTE** pTemp ; 
	pTemp = new BYTE*[imgSrc.m_Height];
	for(i = 0  ; i < imgSrc.m_Height ; i++) 
	{
		pTemp[i] = new BYTE[imgSrc.m_Width] ; 
		
	}
	
	return pTemp ;
}

void CImageProc::DeleteTempBuffer(BYTE **imgDst)
{
	delete imgDst ; 
}

void CImageProc::ClearData(CImageObj &imgSrc,BYTE** imgDst ,unsigned char num)
{
	int x,y;
	
	for(y = 0 ; y < imgSrc.m_Height ; y++)
	{
		for(x = 0 ; x < imgSrc.m_Width ; x++)
		{
			imgDst[y][x] =num ;
		}
	}
}



