// ImgProcBkDoc.h : interface of the CImgProcBkDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_IMGPROCBKDOC_H__D7083DA8_E104_40FD_BCF7_9594F1A93198__INCLUDED_)
#define AFX_IMGPROCBKDOC_H__D7083DA8_E104_40FD_BCF7_9594F1A93198__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "ImageProc.h"

#include "UserBinDlg.h"
#include "TemplateDlg.h"
#include "ContrastDlg.h"

#include "ProcBox.h"
#include <vector>

using namespace std;

typedef vector < CImgProcBkDoc* > DOCVECTOR;


class CImgProcBkDoc : public CDocument
{
protected: // create from serialization only
	CImgProcBkDoc();
	DECLARE_DYNCREATE(CImgProcBkDoc)

// Attributes
public:
	CImageObj		m_ImgObj;
	CImageProc		m_ImgProc;
	
	CUserBinDlg*	m_pUBinDlg;
	CTemplateDlg*	m_pTempDlg;
	CContrastDlg*	m_pContDlg;

	DOCVECTOR		m_vDocNext;	//   Ʈ
	DOCVECTOR		m_vDocPrev;	//    
	int				m_nDocLevel;	//  level (depth)
	CProcBox		m_ProcBox;		//  ڽ
	CString			m_ProcStr;		// ó 

	int				m_CurProcess;


// Operations
public:
	CImgProcBkDoc* CreateNewImageWindow(CString procStr);
	void SetWindowSize(CImgProcBkDoc * pNewDoc);
	void SetWindowStatus(CString str);
	void CImgProcBkDoc::AddInfoStatus(int value);
	CString GetProcStr() { return m_ProcStr; }

	int  GetCurProcess() { return m_CurProcess; }
	void SetCurProcess(int num) { m_CurProcess = num; }

	void OnAmeba(CPoint point);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CImgProcBkDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CImgProcBkDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif



protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CImgProcBkDoc)
	afx_msg void OnFileSaveAs();
	afx_msg void OnRgb2gray();
	afx_msg void OnCloneImage();
	afx_msg void OnRgb2grayRed();
	afx_msg void OnRgb2grayGreen();
	afx_msg void OnRgb2grayBlue();
	afx_msg void OnUserBin();
	afx_msg void OnTemplate();
	afx_msg void OnLookupTable();
	afx_msg void OnHistogramEq();
	afx_msg void OnEdgeEg();
	afx_msg void OnEndinEq();
	afx_msg void OnInverse();
	afx_msg void OnGamma();
	afx_msg void OnStretching();
	afx_msg void OnCompress();
	afx_msg void OnPosterizing();
	afx_msg void OnThreshold();
	afx_msg void OnRangeThreshold();
	afx_msg void OnBitClipping();
	afx_msg void OnEqBright();
	afx_msg void OnRangeEmphasis();
	afx_msg void OnSolarising();
	afx_msg void OnParabola();
	afx_msg void OnPtileBin();
	afx_msg void OnModeBin();
	afx_msg void OnAvrBin();
	afx_msg void OnIterativeBin();
	afx_msg void OnAdaptiveBin();
	afx_msg void OnBlockBin();
	afx_msg void OnOtsuBin();
	afx_msg void OnTempMatch();
	afx_msg void OnSobel();
	afx_msg void OnPrewitte();
	afx_msg void OnRobert();
	afx_msg void OnLoG();
	afx_msg void OnCanny();
	afx_msg void OnZhangSuen();
	afx_msg void OnStentiford();
	afx_msg void OnHough();
	afx_msg void OnBlobColoring();
	afx_msg void OnBorderFollowing();
	afx_msg void OnRasterScan();
	afx_msg void OnGrassFire();
	afx_msg void OnAddSaltPepperNoise();
	afx_msg void OnAddGaussianNoise();
	afx_msg void OnMeanFilter();
	afx_msg void OnMedianFilter();
	afx_msg void OnOpening();
	afx_msg void OnClosing();
	afx_msg void OnErosion();
	afx_msg void OnDilation();
	afx_msg void OnHitMissTransform();
	afx_msg void OnHistogram();
	afx_msg void OnView3d();
	afx_msg void OnBrtransSetup();
	afx_msg void OnParabola2();
	afx_msg void OnZerocross();
	afx_msg void OnEntropyBin();
	afx_msg void OnResizeImage();
	afx_msg void OnRotateImage();
	afx_msg void OnFlipImage();
	afx_msg void OnMirrorImage();
	afx_msg void OnTranslateImage();
	afx_msg void OnLaplacian();
	afx_msg void OnAmeba();
	afx_msg void OnAffine();
	afx_msg void OnPerspective();
	afx_msg void OnBilinTrans1();
	afx_msg void OnBilinTrans2();
	afx_msg void OnShearImage();
	afx_msg void OnFftTransform();
	afx_msg void OnIfftTransform();
	afx_msg void OnZeropad();
	afx_msg void OnBpfB();
	afx_msg void OnBpfG();
	afx_msg void OnBpfI();
	afx_msg void OnBsfB();
	afx_msg void OnBsfG();
	afx_msg void OnBsfI();
	afx_msg void OnHpfB();
	afx_msg void OnHpfG();
	afx_msg void OnHpfI();
	afx_msg void OnLpfB();
	afx_msg void OnLpfG();
	afx_msg void OnLpfI();
	afx_msg void OnDctTransform();
	afx_msg void OnIdctTransform();
	afx_msg void OnBoundary();
	//}}AFX_MSG

	void OnLpf(int mode);
	void OnHpf(int mode);
	void OnBpf(int mode);
	void OnBsf(int mode);
	
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IMGPROCBKDOC_H__D7083DA8_E104_40FD_BCF7_9594F1A93198__INCLUDED_)





















