// ImgProcBkView.cpp : implementation of the CImgProcBkView class
//

#include "stdafx.h"
#include "ImgProcBk.h"
#include "MainFrm.h"

#include "ImgProcBkDoc.h"
#include "ImgProcBkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImgProcBkView

IMPLEMENT_DYNCREATE(CImgProcBkView, CView)

BEGIN_MESSAGE_MAP(CImgProcBkView, CView)
	//{{AFX_MSG_MAP(CImgProcBkView)
	ON_COMMAND(ID_SAVE_TEXT, OnSaveAsText)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImgProcBkView construction/destruction

CImgProcBkView::CImgProcBkView()
{
	// TODO: add construction code here

}

CImgProcBkView::~CImgProcBkView()
{
}

BOOL CImgProcBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CImgProcBkView drawing

void CImgProcBkView::OnDraw(CDC* pDC)
{
	CImgProcBkDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	DrawImage(pDC,pDoc->m_ImgObj);

	if(pDoc->m_ImgObj.m_Flag==TRUE)
	{
		GetParentFrame()->SetWindowPos(NULL, 0, 0, pDoc->m_ImgObj.m_Width+12, pDoc->m_ImgObj.m_Height+22+35, SWP_NOMOVE);
		pDoc->m_ImgObj.m_Flag=FALSE;
	}

}

/////////////////////////////////////////////////////////////////////////////
// CImgProcBkView printing

BOOL CImgProcBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CImgProcBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CImgProcBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CImgProcBkView diagnostics

#ifdef _DEBUG
void CImgProcBkView::AssertValid() const
{
	CView::AssertValid();
}

void CImgProcBkView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CImgProcBkDoc* CImgProcBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CImgProcBkDoc)));
	return (CImgProcBkDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CImgProcBkView message handlers


void CImgProcBkView::DrawImage(CDC* pDC,CImageObj &ImgObj)
{
	if(!ImgObj.IsExist()) return;

	CDC MemDC;
	MemDC.CreateCompatibleDC(pDC);

	HGLOBAL hSrc = ImgObj.MakeDIBData();

	LPBITMAPINFOHEADER	pSrc =(LPBITMAPINFOHEADER)::GlobalLock(hSrc);
	LPSTR	pImage=(LPSTR)pSrc+sizeof(BITMAPINFOHEADER)+pSrc->biClrUsed*sizeof(RGBQUAD);

	// DIB  DDB  ȯִ Լ 
	HBITMAP hbitmap = CreateDIBitmap( pDC->m_hDC,// handle to device context
				(LPBITMAPINFOHEADER)pSrc,	// pointer to bitmap info header 
				(LONG)CBM_INIT,			// initialization flag
				pImage,			// pointer to initialization data 
				(LPBITMAPINFO)pSrc,		// pointer to bitmap info
				DIB_RGB_COLORS );		// color-data usage 
 
	HBITMAP pOldBitmap=(HBITMAP)MemDC.SelectObject(hbitmap);

	pDC->BitBlt(0,0,ImgObj.m_Width,ImgObj.m_Height,&MemDC,0,0,SRCCOPY);

	MemDC.SelectObject(pOldBitmap);

	DeleteObject(hbitmap);
	::GlobalUnlock (hSrc);
	::GlobalFree(hSrc);
}


void CImgProcBkView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
	CImgProcBkDoc* pDoc = GetDocument();

	if(pDoc->m_ProcBox.m_bActivate != bActivate)
	{
		//if(pDoc->m_pHistDlg!=NULL && bActivate) pDoc->m_pHistDlg->SetActiveWindow();
		pDoc->m_ProcBox.m_bActivate = bActivate;
	}
	// ü  ٽñ׸.
	((CMainFrame*)AfxGetMainWnd())->m_wndProcMngr.Invalidate();

	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CImgProcBkView::OnSaveAsText()
{
	CImgProcBkDoc* pDoc = GetDocument();

	pDoc->m_ImgObj.SaveAsText();
}


void CImgProcBkView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CImgProcBkDoc* pDoc = GetDocument();

	if(pDoc->GetCurProcess() == ID_AMEBA)
	{
		pDoc->SetCurProcess(NULL);
		pDoc->OnAmeba(point);
		SetClassLong(m_hWnd,sizeof(HWND),NULL);
	}

	CView::OnLButtonDown(nFlags, point);
}
