// CImgProcMngrBar.cpp : implementation file
//

#include "stdafx.h"
#include "ImgProcBk.h"
#include "ImgProcManager.h"
#include "MainFrm.h"

IMPLEMENT_DYNAMIC(CImgProcMngrBar, CDialogBar)

CImgProcMngrBar::CImgProcMngrBar(CWnd* pParent /*=NULL*/)
	//: CDialogBar(CCtrlDlgBar::IDD, pParent)
{
	m_StartPt = CPoint(0,0);
	m_Limit   = CPoint(0,0);
	m_Height  = 120;
}

CImgProcMngrBar::~CImgProcMngrBar(void)
{
}

void CImgProcMngrBar::DoDataExchange(CDataExchange* pDX)
{
	CDialogBar::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CImgProcMngrBar, CDialogBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

// CCtrlBar message handlers

void CImgProcMngrBar::OnUpdateCmdUI(CFrameWnd* pTarget, BOOL bDisableIfNoHndler)
{
	UpdateDialogControls(pTarget, bDisableIfNoHndler);
}


int CImgProcMngrBar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialogBar::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}


void CImgProcMngrBar::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// Do not call CDialogBar::OnPaint() for painting messages
	
	CDC* pDC = ((CWnd*)GetDlgItem(IDC_VIEW))->GetDC();

	CBrush br(RGB(0,155,0));
	CBrush* pOldBr = pDC->SelectObject(&br);
	CFont font;

	font.CreateFont(13,6,0,0,1,0,0,0,HANGUL_CHARSET,OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,0,DEFAULT_PITCH|FF_SWISS,_T("Microsoft Sans Serif"));
	CFont *pOldFont = pDC->SelectObject(&font);

	RecalculatePos(pDC);

	pDC->SelectObject(pOldBr);
	pDC->SelectObject(pOldFont);

	((CWnd*)GetDlgItem(IDC_VIEW))->ReleaseDC(pDC);
}


//  ġ Ѵ.
void CImgProcMngrBar::RecalculatePos(CDC* pDC)
{
	//int DocSubCount[100];	//     (100 )
	for(int i=0;i<MAX_DEPTH_COUNT;i++) GDepthCount[i]=0;

	CString docStr;
	POSITION doctmpPos = AfxGetApp()->GetFirstDocTemplatePosition();
	while(doctmpPos) 
	{
		CDocTemplate* doctmp = AfxGetApp()->GetNextDocTemplate(doctmpPos);
		POSITION docPos = doctmp->GetFirstDocPosition();
		while(doctmp && docPos)
		{
			CImgProcBkDoc* doc = (CImgProcBkDoc*) doctmp->GetNextDoc(docPos);
			// ù°  ġ  Ѵ.
			if(doc->m_vDocPrev.size()==0) StartCalcDocPosRecursive( NULL,doc,pDC);
		}
	}
}


//  ġ Ѵ.
void CImgProcMngrBar::StartCalcDocPosRecursive(CImgProcBkDoc* docPrev,CImgProcBkDoc* doc, CDC* pDC)
{
	if(doc==NULL) return;

	// ׸
	doc->m_ProcBox.RecalcPos();
	doc->m_ProcBox.Draw(pDC,m_StartPt);

	// ġ  ִ ũ
	if(m_Limit.x < doc->m_ProcBox.m_Pos.x) m_Limit.x = doc->m_ProcBox.m_Pos.x;
	if(m_Limit.y < doc->m_ProcBox.m_Pos.y) m_Limit.y = doc->m_ProcBox.m_Pos.y;

	//    ġ
	for(DOCVECTOR::iterator it=doc->m_vDocNext.begin();it!=doc->m_vDocNext.end(); it++) 
	{
		StartCalcDocPosRecursive(doc, *it, pDC);
	}
}


// ִ   Ѵ.
int CImgProcMngrBar::GetDocMaxLevel()
{
	int level = 0;
	
	POSITION doctmpPos = AfxGetApp()->GetFirstDocTemplatePosition();

	while(doctmpPos) 
	{
		CDocTemplate* doctmp = AfxGetApp()->GetNextDocTemplate(doctmpPos);
		POSITION docPos = doctmp->GetFirstDocPosition();
		while(doctmp && docPos)
		{
			CImgProcBkDoc* doc = (CImgProcBkDoc*) doctmp->GetNextDoc(docPos);
			if(doc->m_nDocLevel > level) level = doc->m_nDocLevel;
		}
	}

	return level;
}


/*
      ǥ ׸̴. prev,next  vector Ǿ ִ.
 
              |------------|
  prev1 -----*|            |*------ next 1
              |    DOC     |
  prev2 -----*|            |*------ next 2
              |------------|
*/

//       Ѵ.
void CImgProcMngrBar::EraseDoc(CImgProcBkDoc* doc)
{
	if(doc==NULL) return;
	
	// previous   ش  ã NULLѴ.
	// vector͸   for  Ҷ  ߻ϱ    Ѵ.
	for(unsigned int i=0; i<doc->m_vDocPrev.size(); i++)
	{
		CImgProcBkDoc* prevDoc = doc->m_vDocPrev.at(i);

		for(DOCVECTOR::iterator it = prevDoc->m_vDocNext.begin(); it != prevDoc->m_vDocNext.end(); it++)
		{
			if(*it == doc) 
			{
				prevDoc->m_vDocNext.erase(it);
				i--;		// vector ϳ  ǾǷ ͷ Ѿ ʰ ٽð˻
				break; 
			}
		}
	}
	// next   ش  ã NULLѴ.
	for(i=0; i<doc->m_vDocNext.size(); i++)
	{
		CImgProcBkDoc* nextDoc = doc->m_vDocNext.at(i);

		for(DOCVECTOR::iterator it = nextDoc->m_vDocPrev.begin(); it != nextDoc->m_vDocPrev.end(); it++)
		{
			if(*it == doc) 
			{
				nextDoc->m_vDocPrev.erase(it);
				nextDoc->m_nDocLevel = 0;		//   NULL̹Ƿ  0̴.
				i--;		// vector ϳ  ǾǷ ͷ Ѿ ʰ ٽð˻
				break; 
			}
		}
	}

	Invalidate();
}	


void CImgProcMngrBar::OnLButtonDown(UINT nFlags, CPoint point)
{
	CRect rc;
	GetDlgItem(IDC_VIEW)->GetWindowRect(&rc);
	CPoint pt = point;
	ClientToScreen(&pt);
	if(rc.left < pt.x && pt.x < rc.right && rc.top < pt.y && pt.y < rc.bottom) {
		SetCapture();
		m_PrevMouse = point - m_StartPt;

		// ڽ õǾ°?
		POSITION doctmpPos = AfxGetApp()->GetFirstDocTemplatePosition();
		while(doctmpPos) 
		{
			CDocTemplate* doctmp = AfxGetApp()->GetNextDocTemplate(doctmpPos);
			POSITION docPos = doctmp->GetFirstDocPosition();
			while(doctmp && docPos)
			{
				CImgProcBkDoc* doc = (CImgProcBkDoc*) doctmp->GetNextDoc(docPos);
				//  ڽ ִ ˻Ѵ.
				doc->m_ProcBox.CheckInBox(point - m_StartPt);
			}
		}
	}
	
	CDialogBar::OnLButtonDown(nFlags, point);
}

void CImgProcMngrBar::OnMouseMove(UINT nFlags, CPoint point)
{

	if(GetCapture()) {
		CRect rc;
		GetDlgItem(IDC_VIEW)->GetWindowRect(&rc);

		m_StartPt = point - m_PrevMouse;
		if(m_StartPt.x < -m_Limit.x) m_StartPt.x = -m_Limit.x;
		if(m_StartPt.x > rc.Width()-30) m_StartPt.x = rc.Width()-30;
		if(m_StartPt.y < -m_Limit.y) m_StartPt.y = -m_Limit.y;
		if(m_StartPt.y > rc.Height()-30) m_StartPt.y = rc.Height()-30;
		Invalidate(TRUE);
	}

	CDialogBar::OnMouseMove(nFlags, point);
}

void CImgProcMngrBar::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(GetCapture()) {
		ReleaseCapture();
	}

	CDialogBar::OnLButtonUp(nFlags, point);
}

void CImgProcMngrBar::OnSize(UINT nType, int cx, int cy)
{
	CDialogBar::OnSize(nType, cx, cy);

	
	CRect rc;
	GetClientRect(&rc);
	CRect rc2;
	CWnd *pWnd = GetDlgItem(IDC_VIEW);
	if(pWnd!=NULL) 
	{
		pWnd->GetClientRect(&rc2);
		//pWnd->ClientToScreen(&rc2);
		if (IsFloating())
			pWnd->MoveWindow(12,0,rc2.right,m_Height*2);
		else 
			pWnd->MoveWindow(12,0,rc.right,m_Height+2);
	}
}

CSize CImgProcMngrBar::CalcDynamicLayout(int nLength, DWORD dwMode)
{
	if (IsFloating())
	{
		CRect rc;
		GetDlgItem(IDC_VIEW)->GetClientRect(&rc);
		rc.InflateRect(12,12);
		return CSize(rc.Width()-12,m_Height*2);
	}
	else 
	{
		CRect rc;
		GetDlgItem(IDC_VIEW)->GetClientRect(&rc);
		//rc.InflateRect(12,12);
		CRect rc2;
		GetParent()->GetClientRect(&rc2);
		return CSize(rc2.Width(),m_Height);
	}
}