// TemplateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImgProcBk.h"
#include "MainFrm.h"
#include "ChildFrm.h"

#include "ImgProcBkDoc.h"
#include "ImgProcBkView.h"
#include "TemplateDlg.h"

#include <math.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTemplateDlg dialog


CTemplateDlg::CTemplateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTemplateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemplateDlg)
	m_SelectedWindow = -1;
	//}}AFX_DATA_INIT
	Init();
}

CTemplateDlg::CTemplateDlg(CImageObj* imgOrg,CImageObj* imgDst,CWnd* pParent /*=NULL*/)
	: CDialog(CTemplateDlg::IDD, pParent)
{
	Init();

	//   
	m_pImgSrc = imgOrg; 
	m_pImgDst = imgDst;
	//m_pImgDst->m_pDlg = this;	//  ̾α ͸ صд.

	//  view ͸ ´.
	CMainFrame *pFrame = (CMainFrame*)AfxGetMainWnd() ;
	CChildFrame *pChild = (CChildFrame*)pFrame->GetActiveFrame();
	m_pView = (CView*)pChild->GetActiveView();

}


void CTemplateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemplateDlg)
	DDX_Text(pDX, IDC_D11, m_D11);
	DDX_Text(pDX, IDC_D12, m_D12);
	DDX_Text(pDX, IDC_D13, m_D13);
	DDX_Text(pDX, IDC_D21, m_D21);
	DDX_Text(pDX, IDC_D22, m_D22);
	DDX_Text(pDX, IDC_D23, m_D23);
	DDX_Text(pDX, IDC_D31, m_D31);
	DDX_Text(pDX, IDC_D32, m_D32);
	DDX_Text(pDX, IDC_D33, m_D33);
	DDX_Text(pDX, IDC_S11, m_S11);
	DDX_Text(pDX, IDC_S12, m_S12);
	DDX_Text(pDX, IDC_S13, m_S13);
	DDX_Text(pDX, IDC_S21, m_S21);
	DDX_Text(pDX, IDC_S22, m_S22);
	DDX_Text(pDX, IDC_S23, m_S23);
	DDX_Text(pDX, IDC_S31, m_S31);
	DDX_Text(pDX, IDC_S32, m_S32);
	DDX_Text(pDX, IDC_S33, m_S33);
	DDX_Radio(pDX, IDC_SOBEL, m_SelectedWindow);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTemplateDlg, CDialog)
	//{{AFX_MSG_MAP(CTemplateDlg)
	ON_BN_CLICKED(IDC_SOBEL, OnSobel)
	ON_BN_CLICKED(IDC_PREWITT, OnPrewitt)
	ON_BN_CLICKED(IDC_ROBERTS, OnRoberts)
	ON_BN_CLICKED(IDC_LAPLACIAN, OnLaplacian)
	ON_BN_CLICKED(IDC_ZEROCROSS, OnZeroCross)
	ON_BN_CLICKED(IDC_GAUSSIAN, OnGaussian)
	ON_BN_CLICKED(IDC_DOUBLE_WINDOW, OnDoubleWindow)
	ON_BN_CLICKED(IDC_SINGLE_WINDOW, OnSingleWindow)
	ON_BN_CLICKED(IDC_PROCESS, OnBnClickedProcess)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTemplateDlg message handlers


void CTemplateDlg::Init()
{
	m_pView = NULL;
	m_pImgSrc = NULL;
	m_pImgDst = NULL;
}

BOOL CTemplateDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	OnSobel();
	m_SelectedWindow=0;
	UpdateData(FALSE);

	//((CButton*)GetDlgItem(IDC_SOBEL))->SetCheck(TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTemplateDlg::GetLookUp(int (*valSingle)[9],int (*valDouble)[9])
{
	UpdateData(TRUE);

	(*valSingle)[0] = m_D11;
	(*valSingle)[1] = m_D12;
	(*valSingle)[2] = m_D13;
	(*valSingle)[3] = m_D21;
	(*valSingle)[4] = m_D22;
	(*valSingle)[5] = m_D23;
	(*valSingle)[6] = m_D31;
	(*valSingle)[7] = m_D32;
	(*valSingle)[8] = m_D33;

	(*valDouble)[0] = m_S11;
	(*valDouble)[1] = m_S12;
	(*valDouble)[2] = m_S13;
	(*valDouble)[3] = m_S21;
	(*valDouble)[4] = m_S22;
	(*valDouble)[5] = m_S23;
	(*valDouble)[6] = m_S31;
	(*valDouble)[7] = m_S32;
	(*valDouble)[8] = m_S33;
}

void CTemplateDlg::SetLookUp(int (*valSingle)[9],int (*valDouble)[9])
{
	UpdateData(TRUE);

	m_D11 = (*valSingle)[0];
	m_D12 = (*valSingle)[1];
	m_D13 = (*valSingle)[2];
	m_D21 = (*valSingle)[3];
	m_D22 = (*valSingle)[4];
	m_D23 = (*valSingle)[5];
	m_D31 = (*valSingle)[6];
	m_D32 = (*valSingle)[7];
	m_D33 = (*valSingle)[8];

	m_S11 = (*valDouble)[0];
	m_S12 = (*valDouble)[1];
	m_S13 = (*valDouble)[2];
	m_S21 = (*valDouble)[3];
	m_S22 = (*valDouble)[4];
	m_S23 = (*valDouble)[5];
	m_S31 = (*valDouble)[6];
	m_S32 = (*valDouble)[7];
	m_S33 = (*valDouble)[8];

	UpdateData(FALSE);
}

void CTemplateDlg::EnableUpTable(BOOL mode)
{
	((CEdit*)GetDlgItem(IDC_D11))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D12))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D13))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D21))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D22))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D23))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D31))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D32))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_D33))->EnableWindow(mode);
}

void CTemplateDlg::EnableDownTable(BOOL mode)
{
	((CEdit*)GetDlgItem(IDC_S11))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S12))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S13))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S21))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S22))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S23))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S31))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S32))->EnableWindow(mode);
	((CEdit*)GetDlgItem(IDC_S33))->EnableWindow(mode);
}

void CTemplateDlg::OnSobel() 
{
	int Tx[9]={-1,0,1,-2,0,2,-1,0,1};
	int Ty[9]={1,2,1,0,0,0,-1,-2,-1};

	SetLookUp(&Tx,&Ty);
	EnableUpTable(FALSE);
	EnableDownTable(FALSE);
}

void CTemplateDlg::OnPrewitt() 
{
	int Tx[9]={-1,0,1,-1,0,1,-1,0,1};
	int Ty[9]={1,1,1,0,0,0,-1,-1,-1};
	
	SetLookUp(&Tx,&Ty);
	EnableUpTable(FALSE);
	EnableDownTable(FALSE);
}

void CTemplateDlg::OnRoberts() 
{
	int Tx[9]={0,0,-1,0,1,0,0,0,0};
	int Ty[9]={-1,0,0,0,1,0,0,0,0};

	SetLookUp(&Tx,&Ty);
	EnableUpTable(FALSE);
	EnableDownTable(FALSE);
}


void CTemplateDlg::OnLaplacian() 
{
	int Tx[9]={0,0,0,0,0,0,0,0,0};
	int Ty[9]={-1,-1,-1,-1,8,-1,-1,-1,-1};

	SetLookUp(&Tx,&Ty);
	EnableUpTable(FALSE);
	EnableDownTable(FALSE);
}

void CTemplateDlg::OnGaussian() 
{
	// TODO: Add your control notification handler code here
	int Tx[9]={0,0,0,0,0,0,0,0,0};
	int Ty[9]={1,2,1,2,4,2,1,2,1};

	SetLookUp(&Tx,&Ty);
	EnableUpTable(FALSE);
	EnableDownTable(FALSE);
}


void CTemplateDlg::OnZeroCross() 
{
	int Tx[9]={0,0,0,0,0,0,0,0,0};
	int Ty[9]={1,1,1,1,4,1,1,1,1};

	SetLookUp(&Tx,&Ty);
	EnableUpTable(FALSE);
	EnableDownTable(FALSE);
}


void CTemplateDlg::OnDoubleWindow() 
{
//	int Tx[9]={1,1,1,1,1,1,1,1,1};
//	int Ty[9]={1,1,1,1,1,1,1,1,1};

//	SetLookUp(&Tx,&Ty);
	EnableUpTable(TRUE);
	EnableDownTable(TRUE);
}

void CTemplateDlg::OnSingleWindow() 
{
//	int Tx[9]={0,0,0,0,0,0,0,0,0};
//	int Ty[9]={1,1,1,1,1,1,1,1,1};

//	SetLookUp(&Tx,&Ty);
	EnableUpTable(FALSE);
	EnableDownTable(TRUE);
}



void CTemplateDlg::OnBnClickedProcess()
{
	int Tx[9];
	int Ty[9];

	GetLookUp(&Tx,&Ty);


	switch(m_SelectedWindow)
	{
	case 0: ((CImgProcBkDoc*)m_pView->GetDocument())->m_ImgProc.CvtEdgeSobel(*m_pImgSrc, *m_pImgDst); break;
	case 1: ((CImgProcBkDoc*)m_pView->GetDocument())->m_ImgProc.CvtEdgePrewitte(*m_pImgSrc, *m_pImgDst); break;
	case 2: ((CImgProcBkDoc*)m_pView->GetDocument())->m_ImgProc.CvtEdgeRobert(*m_pImgSrc, *m_pImgDst); break;
	case 3: ((CImgProcBkDoc*)m_pView->GetDocument())->m_ImgProc.CvtEdgeLoG(*m_pImgSrc, *m_pImgDst,3); break;
	case 4: ((CImgProcBkDoc*)m_pView->GetDocument())->m_ImgProc.CvtGaussianSmoothing3(*m_pImgSrc, *m_pImgDst); break;
	case 5: 
	case 6:
	default: ((CImgProcBkDoc*)m_pView->GetDocument())->m_ImgProc.ApplyDblMask(*m_pImgSrc, *m_pImgDst, Tx,Ty,3,1.0f,0.0f);

	}

	m_pView->Invalidate(FALSE);
}

