// UserBinDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImgProcBk.h"
#include "UserBinDlg.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "ImgProcBkDoc.h"
#include "ImgProcBkView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUserBinDlg dialog


CUserBinDlg::CUserBinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserBinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserBinDlg)
	m_sThreshold = _T("");
	//}}AFX_DATA_INIT
	m_pView = NULL;
	m_pImgSrc = NULL;
	m_pImgDst = NULL;
}

CUserBinDlg::CUserBinDlg(CImageObj* imgOrg,CImageObj* imgRst,CWnd* pParent /*=NULL*/)
	: CDialog(CUserBinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserBinDlg)
	m_sThreshold = _T("");
	//}}AFX_DATA_INIT

	m_pImgSrc = imgOrg;
	m_pImgDst = imgRst;

	//  view ͸ ´.
	CMainFrame *pFrame = (CMainFrame*)AfxGetMainWnd() ;
	CChildFrame *pChild = (CChildFrame*)pFrame->GetActiveFrame();
	m_pView = (CView*)pChild->GetActiveView();
}

void CUserBinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserBinDlg)
	DDX_Control(pDX, IDC_FRAME, m_Frame);
	DDX_Control(pDX, IDC_SLIDER, m_ThresholdBar);
	DDX_Text(pDX, IDC_THRESHOLD, m_sThreshold);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserBinDlg, CDialog)
	//{{AFX_MSG_MAP(CUserBinDlg)
	ON_WM_HSCROLL()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUserBinDlg message handlers

BOOL CUserBinDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//set manual
	m_Threshold=128;
	m_sThreshold.Format(_T("%d"),m_Threshold);

	//set edit text box data
	m_ThresholdBar.SetRange(0,255);
	m_ThresholdBar.SetPos(m_Threshold);
	m_ThresholdBar.SetTicFreq(10);

	UpdateData(FALSE);

	CalcHistogram();

	ApplyLut();

	Invalidate(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CUserBinDlg::OnPaint() 
{
	// TODO: Add your message handler code here
	CPaintDC dc(this); // device context for painting

	RECT rcRange;
	CBrush cBrush,* OldBrush;
	cBrush.CreateSolidBrush(RGB(255,255,255));
	CDC *pDC=m_Frame.GetDC();

	m_Frame.GetClientRect(&rcRange);
	OldBrush=pDC->SelectObject(&cBrush);
	pDC->FillRect(&rcRange,&cBrush);		
	pDC->SelectObject(OldBrush);
	cBrush.DeleteObject();

	// ȭ 
	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetWindowExt(255,102);
	pDC->SetViewportExt(rcRange.right-rcRange.left, -rcRange.bottom+rcRange.top);
	pDC->SetViewportOrg(rcRange.left,rcRange.bottom-2);

	float mmax=m_Hist[0];
	for(int i=0;i<256;i++) if(m_Hist[i]>mmax) mmax=m_Hist[i];

	// ׷ ׸
	//COLORREF color[4] = { RGB(0,0,0), RGB(255,0,0), RGB(0,180,0), RGB(0,0,255) };
	CPen pen(PS_SOLID,1,RGB(0,0,0));
	CPen *pOldPen = pDC->SelectObject(&pen);

	pDC->MoveTo(0,(int)m_Hist[0]); 
	for(i=0;i<256;i++) pDC->LineTo(i,(int)(m_Hist[i]*100/mmax));
	
	pDC->SelectObject(pOldPen);

	// ׸
	pDC->MoveTo(m_Threshold,1);
	pDC->LineTo(m_Threshold,99);

	m_Frame.ReleaseDC(pDC);
	
	//   
	if(m_pView!=NULL) m_pView->Invalidate(FALSE);

	// Do not call CDialog::OnPaint() for painting messages
}


void CUserBinDlg::CalcHistogram()
{
	for(int i=0;i<256;i++) m_Hist[i]=0;

	if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
	{
		for(long y=0;y<m_pImgSrc->m_Height;y++)
			for(long x=0;x<m_pImgSrc->m_Width;x++)
				m_Hist[ (*m_pImgSrc)[y][x] ]++;
	}
	/*
	else 
	{
		for(long y=0;y<m_pImgSrc->m_Height;y++)
			for(long x=0;x<m_pImgSrc->m_Width;x++)
				m_Hist[ (*m_pImgSrc)[x*3+m_Color-1][y] ]++;
	}
	*/
	//m_Scale HistogramBin data
	for(i=0;i<256;i++) m_Hist[i] /= (m_pImgSrc->m_Height * m_pImgSrc->m_Width);

}


void CUserBinDlg::ApplyLut() 
{
	if(m_pImgSrc==NULL || m_pImgDst==NULL) return;

	int i;
	BYTE Lut[256];

	for(i=0;i<m_Threshold;i++) Lut[i]=0;
	for(i=m_Threshold;i<256;i++) Lut[i]=255;

	if(m_pImgSrc->m_ColorMode==IDM_GRAY) 
	{
		for(long y=0;y<m_pImgSrc->m_Height;y++)
			for(long x=0;x<m_pImgSrc->m_Width;x++)
				(*m_pImgDst)[y][x] = Lut[ (*m_pImgSrc)[y][x] ];
	}
	/*
	else 
	{
		for(long y=0;y<m_pImgSrc->m_Height;y++)
			for(long x=0;x<m_pImgSrc->m_Width;x++)
				(*m_pImgDst)[x*3+m_Color-1][y] = Lut[ (*m_pImgSrc)[x*3+m_Color-1][y] ];
	}
	*/

	// Ӱ谪 ǥ
	((CImgProcBkDoc*)(m_pView->GetDocument()))->SetWindowStatus( _T(" ȭ ")+m_sThreshold );
}


void CUserBinDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateData(TRUE);

	m_Threshold=m_ThresholdBar.GetPos();
	m_sThreshold.Format(_T("%d"),m_Threshold);

	UpdateData(FALSE);

	//   
	ApplyLut();

	Invalidate(FALSE);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


